package com.codes_roots.imakeapp.create_vendor_driver_account.create_driver_account_fragment

import android.os.Bundle
import android.view.LayoutInflater
import android.view.View
import android.view.ViewGroup
import android.widget.ProgressBar
import android.widget.Toast
import androidx.databinding.DataBindingUtil
import androidx.fragment.app.Fragment
import androidx.fragment.app.viewModels
import androidx.lifecycle.Observer
import androidx.lifecycle.ViewModelProvider
import com.codes_roots.imakeapp.R
import com.codes_roots.imakeapp.create_vendor_driver_account.viewmodel.CreateDriverAccViewModel
import com.codes_roots.imakeapp.databinding.CreateDriverAccFragmentBinding
import com.codes_roots.imakeapp.helper.*
import kotlinx.android.synthetic.main.register_activity.*
import javax.inject.Inject


class CreateDriverAccountFragment : Fragment() {

    @Inject
    lateinit var viewModelFactory: ViewModelProvider.Factory

    val viewModel by viewModels<CreateDriverAccViewModel> { viewModelFactory }

    @Inject
    lateinit var Pref: PreferenceHelper

    lateinit var view: CreateDriverAccFragmentBinding

    val progressBar: ProgressBar? = null


    override fun onCreate(savedInstanceState: Bundle?) {
        super.onCreate(savedInstanceState)
        BaseApplication.appComponent.inject(this)
    }

    override fun onCreateView(
        inflater: LayoutInflater,
        container: ViewGroup?,
        savedInstanceState: Bundle?
    ): View {

        view = DataBindingUtil.inflate(
            inflater,
            R.layout.create_driver_acc_fragment, container, false
        )

        setImageResource(view.logo, Pref.appLogo)
        view.next.setOnClickListener {
            if (!ValidationCreateDriverAcc().submitForm(view, requireContext(), this)) {
                ValidationCreateDriverAcc().invalidForm(view, requireContext())
            } else {
                ValidationCreateDriverAcc().submitForm(view, requireContext(), this)
                it.isEnabled =false
                showDefaultDialog(requireActivity(),requireActivity()) {
                 //   Toast.makeText(requireContext(), "Hello!!!", Toast.LENGTH_SHORT).show()
                }
            }
        }
//        view.folderBackId.setOnClickListener {
//            val gallery = Intent(Intent.ACTION_PICK, MediaStore.Images.Media.INTERNAL_CONTENT_URI)
//            startActivityForResult(gallery, pickImage)
//        }
//
//        view.cameraBackId.setOnClickListener {
//            addimage()
//        }
        viewModel.processVisibility.observe(requireActivity()) {
            //  view.progress.isVisible = it
        }

        viewModel.authLD?.observe(requireActivity(), Observer {
            viewModel.processVisibility.value = true
            if (it == null) {
                Toast.makeText(context, "try again", Toast.LENGTH_SHORT).show()
                viewModel.processVisibility.value = false
            } else {
                viewModel.processVisibility.value = true


            }
        })

        viewModel.errorMessage.observe(requireActivity()) {
            Toast.makeText(context, it, Toast.LENGTH_SHORT).show()
        }

        return view.root
    }



//    override fun onActivityResult(requestCode: Int, resultCode: Int, data: Intent?) {
//        super.onActivityResult(requestCode, resultCode, data)
//        if (resultCode == RESULT_OK && requestCode == pickImage) {
//            imageUri = data?.data
//            view.idBackImg.setImageURI(imageUri)
//        }
//
//        if (resultCode == RESULT_OK && requestCode == REQUEST_CODE) {
//            imageUri = data?.data
//            view.idBackImg.setImageURI(imageUri)
//        }
//    }

//    fun addimage() {
//        ImagePicker.with(this)
//            .compress(1024)         //Final image size will be less than 1 MB(Optional)
//            .maxResultSize(1080, 1080)
//            .crop()    //Final image resolution will be less than 1080 x 1080(Optional)
//            .createIntent { intent ->
//                startForProfileImageResult.launch(intent)
//            }
//    }


//    private fun prepareFilePart(name: String, fileUri: Uri): MultipartBody.Part {
//        var file: File? = null
//        if (Build.VERSION.SDK_INT >= Build.VERSION_CODES.KITKAT) {
//            file = FileUtils.getFile(requireContext(), fileUri)
//        }
//        val requestFile = RequestBody.create(
//            MediaType.parse("image"),
//            file!!
//        )
//
//
//        return MultipartBody.Part.createFormData(name, file.name, requestFile)
//    }
//
//    private val startForProfileImageResult =
//        registerForActivityResult(ActivityResultContracts.StartActivityForResult()) { result: ActivityResult ->
//            val resultCode = result.resultCode
//            val data = result.data
//
//            if (resultCode == Activity.RESULT_OK) {
//                //Image Uri will not be null for RESULT_OK
//                fileUri = data?.data!!
//
//                //  mProfileUri = fileUri
//                view.idBackImg.setImageURI(fileUri)
//
//            } else if (resultCode == ImagePicker.RESULT_ERROR) {
//                Toast.makeText(requireContext(), ImagePicker.getError(data), Toast.LENGTH_SHORT)
//                    .show()
//            } else {
//                Toast.makeText(requireContext(), "Task Cancelled", Toast.LENGTH_SHORT).show()
//            }
//        }

}