package com.codes_roots.imakeapp.create_vendor_driver_account.create_driver_account_fragment

import android.content.Context
import android.util.Patterns
import com.codes_roots.imakeapp.R
import com.codes_roots.imakeapp.databinding.CreateDriverAccFragmentBinding
import com.satafood.core.entities.add_driver_request.DriverRequestModel

class ValidationCreateDriverAcc {

    //
    fun nameFocusListener(context: Context, binding: CreateDriverAccFragmentBinding) {
        binding.username.setOnFocusChangeListener { _, focused ->
            if (!focused) {
                binding.usernameTextField.helperText = validName(context, binding)
            }
        }
    }

    fun roleFocusListener(context: Context, binding: CreateDriverAccFragmentBinding) {
        binding.cityName.setOnFocusChangeListener { _, focused ->
            if (!focused) {
                binding.cityField.helperText = validRole(context, binding)
            }
        }
    }
    fun qualificationFocusListener(context: Context, binding: CreateDriverAccFragmentBinding) {
        binding.qualification.setOnFocusChangeListener { _, focused ->
            if (!focused) {
                binding.qualificationTextField.helperText = qualificationRole(context, binding)
            }
        }
    }

    fun addressFocusListener(context: Context, binding: CreateDriverAccFragmentBinding) {
        binding.address.setOnFocusChangeListener { _, focused ->
            if (!focused) {
                binding.addressField.helperText = validAddress(context, binding)
            }
        }
    }

    fun phoneFocusListener(context: Context, binding: CreateDriverAccFragmentBinding) {
        binding.mobile.setOnFocusChangeListener { _, focused ->
            if (!focused) {

                binding.phonenimerfield.helperText = validPhone(context, binding)

            }
        }
    }

    fun idFocusListener(context: Context, binding: CreateDriverAccFragmentBinding) {
        binding.idNumber.setOnFocusChangeListener { _, focused ->
            if (!focused) {
                binding.idNumberField.helperText = validID(context, binding)
            }
        }
    }
    fun emailfilledFocusListener(context: Context, binding: CreateDriverAccFragmentBinding) {
        binding.email.setOnFocusChangeListener { _, focused ->
            if (!focused) {
                binding.emailfilledTextField.helperText = validEmail(context, binding)
            }
        }
    }


    fun addRequest(view: CreateDriverAccFragmentBinding, frag: CreateDriverAccountFragment) {
        val loginInfo = DriverRequestModel(
            name = view.username.text.toString(),
            phone = view.mobile.text.toString(),
            email = view.email.text.toString(),
            role = view.cityName.text.toString(),
            address = view.address.text.toString(),
         //   id = view.address.text.toString(),
        )
        frag.viewModel.driverRequestModel(loginInfo)
    }


    private fun validPhone(context: Context, binding: CreateDriverAccFragmentBinding): String? {
        val phoneText = binding.mobile.text.toString()

        if (!phoneText.matches(".*[0-9].*".toRegex())) {
            return context.getString(R.string.validMobNum3)
        }
        if ((phoneText.length != 11)) {
            return context.getString(R.string.validMobNum2)
        }

        if (!phoneText.startsWith("011")) {
            if (!phoneText.startsWith("010")) {

                if (!phoneText.startsWith("012")) {
                    if (!phoneText.startsWith("015")) {

                        return context.getString(R.string.validMobNum)
                    }
                }
            }

        }

        return null
    }

    private fun validID(context: Context, binding: CreateDriverAccFragmentBinding): String? {
        val idText = binding.idNumber.text.toString()

        if (!idText.matches(".*[0-9].*".toRegex())) {
            return context.getString(R.string.validMobNum3)
        }
        if ((idText.length != 16)) {
            return context.getString(R.string.validMobNum3)
        }



        return null
    }
    fun validEmail(context: Context, binding: CreateDriverAccFragmentBinding): String? {
        val emailText = binding.email.text.toString()
        if (!Patterns.EMAIL_ADDRESS.matcher(emailText).matches()) {
            return context.getString(R.string.invalidEmail)
        }
        return null
    }


    private fun validName(context: Context, binding: CreateDriverAccFragmentBinding): String? {
        val userName = binding.username.text.toString()
        if (userName.length < 4) {
            return context.getString(R.string.validusername)
        }

        return null
    }

    private fun validAddress(context: Context, binding: CreateDriverAccFragmentBinding): String? {

        val address = binding.address.text.toString()
        if (address.length < 8) {
            return context.getString(R.string.validuseraddress)
        }

        return null
    }

    private fun validRole(context: Context, binding: CreateDriverAccFragmentBinding): String? {

        val address = binding.cityName.text.toString()
        if (address.length < 2) {
            return context.getString(R.string.cityField)
        }

        return null
    }
    private fun qualificationRole(context: Context, binding: CreateDriverAccFragmentBinding): String? {
        val address = binding.qualification.text.toString()
        if (address.isEmpty()) {

            return context.getString(R.string.validQualification)

        }

        return null
    }

    fun submitForm(
        binding: CreateDriverAccFragmentBinding,
        context: Context,
        frag: CreateDriverAccountFragment,
    ): Boolean {
        binding.phonenimerfield.helperText = validPhone(context, binding)
        binding.usernameTextField.helperText = validName(context, binding)
        binding.cityField.helperText = validRole(context, binding)
        binding.qualificationTextField.helperText = qualificationRole(context, binding)
        binding.addressField.helperText = validAddress(context, binding)
        binding.emailfilledTextField.helperText = validAddress(context, binding)
        binding.idNumberField.helperText = validID(context, binding)

        val idNumberField = binding.idNumberField.helperText == null
        val emailNumberField = binding.idNumberField.helperText == null
        val qualificationTextField = binding.qualificationTextField.helperText == null
        val validPhone = binding.phonenimerfield.helperText == null
        val validUsername = binding.usernameTextField.helperText == null
        val role = binding.cityField.helperText == null

        return if (idNumberField && validPhone && validUsername && role && emailNumberField&&qualificationTextField) {
            addRequest(binding, frag)
            true
        } else
            false


    }


    fun invalidForm(binding: CreateDriverAccFragmentBinding, context: Context) {

        idFocusListener(context, binding)
        nameFocusListener(context, binding)
        phoneFocusListener(context, binding)
        roleFocusListener(context, binding)
        addressFocusListener(context, binding)
        emailfilledFocusListener(context, binding)
        qualificationFocusListener(context, binding)

    }
}