package com.codes_roots.imakeapp.create_vendor_driver_account.create_vendor_account_fragment

import android.content.Context
import android.util.Patterns
import com.codes_roots.imakeapp.R
import com.codes_roots.imakeapp.databinding.CreateVendorAccFragmentBinding
import com.satafood.core.entities.add_driver_request.DriverRequestModel

class ValidationCreateVendorAcc {


    fun nameFocusListener(context: Context, binding: CreateVendorAccFragmentBinding) {
        binding.username.setOnFocusChangeListener { _, focused ->
            if (!focused) {
                binding.usernameTextField.helperText = validName(context, binding)
            }
        }
    }

    fun vendorNameFocusListener(context: Context, binding: CreateVendorAccFragmentBinding) {
        binding.brandName.setOnFocusChangeListener { _, focused ->
            if (!focused) {
                binding.brandNameTextField.helperText = validVendorName(context, binding)
            }
        }
    }

    fun roleFocusListener(context: Context, binding: CreateVendorAccFragmentBinding) {
        binding.roleName.setOnFocusChangeListener { _, focused ->
            if (!focused) {
                binding.roleField.helperText = validRole(context, binding)
            }
        }
    }

    fun addressFocusListener(context: Context, binding: CreateVendorAccFragmentBinding) {
        binding.address.setOnFocusChangeListener { _, focused ->
            if (!focused) {
                binding.addressField.helperText = validAddress(context, binding)
            }
        }
    }

    fun phoneFocusListener(context: Context, binding: CreateVendorAccFragmentBinding) {
        binding.mobile.setOnFocusChangeListener { _, focused ->
            if (!focused) {

                binding.phonenimerfield.helperText = validPhone(context, binding)

            }
        }
    }

    fun idFocusListener(context: Context, binding: CreateVendorAccFragmentBinding) {
        binding.idNumber.setOnFocusChangeListener { _, focused ->
            if (!focused) {
                binding.idNumberField.helperText = validID(context, binding)
            }
        }
    }
    fun emailfilledFocusListener(context: Context, binding: CreateVendorAccFragmentBinding) {
        binding.email.setOnFocusChangeListener { _, focused ->
            if (!focused) {
                binding.emailfilledTextField.helperText = validEmail(context, binding)
            }
        }
    }

    fun numberOfBranchFocusListener(context: Context, binding: CreateVendorAccFragmentBinding) {

        binding.numberOfBranches.setOnFocusChangeListener { _, focused ->

            if (!focused) {

                binding.idNumberField.helperText = validNumberOfBranches(context, binding)

            }
        }
    }


    fun addRequest(view: CreateVendorAccFragmentBinding, frag: CreateVendorAccountFragment) {
        val loginInfo = DriverRequestModel(
            name = view.username.text.toString(),
            phone = view.mobile.text.toString(),
            email = view.email.text.toString(),
            brand_name = view.brandName.text.toString(),
            role = view.roleName.text.toString(),
            address = view.address.text.toString(),
            branches = view.numberOfBranches.text.toString().toInt(),
            type = 1
        )
        frag.viewModel.driverRequestModel(loginInfo)
    }



    private fun validPhone(context: Context, binding: CreateVendorAccFragmentBinding): String? {
        val phoneText = binding.mobile.text.toString()

        if (!phoneText.matches(".*[0-9].*".toRegex())) {
            return context.getString(R.string.validMobNum2)
        }
        if ((phoneText.length != 11)) {
            return context.getString(R.string.validMobNum2)
        }

        if (!phoneText.startsWith("011")) {
            if (!phoneText.startsWith("010")) {

                if (!phoneText.startsWith("012")) {
                    if (!phoneText.startsWith("015")) {

                        return context.getString(R.string.validMobNum)
                    }
                }
            }

        }

        return null
    }

    private fun validID(context: Context, binding: CreateVendorAccFragmentBinding): String? {
        val idText = binding.idNumber.text.toString()

        if (!idText.matches(".*[0-9].*".toRegex())) {
            return context.getString(R.string.validMobNum3)
        }
        if ((idText.length != 16)) {
            return context.getString(R.string.validMobNum3)
        }



        return null
    }
    fun validEmail(context: Context, binding: CreateVendorAccFragmentBinding): String? {
        val emailText = binding.email.text.toString()
        if (!Patterns.EMAIL_ADDRESS.matcher(emailText).matches()) {
            return context.getString(R.string.invalidEmail)
        }
        return null
    }

    private fun validNumberOfBranches(context: Context, binding: CreateVendorAccFragmentBinding): String? {
        val numberOfBranches = binding.numberOfBranches.text.toString()

        if ((numberOfBranches.isEmpty())) {
            return context.getString(R.string.validNumberOfBranch)
        }



        return null
    }

    private fun validName(context: Context, binding: CreateVendorAccFragmentBinding): String? {
        val userName = binding.username.text.toString()
        if (userName.length < 2) {
            return context.getString(R.string.validusername)
        }

        return null
    }
    private fun validVendorName(context: Context, binding: CreateVendorAccFragmentBinding): String? {
        val userName = binding.brandName.text.toString()
        if (userName.length < 4) {
            return context.getString(R.string.validbrandname)
        }

        return null
    }

    private fun validAddress(context: Context, binding: CreateVendorAccFragmentBinding): String? {

        val address = binding.address.text.toString()
        if (address.length < 8) {
            return context.getString(R.string.validuseraddress)
        }

        return null
    }

    private fun validRole(context: Context, binding: CreateVendorAccFragmentBinding): String? {

        val address = binding.roleName.text.toString()
        if (address.length < 2) {
            return context.getString(R.string.validRole)
        }

        return null
    }

    fun submitForm(
        binding: CreateVendorAccFragmentBinding,
        context: Context,
        frag: CreateVendorAccountFragment
    ) : Boolean {
        binding.phonenimerfield.helperText = validPhone(context, binding)
        binding.usernameTextField.helperText = validName(context, binding)
        binding.roleField.helperText = validRole(context, binding)
        binding.addressField.helperText = validAddress(context, binding)
        binding.numberOfBranchesTextField.helperText = validNumberOfBranches(context, binding)
        binding.emailfilledTextField.helperText = validEmail(context, binding)

        val idNumberField = binding.idNumberField.helperText == null
        val validPhone = binding.phonenimerfield.helperText == null
        val validUsername = binding.usernameTextField.helperText == null
        val numOfBranches = binding.numberOfBranchesTextField.helperText == null
        val role = binding.roleField.helperText == null
        val email = binding.emailfilledTextField.helperText == null

        return if (idNumberField && validPhone && validUsername && role && email&& numOfBranches) {
            addRequest(binding, frag)
            true
        } else
            false


    }


    fun invalidForm(binding: CreateVendorAccFragmentBinding, context: Context) {
        idFocusListener(context, binding)
        nameFocusListener(context, binding)
        phoneFocusListener(context, binding)
        roleFocusListener(context, binding)
        addressFocusListener(context, binding)
        numberOfBranchFocusListener(context, binding)
        emailfilledFocusListener(context, binding)

    }
}