package com.codes_roots.imakeapp.datalayer


import com.satafood.core.entities.add_driver_request.DriverRequestModel
import com.satafood.core.entities.addresses.UserAddressesItem
import com.satafood.core.entities.branches_locations.Branch
import com.satafood.core.entities.branches_locations.BranchesLocation
import com.satafood.core.entities.cart.CartConfigurations
import com.satafood.core.entities.favourite.FavouriteModelItem
import com.satafood.core.entities.gallery.BranchesGalleryModelItem
import com.satafood.core.entities.gallery.GalleryModel
import com.satafood.core.entities.google.Google
import com.satafood.core.entities.google.GoogleModel
import com.satafood.core.entities.google.SliderModel
import com.satafood.core.entities.homepage.CitiesModelItem
import com.satafood.core.entities.homepage.Cuisines
import com.satafood.core.entities.homepage.SectionsModelItem
import com.satafood.core.entities.homepage.sliders.SliderHomePageModelItem
import com.satafood.core.entities.login.ForgetPasswordModel
import com.satafood.core.entities.login.LoginModel
import com.satafood.core.entities.login.User
import com.satafood.core.entities.main.Token
import com.satafood.core.entities.mainpage.HomePageModel
import com.satafood.core.entities.myorders.MyOrderModelItem
import com.satafood.core.entities.myorders.OrderStatus
import com.satafood.core.entities.notification.NotificationModelItem
import com.satafood.core.entities.ordermodel.OrderModel
import com.satafood.core.entities.paymentways.PaymentWaysItem
import com.satafood.core.entities.paymentways.VoucherModel
import com.satafood.core.entities.paymob.MakePaymentOrderIntegration
import com.satafood.core.entities.paymob.PayMobToken
import com.satafood.core.entities.paymob.Payment
import com.satafood.core.entities.profile.ProfileModel
import com.satafood.core.entities.rate.RateModel
import com.satafood.core.entities.restaurantdetails.MenuCategoriesItem
import com.satafood.core.entities.restaurantdetails.StoreDetailsModel
import com.satafood.core.entities.restaurantslist.BranchesModelListItem
import com.satafood.core.entities.reviews.ReviewsModel
import com.satafood.core.entities.search_model.SearchModel
import com.satafood.core.entities.seemore_section.CategoryBannerItem
import com.satafood.core.entities.seemore_section.VendorOffersDataItem
import com.satafood.core.entities.social_media.SocialMediaModelItem
import com.satafood.core.entities.static_pages.StaticPagesItem
import com.satafood.core.entities.support.Complaints
import com.satafood.core.entities.support.QuestionCategoryItem
import com.satafood.core.entities.support.questionsItem
import com.satafood.core.entities.userpoints.CountPointsModel
import com.satafood.core.entities.userpoints.UserPointsModel
import com.satafood.core.entities.vendor_attributes.VendorAttributesModelItem
import com.satafood.core.entities.wallet.WalletCredit
import com.satafood.core.entities.wallet.WalletModel
import com.satafood.core.entities.walletdetails.WalletDetailsModelItem
import okhttp3.MultipartBody
import retrofit2.Response
import retrofit2.http.*

interface APIServices {

    @GET("categories/index")
    @Headers("cache-control: no-cache")
    suspend fun GetMainData(): ArrayList<SectionsModelItem>

    @POST("MobileMainPage/GetHomePage")
    @Headers("cache-control: no-cache")
    suspend fun getHomePageData(@Body googleModel: GoogleModel?,@Query("user_id") userId: Int): HomePageModel?

    @POST
    suspend fun getBranchesGallery(
        @Url url: String,
        @Body query: GalleryModel
    ):GalleryModel


    @GET("Attributes/index")
    suspend fun getVendorAttributes(): ArrayList<VendorAttributesModelItem>

    @POST("MobileMainPage/GetMainSliders")
    @Headers("cache-control: no-cache")
    suspend fun getMainSlidersData(@Body googleModel: GoogleModel?): ArrayList<SliderHomePageModelItem?>

    @GET("orders/GetUserLastOrderForRating")
    suspend fun getUserLastOrderForRating(): MyOrderModelItem

    @POST("orders/editfromDashboard/{id}")
    @Headers("Accept: Application/json", "cache-control: no-cache")
    suspend fun changeOrderRateStatus(@Path("id") orderId: Int,@Body rated: MyOrderModelItem): MyOrderModelItem

    //// Sections see more API /////
    @POST("MobileMainPage/getVendorOffersData")
    @Headers("cache-control: no-cache")
    suspend fun getVendorOffersData(@Body googleModel: GoogleModel?): ArrayList<VendorOffersDataItem>

    @POST("MobileMainPage/GetNearestBranches")
    @Headers("cache-control: no-cache")
    suspend fun getNearestBranchesData(@Body googleModel: GoogleModel?): ArrayList<BranchesModelListItem>

    @POST("MobileMainPage/GetNewOffer")
    @Headers("cache-control: no-cache")
    suspend fun getNewOfferData(@Body googleModel: GoogleModel?): ArrayList<BranchesModelListItem>

    @POST("MobileMainPage/GetFreeDliveryBranches")
    @Headers("cache-control: no-cache")
    suspend fun getFreeDliveryBranches(@Body googleModel: GoogleModel?): ArrayList<BranchesModelListItem>

    @POST("MobileMainPage/getMostOrderedBranchs")
    @Headers("cache-control: no-cache")
    suspend fun getMostOrderedBranches(@Body googleModel: GoogleModel?): ArrayList<BranchesModelListItem>

    @POST("MobileMainPage/MobileSearch")
    @Headers("cache-control: no-cache")
    suspend fun getMobileSearch(@Body googleModel: GoogleModel?): SearchModel

    @POST("users/registerToken")
    @Headers("cache-control: no-cache")
    suspend fun registerToken(@Body user: LoginModel?): Response<Int>

    @POST("notification/sendToDevice")
    @Headers("cache-control: no-cache")
    suspend fun sendNotificationToDevice(@Body user: LoginModel?): Response<LoginModel>

    @GET("staticpages/index")
    suspend fun getStaticPages(): ArrayList<StaticPagesItem>

   @GET("socialUrls/index")
    suspend fun getSocialIcons(): ArrayList<SocialMediaModelItem>

    @GET("Categories/index")
    suspend fun getCategoriesBanner(): ArrayList<CategoryBannerItem>

    @GET("Address/PaymentTypes")
    suspend fun getPaymentWays(): Response<ArrayList<PaymentWaysItem>>

    @GET("Address/UsersAddress")
    suspend fun getUsersAddress(): Response<ArrayList<UserAddressesItem>>

    @GET("Address/UsersAddressByBranch/{branchID}")
    suspend fun checkRestaurantAddress(@Path("branchID") branchId: Int): Response<ArrayList<UserAddressesItem>>

    //Address/UsersAddress/add
    @POST("Address/UsersAddress/add")
    @Headers("cache-control: no-cache")
    suspend fun addUsersAddress(@Body addressInfo: UserAddressesItem): Response<UserAddressesItem>

    //Address/UsersAddress/add
    @POST("Address/edit/{id}")
    @Headers("cache-control: no-cache")
    suspend fun editUsersAddress(
        @Path("id") addressId: Int,
        @Body addressInfo: UserAddressesItem,
    ): Response<UserAddressesItem>

    @GET("Address/delete/{id}")
    suspend fun deleteUsersAddress(@Path("id") addressId: Int): Response<Int>

    @GET("users/view/{id}")
    suspend fun getUsersData(@Path("id") addressId: Int): Response<ProfileModel>

    @Multipart
    @POST("users/edit")
    suspend fun editUsersData(
        @Part("data") data: User,
        @Part img: MultipartBody.Part?,
    ):Response<User>


    @POST("users/edituser")
    suspend fun editUsersDataWithOutPhoto(

        @Body() data: User,
    ):Response<User>
    @GET("restaurant/getCusinesList/{category_id}")
    suspend fun GetCuisinesData(@Path("category_id") category_id: Int): ArrayList<Cuisines>


    @POST("MobileMainPage/GetCategoriesSliders")
    suspend fun getCategoriesSliders(@Body sliderModel: SliderModel): ArrayList<SliderHomePageModelItem>


    @GET("MenuItem/GetItemById/{item_id}")
    suspend fun GetItemById(@Path("item_id") item_id: Int): ArrayList<MenuCategoriesItem>

    //branches/getBranchesByAreas
    @GET("branches/getBranchesByAreas/{area_id}/{catid}")
    suspend fun GetBranchesData(
        @Path("area_id") area_id: Int,
        @Path("catid") catid: Int,
    ): ArrayList<BranchesModelListItem>


    @POST("branches/getBranchesByAreas")
    @Headers("Content-Type: Application/json", "cache-control: no-cache")
    suspend fun getBranchesByGoogle(
        @Body googleModel: GoogleModel?, @Query("page") page: Int?,
    ): ArrayList<BranchesModelListItem>

    @POST("branches/getBranchesByAreasByCat")
    @Headers("Content-Type: Application/json")
    suspend fun getBranchesByAreasByCat(
        @Body googleModel: GoogleModel?, @Query("page") page: Int?,
    ): ArrayList<BranchesModelListItem>

    @POST("branches/getBranchesByAreasForGoogleMaps")
    @Headers("Content-Type: Application/json", "cache-control: no-cache")
    suspend fun getBranchesByAreasForGoogleMaps(@Body googleModel: GoogleModel?): Response<BranchesModelListItem>


    @POST("branches/getBranchesByAreas")
    @Headers("Content-Type: Application/json", "cache-control: no-cache")
    suspend fun getBranchesMap(@Body googleModel: GoogleModel?): Response<ArrayList<BranchesModelListItem>>


    @GET("cities/getCitiesForApp")
    suspend fun GetCitiesData(): ArrayList<CitiesModelItem>?

    @GET("Cities/getCitiyTowns/{city_id}")
    suspend fun GetTownData(@Path("city_id") city_id: Int): Response<ArrayList<CitiesModelItem>>

//http://satafood.codesroots.com:3000/api/Cities/getTownsArea/11

    @GET("Cities/getTownsArea/{area_id}")
    suspend fun GetAreaData(@Path("area_id") area_id: Int): ArrayList<CitiesModelItem>


    /// getRestaurantDetails
    ///http://satafood.codesroots.com:3000/api/branches/resturantDetails/5/17
    @GET("branches/resturantDetails/{restaurant_id}/{area_id}")
    suspend fun getRestaurantDetails(
        @Path("restaurant_id") restaurant_id: Int, @Path("area_id") area_id: Int,
    ): StoreDetailsModel

    @GET("Restaurant/getRestuarantRates/{restaurant_id}")
    suspend fun getRestaurantReviews(
        @Path("restaurant_id") restaurant_id: Int
    ): ReviewsModel


    @POST("orders/checkOrderTotal")
    suspend fun getCartConfig(@Body googleModel: GoogleModel?): Response<CartConfigurations>

    @POST("wallets/checkWallet")
    suspend fun checkWallet(@Body googleModel: GoogleModel?): WalletModel

    @POST("Transactions/indexForMobile")
    suspend fun getWalletTransactions(@Body walletId:WalletDetailsModelItem?): ArrayList<WalletDetailsModelItem>

    @FormUrlEncoded
    @POST("branches/Cart/{restaurant_id}/{AreaId}")
    suspend fun getCartItems(
        @Path("restaurant_id") restaurant_id: Int,
        @Path("AreaId") AreaId: Int,
        @Field("productList") ItemList: Array<Int>,
    ): StoreDetailsModel


    ////http://satafood.codesroots.com:3000/api/Restaurant/getRestaurant


    // Favourite
    @FormUrlEncoded
    @POST("Favorite/add")
    suspend fun AddFavorite(
        @Field("restaurant_id") restaurant_id: Int, @Field("user_id") UserId: Int,
    ): Boolean

    @POST
    suspend fun getPlaceId(
        @Url url: String,
        @Query("query") streetName: String, @Query("key") key: String,
    ): Response<Google>

  @GET("Branches/getBranchesForRestaurant")
    suspend fun getBranchesLocations(): Response<BranchesLocation>

 @GET("gallery/index")
    suspend fun getBranchesGallery(): Response<ArrayList<BranchesGalleryModelItem>>


    @POST
    suspend fun getPaymobToken(
        @Url url: String,
        @Body orderModel: PayMobToken?,
    ): Response<com.satafood.core.entities.paymob.Token>

    @POST
    @Headers("isAuthorizable: false")

    suspend fun GetPaymentkey(
        @Url url: String,

        @Body orderModel: Payment?
    ): Response<Payment>


    @POST
    suspend fun makePaymentOrderIntegration(
        @Url url: String,
        @Body orderModel: HashMap<*, *>?,
    ): Response<PayMobToken>


    //https://maps.googleapis.com/maps/api/geocode/json?latlng=30.060714,31.346661
    // &language=en
    // &result_type=administrative_area_level_3|postal_code&key=AIzaSyBgPlLlB6uJSbGBAhlircYKudeeuGVtWfs
    @GET
    suspend fun getLocationByPlaceId(
        @Url url: String,
        @Query("place_id")
        latlng: String,
        @Query("key")
        apiKey: String = "AIzaSyBgPlLlB6uJSbGBAhlircYKudeeuGVtWfs",

        ): Response<Google>
    @GET
    suspend fun getPlaceIdByGeoCode(
        @Url url: String,
        @Query("latlng")
        latlng: String,
        @Query("key")
        apiKey: String = "AIzaSyBgPlLlB6uJSbGBAhlircYKudeeuGVtWfs",
        @Query("result_type", encoded = true)
        result_type: String = "administrative_area_level_3|postal_code",
    ): Response<Google>

    @GET("Favorite/delete/{favId}")
    suspend fun DELETEFavorite(
        @Path("favId") favId: Int,
    ): Boolean

    @GET("Favorite/get")
    suspend fun getFavorite(): ArrayList<FavouriteModelItem>

    @GET("Favorite/getFavForUserForRestaurants/{id}")
    suspend fun checkFavorite(@Path("id") restaurant_id: Int):Response<ArrayList<FavouriteModelItem>>


    @POST("orders/editfromDashboard/{orderId}")
    suspend fun changeOrderStatus(
        @Path("orderId") orderId: Int, @Body data: OrderStatus,
    ): OrderStatus

    ////////////// make order
    @POST("Orders/add")
    @Headers("Accept: Application/json", "cache-control: no-cache")
    suspend fun AddOrder(@Body orderModel: OrderModel?): Response<OrderModel>

    ////////////// rate order
    @POST("orders/rate")
    @Headers("Accept: Application/json", "cache-control: no-cache")
    suspend fun rate(@Body rateModel: RateModel?): Response<RateModel>


    ///// Notifications ArrayList<NotificationModelItem>()
    @GET("notification/index")
    suspend fun getNotifications(@Query("user_id")user_id:Int,@Query("googleId")googleId:String): ArrayList<NotificationModelItem>

    //orders/GetUserOrders
    @GET("orders/GetUserOrders")
    suspend fun getUserOrders(): ArrayList<MyOrderModelItem>

    ////////////// preOrder
    @POST("orders/preOrder")
    @Headers("Accept: Application/json", "cache-control: no-cache")
    suspend fun preOrder(@Body orderModel: MyOrderModelItem?): Response<Double>

    //orders/GetUserOrders
    @POST("orders/GetUserOrders")
    suspend fun getFilteredUserOrders(@Body orderModel: OrderModel?): ArrayList<MyOrderModelItem>

    /////// Authentication
    @POST("login")
    @Headers("Accept: Application/json", "cache-control: no-cache")
    suspend fun login(@Body loginModel: User?): Response<LoginModel>

    /////// Authentication
    @POST("forgotPassword")
    @Headers("Accept: Application/json", "cache-control: no-cache")
    suspend fun forgetPassword(@Body loginModel: ForgetPasswordModel?): Response<ForgetPasswordModel>

    @POST("createUser")
    @Headers("Accept: Application/json", "cache-control: no-cache")
    suspend fun register(@Body registerModel: User?): Response<LoginModel>

    @POST("checkAgainVerifyEmail")
    @Headers("Accept: Application/json", "cache-control: no-cache")
    suspend fun checkAgainVerifyEmail(@Body registerModel: User?): Response<LoginModel>

    @POST("checkVerifyEmail")
    @Headers("Accept: Application/json", "cache-control: no-cache")
    suspend fun checkVerifyEmail(@Body registerModel: LoginModel?): Response<LoginModel>

    @POST("users/facebooklogin.json")
    fun faceBookLogin(@Body facebookModel: User?): Response<LoginModel>

    @GET("wallets/GetWalletForUserMobile")
    suspend fun getWalletList(): Response<List<WalletModel>>

    @GET("wallets/GetUserCreditMobile")
    suspend fun getUserCredit(): Response<WalletCredit>

    @POST("users/edit/{userId}")
    suspend fun updateUserToken(@Path("userId") userId: Int, @Body token: Token): Response<Unit>

    @POST("users/edituser")
    suspend fun activeUserAccount( @Body loginModel: LoginModel?): Response<LoginModel>

    @GET("MenuItem/GetItemById/{itemId}")
    suspend fun getItemById(@Path("itemId") userId: Int): Response<List<MenuCategoriesItem>>

    @GET("CustomerSupport/index")
    suspend fun getQueries(): Response<List<com.satafood.core.entities.support.Query>>

    @GET("CustomerSupport/index")
    suspend fun getAllCommonQuestions() : Response<MutableList<questionsItem>>

    @GET("CustomerSupportCat/getByCatId/{id}")
    suspend fun getCommonQuestionsById(@Path("id") typeId:Int) : Response<MutableList<questionsItem>>

    @GET("CustomerSupportCat/index")
    suspend fun getQuestionsCategories() : Response<List<QuestionCategoryItem>>


    @POST("complaints/add")
    @Headers("Content-Type: Application/json", "cache-control: no-cache")
    suspend fun addComplaints(@Body complaintsModel: Complaints?): Response<Complaints>

    @POST("NewRequests/add")
    @Headers("cache-control: no-cache")
    suspend fun addDriverRequest(@Body driverRequestModel: DriverRequestModel?): Response<DriverRequestModel>


    @POST("vouchers/checkVoucher")
    @Headers("cache-control: no-cache")
    suspend fun checkVoucherRequest(@Body voucherModel: VoucherModel?): Response<VoucherModel>


    @POST("points/getUserPoints")
    @Headers("cache-control: no-cache")
    suspend fun getUserPoints(): UserPointsModel


    @POST("points/transferPoints")

    suspend fun transferPoints(@Body userPoints: CountPointsModel): Response<CountPointsModel>




    @Headers("isAuthorizable: false")
    @POST
    suspend fun MakePaymentOrderIntegration(
        @Url url: String,
        @Body orderModel:HashMap<String,Any>
    ): Response<MakePaymentOrderIntegration?>

    @GET("Menu/getMenuItemsByResturantApp/247")
    suspend fun getCategoriesData(): SectionsModelItem

}


