package com.codes_roots.imakeapp.datalayer

import android.content.Context
import com.codes_roots.imakeapp.R
import java.net.SocketTimeoutException
import java.net.UnknownHostException
import java.util.concurrent.TimeoutException

class ExceptionsMapper
constructor(private val context: Context) {

    fun mapFromException(exception: Throwable) =
        if (exception != null)
            when (exception) {
                is NetworkConnectionInterceptor.NoConnectivityException ->
                    context.getString(R.string.failedConnection)
                is TimeoutException, is UnknownHostException, is SocketTimeoutException ->
                    context.getString(R.string.timeoutExceeded)
                else -> context.getString(R.string.errorOccurred)
            }
        else
            context.getString(R.string.errorOccurred)

}





















