package com.codes_roots.imakeapp.helper


import com.codes_roots.imakeapp.di.AppComponent
import com.codes_roots.imakeapp.di.DaggerAppComponent
import dagger.android.AndroidInjector
import dagger.android.DaggerApplication
import io.socket.client.IO
import io.socket.client.Socket
import java.net.URISyntaxException

/**
Created by Prokash Sarkar on Tue, January 19, 2021
 **/

open class BaseApplication : DaggerApplication() {
    private var mSocket: Socket? = null
    override fun applicationInjector(): AndroidInjector<out DaggerApplication> {
        return initializeDaggerComponent()
    }

    companion object {
        lateinit var appComponent: AppComponent

    }

    override fun onCreate() {
        super.onCreate()
        initDI()
        try {


            mSocket = IO.socket(Constants.SocketURL)
        } catch (e: URISyntaxException) {
            throw RuntimeException(e)
        }

    }

    private fun initDI() {
        appComponent = DaggerAppComponent.factory()
            .create(this)

    }

    open fun initializeDaggerComponent(): AppComponent {
        val component: AppComponent = DaggerAppComponent.factory()
            .create(this)

        component.inject(this)

        return component
    }

    fun getMSocket(): Socket? {
        return mSocket
    }

}