package com.codes_roots.imakeapp.helper

import com.satafood.core.base.DataState
import kotlinx.coroutines.flow.Flow
import kotlinx.coroutines.flow.flow


fun <T> executeRemoteAPI(
    networkCall: suspend () -> DataState<T>
): Flow<DataState<T>> =
    flow {
        emit(DataState.loading())
        val responseStatus = networkCall.invoke()
        if (responseStatus.status == DataState.Status.SUCCESS) {
            try {
                emit(DataState.success(responseStatus.data))
            }catch (e: Exception){

            }
        } else if (responseStatus.status == DataState.Status.ERROR) {
            emit(DataState.error(responseStatus.error, responseStatus.data))
        }
    }