package com.codes_roots.imakeapp.helper

import android.content.Context
import androidx.appcompat.app.AlertDialog
import com.codes_roots.imakeapp.R
import com.codes_roots.imakeapp.databinding.LoginFragmentBinding
import com.codes_roots.imakeapp.presentaion.register.loginfragment.LoginFragment
import com.satafood.core.entities.login.User
import kotlinx.android.synthetic.main.login_fragment.*

class FormValidationLogin {


     fun passwordFocusListener(context: Context,binding: LoginFragmentBinding)
    {
        binding.password.setOnFocusChangeListener { _, focused ->
            if(!focused)
            {
                binding.passwordfilledTextField.helperText = validPassword(context ,binding)
            }
        }
    }

    private fun validPassword(context: Context,binding: LoginFragmentBinding): String?
    {
        val passwordText = binding.password.text.toString()
        if(passwordText.length < 5)
        {
            return  context.getString(R.string.invalidPassword)
        }
//        if(!passwordText.matches(".*[A-Z].*".toRegex()))
//        {
//            return  context.getString(R.string.invalidPassword2)
//        }
//        if(!passwordText.matches(".*[a-z].*".toRegex()))
//        {
//            return "Must Contain 1 Lower-case Character"
//        }

//        if(!passwordText.matches(".*[@#\$%^&+=].*".toRegex()))
//        {
//            return  context.getString(R.string.invalidPassword3)
//        }

        return null
    }
    private fun validName(context: Context,binding: LoginFragmentBinding): String?
    {
        val userName = binding.username.text.toString()
        if(userName.length < 2)
        {
            return context.getString(R.string.validusername)

        }
        return null
    }




     fun submitForm(binding: LoginFragmentBinding,context: Context,frag : LoginFragment)
    {
        binding.passwordfilledTextField.helperText = validPassword(context,binding)
        binding.usernameContainer.helperText = validName(context,binding)
        val validPassword = binding.passwordfilledTextField.helperText == null
        val validUsername =  binding.usernameContainer.helperText == null

        if (validUsername && validPassword)
            loginRequest(binding,frag)
        else
            invalidForm(frag,context)
    }


    fun nameFocusListener(context: Context,binding: LoginFragmentBinding)
    {
        binding.username.setOnFocusChangeListener { _, focused ->
            if(!focused)
            {
                binding.usernameContainer.helperText = validName(context,binding)
            }
        }
    }

    fun loginRequest(view: LoginFragmentBinding,frag : LoginFragment) {
        val loginInfo = User(
            username = view.username.text.toString()
            , password = view.password.text.toString())
        frag.viewModel.login(loginInfo)
    }

    private fun invalidForm(binding: LoginFragment,context: Context)
    {
        var message = ""

        if(binding.passwordfilledTextField.helperText != null)
            message += "\n\nPassword: " + binding.passwordfilledTextField.helperText

        AlertDialog.Builder(context)
            .setTitle("Invalid Form")
            .setMessage(message)
            .setPositiveButton("Okay"){ _,_ ->
                // do nothing
            }
         //   .show()
    }
}