package com.codes_roots.imakeapp.helper

import android.content.Context
import android.util.Log
import android.util.Patterns
import com.codes_roots.imakeapp.R
import com.codes_roots.imakeapp.databinding.RegisterFragmentBinding
import com.codes_roots.imakeapp.presentaion.register.RegisterActivity
import com.codes_roots.imakeapp.presentaion.register.registerfragment.RegisterFragment

class FormValidationRegister {
    fun emailFocusListener(context: Context, binding: RegisterFragmentBinding) {
        binding.email.setOnFocusChangeListener { _, focused ->
            if (!focused) {
                binding.emailfilledTextField.helperText = validEmail(context, binding)
            }
        }
    }

    fun validEmail(context: Context, binding: RegisterFragmentBinding): String? {
        val emailText = binding.email.text.toString()
        if (!Patterns.EMAIL_ADDRESS.matcher(emailText).matches()) {
            return context.getString(R.string.invalidEmail)
        }
        return null
    }

    fun passwordFocusListener(context: Context, binding: RegisterFragmentBinding) {
        binding.password.setOnFocusChangeListener { _, focused ->
            if (!focused) {
                binding.passwordfilledTextField.helperText = validPassword(context, binding)
            }
        }
    }

    fun nameFocusListener(context: Context, binding: RegisterFragmentBinding) {
        binding.username.setOnFocusChangeListener { _, focused ->
            if (!focused) {
                binding.filledTextField.helperText = validName(context, binding)
            }
        }
    }

    private fun validPassword(context: Context, binding: RegisterFragmentBinding): String? {
        val passwordText = binding.password.text.toString()
        if (passwordText.length < 5) {
            return context.getString(R.string.invalidPassword)
        }
//        if (!passwordText.matches(".*[A-Z].*".toRegex())) {
//            return context.getString(R.string.invalidPassword2)
//
//        }
////        if(!passwordText.matches(".*[a-z].*".toRegex()))
////        {
////            return "Must Contain 1 Lower-case Character"
////        }
//        if (!passwordText.matches(".*[@#\$%^&+=].*".toRegex())) {
//            return context.getString(R.string.invalidPassword3)
//
//        }

        return null
    }

    fun phoneFocusListener(context: Context, binding: RegisterFragmentBinding) {
        binding.mobile.setOnFocusChangeListener { _, focused ->
            if (!focused) {
                binding.phonenimerfield.helperText = validPhone(context, binding)
            }
        }
    }

    private fun validPhone(context: Context, binding: RegisterFragmentBinding): String? {
        val phoneText = binding.mobile.text.toString()

        if (!phoneText.matches(".*[0-9].*".toRegex())) {
            return "Must be all Digits"
        }
        if ((phoneText.length != 11)) {
            return context.getString(R.string.validMobNum2)
        }

        if (!phoneText.startsWith("011")) {
            if (!phoneText.startsWith("010")) {

                if (!phoneText.startsWith("012")) {
                    if (!phoneText.startsWith("015")) {

                        return context.getString(R.string.validMobNum)
                    }
                }
            }

        }

        return null
    }

    private fun validName(context: Context, binding: RegisterFragmentBinding): String? {
        val userName = binding.username.text.toString()
        if (userName.length < 2) {
            return context.getString(R.string.validusername)
        }

        return null
    }

    fun submitForm(binding: RegisterFragmentBinding, context: Context, frag: RegisterFragment):Boolean {
        binding.emailfilledTextField.helperText = validEmail(context, binding)
        binding.passwordfilledTextField.helperText = validPassword(context, binding)
        binding.phonenimerfield.helperText = validPhone(context, binding)
        binding.filledTextField.helperText = validName(context, binding)

        val validEmail = binding.emailfilledTextField.helperText == null
       val validPassword = binding.passwordfilledTextField.helperText == null
        val validPhone = binding.phonenimerfield.helperText == null
        val validUsername = binding.filledTextField.helperText == null

        if (validEmail && validPhone && validPassword && validUsername){
            (context as RegisterActivity).preferenceHelper.userPhone = binding.mobile.text.toString()
        if (binding.ccp.fullNumber.contains("+20")){
            (context as RegisterActivity).preferenceHelper.countryCode = "+2"

        }else{
            (context as RegisterActivity).preferenceHelper.countryCode = binding.ccp.fullNumber.toString()

        }

          return true

        }
        else
          return false


    }

     fun invalidForm(binding: RegisterFragmentBinding, context: Context) {
         emailFocusListener(context, binding)
       passwordFocusListener(context, binding)
        nameFocusListener(context, binding)
        phoneFocusListener(context, binding)
          //  .show()
    }
}