package com.codes_roots.imakeapp.helper

import android.graphics.Rect
import android.view.View
import androidx.recyclerview.widget.RecyclerView
import androidx.recyclerview.widget.RecyclerView.ItemDecoration

class VerticalMarginItemDecoration(
    private val spaceHeight: Int
) :
    ItemDecoration() {
    override fun getItemOffsets(
        outRect: Rect,
        view: View,
        parent: RecyclerView,
        state: RecyclerView.State
    ) {
        super.getItemOffsets(outRect, view, parent, state)
        if (parent.getChildAdapterPosition(view) == 0) {
            outRect.top = spaceHeight
        } else {
            outRect.top = spaceHeight / 2
        }
        outRect.bottom = spaceHeight / 2
    }
}