package com.codes_roots.imakeapp.helper

import android.app.Activity
import android.app.AlertDialog
import android.content.Context
import android.graphics.Color
import android.graphics.Paint
import android.os.Build
import android.widget.TextView
import androidx.annotation.RequiresApi
import androidx.appcompat.widget.AppCompatImageView
import androidx.core.content.res.ResourcesCompat
import androidx.databinding.BindingAdapter
import androidx.fragment.app.Fragment
import androidx.fragment.app.FragmentActivity
import androidx.lifecycle.ViewModel
import androidx.lifecycle.ViewModelProvider
import androidx.lifecycle.ViewModelProviders
import com.bumptech.glide.Glide
import com.bumptech.glide.load.resource.drawable.DrawableTransitionOptions
import com.bumptech.glide.request.RequestOptions
import com.codes_roots.imakeapp.R
import com.google.android.material.imageview.ShapeableImageView
import com.makeramen.roundedimageview.RoundedImageView
import www.sanju.motiontoast.MotionToast
import java.lang.Long
import java.text.SimpleDateFormat
import java.util.*
import kotlin.Boolean
import kotlin.Exception
import kotlin.Lazy
import kotlin.LazyThreadSafetyMode
import kotlin.String
import kotlin.Unit
import kotlin.apply
import kotlin.lazy


///TOAST_SUCCESS_MotionToast
fun SUCCESS_MotionToast(massage: String, context: Activity) {
    MotionToast.createColorToast(
        context,
        context.getString(R.string.success),
        massage,
        MotionToast.TOAST_SUCCESS,
        MotionToast.GRAVITY_BOTTOM,
        MotionToast.LONG_DURATION,
        ResourcesCompat.getFont(context, R.font.helvetica_regular)
    )
}
///TOAST_SUCCESS_MotionToast
fun InfoMotionToast(massage: String, context: Activity) {
    MotionToast.createColorToast(
        context,
        context.getString(R.string.sata),
        massage,
        MotionToast.TOAST_INFO,
        MotionToast.GRAVITY_BOTTOM,
        MotionToast.LONG_DURATION,
        ResourcesCompat.getFont(context, R.font.helvetica_regular)
    )
}

fun WARN_MotionToast(massage: String, context: Activity) {
    MotionToast.createColorToast(
        context,
        context.getString(R.string.attention),
        massage,
        MotionToast.TOAST_WARNING,
        MotionToast.GRAVITY_BOTTOM,
        MotionToast.LONG_DURATION,
        ResourcesCompat.getFont(context, R.font.helvetica_regular)
    )
}

fun Error_MotionToast(massage: String, context: Activity) {
    MotionToast.createColorToast(
        context,
        "",
        massage,
        MotionToast.TOAST_ERROR,
        MotionToast.GRAVITY_BOTTOM,
        MotionToast.LONG_DURATION,
        ResourcesCompat.getFont(context, R.font.helvetica_regular)
    )
}
 fun showDialog(){

}

@BindingAdapter("app:imageResource")
fun setImageResource(imageView: AppCompatImageView, resource: String?) {
    Glide.with(imageView.context)
        .load((Constants.IMAGE_URL + resource))
        .error(R.drawable.empty_meal)
        .transition(DrawableTransitionOptions.withCrossFade())
        .into(imageView)
}

@BindingAdapter("app:imageResourcea")
fun setImageResourceSata(imageView: AppCompatImageView, resource: String?) {
    val requestOptions = RequestOptions()
    requestOptions.error(R.drawable.empty_meal_2)
    Glide.with(imageView.context)
        .load((Constants.IMAGE_URL_SATA + resource))
        .transition(DrawableTransitionOptions.withCrossFade())
        .apply(requestOptions)
        .into(imageView)
}

@BindingAdapter("app:setRoundImageResource")
fun setRoundImageResource(imageView: RoundedImageView, resource: String?) {
    val requestOptions = RequestOptions()
    requestOptions.error(R.drawable.noimg)
    Glide.with(imageView.context)
        .load((Constants.IMAGE_URL + resource))
        .transition(DrawableTransitionOptions.withCrossFade())
        .apply(requestOptions)
        .into(imageView)
}

@BindingAdapter("text_color")
/////// set Stock image statue /////
fun setTextStock(text: TextView, color: String?) {
    when (color) {
        "(مفتوح)" ->
            text.setTextColor(Color.parseColor("#4CAF50"))

        "(مغلق)" -> text.setTextColor(Color.parseColor("#FF0000"))

        else -> {
            text.setTextColor(Color.parseColor("#9C9898"))
        }
    }

}

@BindingAdapter("strikeThrough")
fun strikeThrough(textView: TextView, strikeThrough: Boolean) {
    if (strikeThrough) {
        textView.paintFlags = textView.paintFlags or Paint.STRIKE_THRU_TEXT_FLAG
    } else {
        textView.paintFlags = textView.paintFlags and Paint.STRIKE_THRU_TEXT_FLAG.inv()
    }
}

inline fun  showDefaultDialog(
    context: Context,
    onDismiss1: FragmentActivity,
    crossinline onDismiss: () -> Unit,
) {
    val alertDialog = AlertDialog.Builder(context)

    alertDialog.apply {
        //setIcon(R.drawable.ic_hello)
        setTitle(context.getString(R.string.thanksForJoin))
        setMessage(context.getString(R.string.thanksForJoin2))
        setIcon(context.resources.getDrawable(R.drawable.logo2))
//        setPositiveButton("Positive") { _: DialogInterface?, _: Int ->
//            Toast.makeText(context, "Hello", Toast.LENGTH_SHORT).show()
//        }
//        setNegativeButton("Negative") { _, _ ->
//            Toast.makeText(context, "Negative", Toast.LENGTH_SHORT).show()
//        }
//        setNeutralButton("Neutral") { _, _ ->
//            Toast.makeText(context, "Neutral", Toast.LENGTH_SHORT).show()
//        }
        setOnDismissListener {
            onDismiss()
        }

    }.create().show()
}

fun ShapeAppearanceModel(context: Context, view: ShapeableImageView) {
    val radius = context.resources.getDimension(R.dimen.name)
    val shapeAppearanceModel = view.shapeAppearanceModel.toBuilder()
        .setAllCornerSizes(radius)
        .build()
    view.shapeAppearanceModel = shapeAppearanceModel

}

@BindingAdapter("app:datetext")
fun setDatetext(text: TextView, resource: String?) {

    val myFormat = SimpleDateFormat("yyyy-MM-dd'T'HH:mm")

    val dateObj: Date
    try {

        dateObj = myFormat.parse(resource)
        val timestamp = dateObj.time.toString()//  //Example -> in ms
        val fromServer = SimpleDateFormat("yyyy-MM-dd HH:mm", Locale("en"))
        val dateString = fromServer.format(Date(Long.parseLong(timestamp)))

        text.text = dateString
    } catch (e: Exception) {
    }
}

fun ShapeAppearanceRounded(context: Context, view: ShapeableImageView) {
    val radius = context.resources.getDimension(R.dimen.dimen_48)
    val shapeAppearanceModel = view.shapeAppearanceModel.toBuilder()
        .setAllCornerSizes(radius)
        .build()
    view.shapeAppearanceModel = shapeAppearanceModel

}

@RequiresApi(Build.VERSION_CODES.O)
fun getCreationDateFormatted(resource: String?): String? {
    val date = SimpleDateFormat("yyyy-MM-dd'T'HH:mm:ss.SSS'Z'").parse(resource)
    return SimpleDateFormat("yyyy-MM-dd HH").format(date)
}

fun getCurrentDateFormatted(): String? {
    val calendar = Calendar.getInstance()
    val sdf = SimpleDateFormat("yyyy-MM-dd HH")

    val currentDate = sdf.format(calendar.time)

    return currentDate

}


fun <T> androidLazy(initializer: () -> T): Lazy<T> = lazy(LazyThreadSafetyMode.NONE, initializer)
inline fun <reified T : ViewModel> Fragment.getViewModel(viewModelFactory: ViewModelProvider.Factory): T =
    ViewModelProviders.of(this, viewModelFactory)[T::class.java]

