package com.codes_roots.imakeapp.network_connection

import android.app.NotificationManager
import android.app.Service
import android.content.BroadcastReceiver
import android.content.Context
import android.content.Intent
import android.content.IntentFilter
import android.os.IBinder
import android.util.Log
import com.codes_roots.imakeapp.presentaion.nointernet.NoInternetAcitvity

class networkService : Service() {
    private var receiver: BroadcastReceiver? = null
    var manager: NotificationManager? = null
    override fun onBind(intent: Intent): IBinder? {
        return null
    }

    override fun onStartCommand(intent: Intent, flags: Int, startId: Int): Int {
        // Let it continue running until it is stopped.

        val filter = IntentFilter()
        filter.addAction("android.net.conn.CONNECTIVITY_CHANGE")
        receiver = object : BroadcastReceiver() {
            override fun onReceive(context: Context, intent: Intent) {




                val action = intent.action
                if (CONNECTIVITY_CHANGE_ACTION == action) {
                    //check internet connection
                    if (!ConnectionHelper.isConnectedOrConnecting(context)) {
                        if (context != null) {
                            var show = false
                            if (ConnectionHelper.lastNoConnectionTs == -1L) { //first time
                                show = true
                                ConnectionHelper.lastNoConnectionTs = System.currentTimeMillis()
                            } else {
                                if (System.currentTimeMillis() - ConnectionHelper.lastNoConnectionTs > 1000) {
                                    show = true
                                    ConnectionHelper.lastNoConnectionTs = System.currentTimeMillis()
                                }
                            }
                            if (show && ConnectionHelper.isOnline) {
                                ConnectionHelper.isOnline = false
                                Log.i("NETWORK123", "Connection lost")

                                val dialogIntent = Intent(context, NoInternetAcitvity::class.java)
                                dialogIntent.addFlags(Intent.FLAG_ACTIVITY_NEW_TASK)
                                startActivity(dialogIntent)
                                //manager.cancelAll();
                            }
                        }
                    } else {
                        Log.i("NETWORK123", "Connected")

                        // Perform your actions here
                        ConnectionHelper.isOnline = true
                    }
                }
                registerReceiver(receiver, filter)

                }




            }


        return START_STICKY
    }

    override fun onDestroy() {
        super.onDestroy()
        try {
            if (receiver != null) unregisterReceiver(receiver)
      //      Toast.makeText(this, "Service Destroyed", Toast.LENGTH_LONG).show()

        } catch (e: Exception) {
        }
    }

    companion object {
        const val CONNECTIVITY_CHANGE_ACTION = "android.net.conn.CONNECTIVITY_CHANGE"
    }
}