package com.codes_roots.imakeapp.paymob_activity

import android.content.Intent
import android.os.Bundle
import androidx.activity.viewModels
import androidx.appcompat.app.AppCompatActivity
import androidx.lifecycle.MutableLiveData
import androidx.lifecycle.Observer
import androidx.lifecycle.ViewModelProvider
import com.paymob.acceptsdk.*
import com.codes_roots.imakeapp.R
import com.codes_roots.imakeapp.helper.BaseApplication
import com.codes_roots.imakeapp.helper.PreferenceHelper
import com.codes_roots.imakeapp.presentaion.cartfragment.viewmodel.CartViewModel
import com.satafood.core.entities.paymob.BillingData
import com.satafood.core.entities.paymob.MakePaymentOrderIntegration
import com.satafood.core.entities.paymob.Payment
import kotlinx.android.synthetic.main.paymob_activity.*
import javax.inject.Inject
import kotlin.math.roundToInt

class PaymobActivity : AppCompatActivity() {


    internal lateinit var payment: Payment
    @Inject
    lateinit var Pref: PreferenceHelper
    internal  var Total: Float = 0.toFloat()
    internal var paymentKey = ""


    @Inject
    lateinit var cartViewModelFactory: ViewModelProvider.Factory

    val viewModel by viewModels<CartViewModel> { cartViewModelFactory }
    var makePaymentOrderIntegration: MutableLiveData<MakePaymentOrderIntegration> =
        MutableLiveData<MakePaymentOrderIntegration>()

    // Replace this with your actual payment key

    override fun onCreate(savedInstanceState: Bundle?) {
        super.onCreate(savedInstanceState)
        setContentView(R.layout.paymob_activity)
        BaseApplication.appComponent.inject(this)

            Total = Pref.OrderTotal
        processCardpayment()

    }

    private fun processCardpayment() {
        payment = Payment()

        payment.amount_cents = (Total.roundToInt()  * 100).toString()
        payment.auth_token = Pref.PayMobToken
        payment.currency = Pref.currency
        payment.integration_id = 3065700
        var billingModel = BillingData()
        payment.billing_data = (billingModel)
        billingModel.email = Pref.email
        billingModel.first_name = Pref.userName
        billingModel.last_name = Pref.userName
        billingModel.phone_number = Pref.userPhone
        billingModel.apartment = "NA"
        billingModel.apartment = "NA"
        billingModel.building = "NA"
        billingModel.city = "NA"

        payment.billing_data!!.country = "Na"

        payment.billing_data!!.floor = "Na"
        payment.billing_data!!.postal_code = "Na"
        payment.billing_data!!.shipping_method = "Na"
        payment.billing_data!!.street = "Na"
        payment.billing_data!!.state = "Na"
        makePaymentOrderIntegration()



    }
    private fun makePaymentOrderIntegration() {

        var set = HashMap<String, Any>()

        set.put("currency" , Pref.currency!!)
        set.put("amount_cents" ,(Total.roundToInt()  * 100).toString())

        set.put("delivery_needed" , "false")
        set.put("auth_token" , Pref.PayMobToken!!)
        set.put("items" , ArrayList<String>())

        viewModel.MakePaymentOrderIntegration(set)
        viewModel.makePaymentOrderIntegration.observe(this, Observer { aBoolean ->
            sendpaymentRequest(aBoolean.id)

        })

    }
    private fun sendpaymentRequest(id: Long?) {
        payment.order_id = id!!.toString()
        viewModel.PaymentData(payment);
        viewModel.paymentResponseLD!!.observe(this, Observer { aBoolean ->
            paymentKey = aBoolean.token!!;

            processpayment()
            //      ProcessPaymentClass().processpayment()
        })
    }
    private fun processpayment() {
        val pay_intent = Intent(this, PayActivity::class.java)
        putNormalExtras(pay_intent)

        // this key is used to save the card by deafult.
        pay_intent.putExtra(PayActivityIntentKeys.SAVE_CARD_DEFAULT, true)
        pay_intent.putExtra("language",Pref.lang);

        // this key is used to display the savecard checkbox.
        pay_intent.putExtra(PayActivityIntentKeys.SHOW_SAVE_CARD, true)

        //this key is used to set the theme color(Actionbar, statusBar, button).
        // pay_intent.putExtra(PayActivityIntentKeys.THEME_COLOR, resources.getColor(R.color.black))

        // this key is to wether display the Actionbar or not.
        //  pay_intent.putExtra("ActionBar", false)

        // this key is used to define the language. takes for ex ("ar", "en") as inputs.

        startActivityForResult(pay_intent, ACCEPT_PAYMENT_REQUEST)

    }

    private fun putNormalExtras(intent: Intent) {
        intent.putExtra(PayActivityIntentKeys.PAYMENT_KEY, paymentKey)
        intent.putExtra(PayActivityIntentKeys.THREE_D_SECURE_ACTIVITY_TITLE, "Verification")
    }


    public override fun onActivityResult(requestCode: Int, resultCode: Int, data: Intent?) {
        super.onActivityResult(requestCode, resultCode, data)
        val extras = data!!.extras
        if (requestCode == ACCEPT_PAYMENT_REQUEST) {
            when (resultCode) {
                IntentConstants.USER_CANCELED -> {
                    // User canceled and did no payment request was fired
                    ToastMaker.displayShortToast(this, "User canceled!!")
                }
                IntentConstants.MISSING_ARGUMENT -> {
                    // You forgot to pass an important key-value pair in the intent's extras
                    ToastMaker.displayShortToast(this,
                        "Missing Argument == " + extras!!.getString(IntentConstants.MISSING_ARGUMENT_VALUE))
                }
                IntentConstants.TRANSACTION_ERROR -> {
                    // An error occurred while handling an API's response
                    ToastMaker.displayShortToast(this,
                        "Reason == " + extras!!.getString(IntentConstants.TRANSACTION_ERROR_REASON))
                }
                IntentConstants.TRANSACTION_REJECTED -> {
                    // User attempted to pay but their transaction was rejected

                    // Use the static keys declared in PayResponseKeys to extract the fields you want
                    ToastMaker.displayShortToast(this,
                        extras!!.getString(PayResponseKeys.DATA_MESSAGE))
                }
                IntentConstants.TRANSACTION_REJECTED_PARSING_ISSUE -> {
                    // User attempted to pay but their transaction was rejected. An error occured while reading the returned JSON
                    ToastMaker.displayShortToast(this,
                        extras!!.getString(IntentConstants.RAW_PAY_RESPONSE))
                }
                IntentConstants.TRANSACTION_SUCCESSFUL -> {
                    // User finished their payment successfully
                    setResult(100)
                    finish()
                    // Use the static keys declared in PayResponseKeys to extract the fields you want
                    ToastMaker.displayShortToast(this,
                        extras!!.getString(PayResponseKeys.DATA_MESSAGE))
                }
                IntentConstants.TRANSACTION_SUCCESSFUL_PARSING_ISSUE -> {
                    // User finished their payment successfully. An error occured while reading the returned JSON.
                    onBackPressed()
                    ToastMaker.displayShortToast(this, "TRANSACTION_SUCCESSFUL - Parsing Issue")

                    // ToastMaker.displayShortToast(this, extras.getString(IntentConstants.RAW_PAY_RESPONSE));
                }
                IntentConstants.TRANSACTION_SUCCESSFUL_CARD_SAVED -> {
                    // User finished their payment successfully and card was saved.
//                    onBackPressed()
                    setResult(100)
                    finish()
                    // Use the static keys declared in PayResponseKeys to extract the fields you want
                    // Use the static keys declared in SaveCardResponseKeys to extract the fields you want
                    ToastMaker.displayShortToast(this,
                        "Token == " + extras!!.getString(SaveCardResponseKeys.TOKEN))
                }
                IntentConstants.USER_CANCELED_3D_SECURE_VERIFICATION -> {
                    ToastMaker.displayShortToast(this, "User canceled 3-d scure verification!!")

                    // Note that a payment process was attempted. You can extract the original returned values
                    // Use the static keys declared in PayResponseKeys to extract the fields you want
                    ToastMaker.displayShortToast(this, extras!!.getString(PayResponseKeys.PENDING))
                }
                IntentConstants.USER_CANCELED_3D_SECURE_VERIFICATION_PARSING_ISSUE -> {
                    ToastMaker.displayShortToast(this,
                        "User canceled 3-d scure verification - Parsing Issue!!")

                    // Note that a payment process was attempted.
                    // User finished their payment successfully. An error occured while reading the returned JSON.
                    ToastMaker.displayShortToast(this,
                        extras!!.getString(IntentConstants.RAW_PAY_RESPONSE))

                }
            }


        }
        onBackPressed()
    }

    companion object {
        // Arbitrary number and used only in this activity. Change it as you wish.
        const val ACCEPT_PAYMENT_REQUEST = 10
    }
}