package com.codes_roots.imakeapp.presentaion

import android.app.Activity
import android.app.Dialog
import android.content.Context
import android.content.Intent
import android.net.Uri
import android.os.Bundle
import androidx.core.os.bundleOf
import androidx.fragment.app.Fragment
import com.codes_roots.imakeapp.R
import com.codes_roots.imakeapp.create_vendor_driver_account.create_driver_account_fragment.CreateDriverAccountFragment
import com.codes_roots.imakeapp.create_vendor_driver_account.create_vendor_account_fragment.CreateVendorAccountFragment

import com.codes_roots.imakeapp.helper.WARN_MotionToast
import com.codes_roots.imakeapp.presentaion.about_vendor.AboutVendorFragment
import com.codes_roots.imakeapp.presentaion.cartfragment.CartFragment
import com.codes_roots.imakeapp.presentaion.cartfragment.viewmodel.CartViewModel
import com.codes_roots.imakeapp.presentaion.contactus.ContactUsFragment
import com.codes_roots.imakeapp.presentaion.edit_address_fragment.EditAddressFragment
import com.codes_roots.imakeapp.presentaion.favouritefragment.FavouriteFragment
import com.codes_roots.imakeapp.presentaion.filterfragment.FilterFragment
import com.codes_roots.imakeapp.presentaion.homefragment.HomeFragment
import com.codes_roots.imakeapp.presentaion.itemdetails.ItemDetailsBottomSheet
import com.codes_roots.imakeapp.presentaion.itemdetails.ItemDetailsFragment
import com.codes_roots.imakeapp.presentaion.mainactivity.MainActivity
import com.codes_roots.imakeapp.presentaion.menufragment.MenuFragment
import com.codes_roots.imakeapp.presentaion.menufragment.staticfragment.StaticFragment
import com.codes_roots.imakeapp.presentaion.myaddress.AddressBottomFragment
import com.codes_roots.imakeapp.presentaion.myaddress.UserAddressesFragment
import com.codes_roots.imakeapp.presentaion.myorderDetails.AnswerFragment
import com.codes_roots.imakeapp.presentaion.myorderDetails.MyOrdersDetailsFragment
import com.codes_roots.imakeapp.presentaion.myorders.MyOrdersFragment
import com.codes_roots.imakeapp.presentaion.mypoints.PointsFragment
import com.codes_roots.imakeapp.presentaion.mywallet.WalletFragment
import com.codes_roots.imakeapp.presentaion.notification.NotificationFragment
import com.codes_roots.imakeapp.presentaion.paymentfragment.PaymentFragment
import com.codes_roots.imakeapp.presentaion.profilefragment.NewProfileFragment
import com.codes_roots.imakeapp.presentaion.ratefragment.RateFragment
import com.codes_roots.imakeapp.presentaion.register.RegisterActivity
import com.codes_roots.imakeapp.presentaion.reviews_fragment.ReviewsVendorFragment
import com.codes_roots.imakeapp.presentaion.vendordetailsfragment.VendorDetailsFragment
import com.codes_roots.imakeapp.presentaion.vendordetailsfragment.viewmodel.RestaurantDetailsViewModel
import com.codes_roots.imakeapp.presentaion.search_fragment.SearchFragment
import com.codes_roots.imakeapp.presentaion.stores_fragment.StoresFragment
import com.codes_roots.imakeapp.presentaion.stores_fragment.viewmodel.RestaurantsListViewModel
import com.codes_roots.imakeapp.presentaion.sortfragment.SortFragment
import com.codes_roots.imakeapp.presentaion.support.SupportFragment
import com.codes_roots.imakeapp.presentaion.wallet_details.WalletDetailsFragment
import com.codes_roots.imakeapp.presentaion.webview.WebViewActivity
import com.satafood.core.entities.addresses.UserAddressesItem
import com.satafood.core.entities.myorders.MyOrderModelItem
import com.satafood.core.entities.restaurantdetails.MenuCategoriesItem
import com.satafood.core.entities.static_pages.StaticPagesItem
import com.satafood.core.entities.support.Query
import kotlinx.android.synthetic.main.bottom_nav_content.*


class ClickHandler {
    fun Switch_to_Register_Activity(context: Context, activity: Activity) {
        (context as MainActivity).Pref.VendorId = 0
        (context).Pref.token = ""
        val i = Intent(context, RegisterActivity::class.java)
        (context).startActivityForResult(i, 10000)
    }
fun goToBranchLocation(context: Context,latitude:Double,longitude:Double){
    val uri =
        "http://maps.google.com/maps?saddr=" + (context as MainActivity).Pref.currentLatitude!! + "," + (context as MainActivity).Pref.currentLongitude!! + "&daddr=" + latitude + "," + longitude
    val intent = Intent(android.content.Intent.ACTION_VIEW, Uri.parse(uri))
    intent.setPackage("com.google.android.apps.maps")
    context.startActivity(intent)
}
    fun OpenMyAdressFragment(context: Context, dialog: Dialog) {
        context as MainActivity
        if (context.Pref.token.isNullOrEmpty()) {
            WARN_MotionToast(context.getString(R.string.loginFirst), context)
            val i = Intent(context, RegisterActivity::class.java)
            (context).startActivityForResult(i, 10000)
        } else {
            context as MainActivity
            checkForToken(context, AddressBottomFragment())
        }
        dialog.dismiss()
    }

    fun OpenMyAdressFragments(context: Context) {
        context as MainActivity
        if (context.Pref.token.isNullOrEmpty()) {
            WARN_MotionToast(context.getString(R.string.loginFirst), context)
            val i = Intent(context, RegisterActivity::class.java)
            (context).startActivityForResult(i, 10000)
        } else {
            context as MainActivity
            checkForToken(context, AddressBottomFragment())
        }

    }


    fun switchToMyAddressFragment(context: Context, id: Int?) {
        (context as MainActivity)
        val fragment = UserAddressesFragment()
        var bundle = Bundle()
        bundle.putInt("branch_id", id!!)
        fragment.arguments = bundle
        checkForToken(context, fragment)
    }


    fun OpenMyWalletFragment(context: Context, walletClickable: Boolean) {
        context as MainActivity
        if (context.Pref.token.isNullOrEmpty()) {
            WARN_MotionToast(context.getString(R.string.loginFirst), context)
            val i = Intent(context, RegisterActivity::class.java)
            (context).startActivityForResult(i, 10000)
        } else {
            val walletFragment = WalletFragment().apply {
                arguments = bundleOf("walletClickable" to walletClickable)
            }

            (context).supportFragmentManager.beginTransaction()
                .addToBackStack(null)
                .replace(R.id.main_frame, walletFragment).commit()
        }
    }

    fun OpenMyWalletFromMenu(context: Context, walletClickable: Boolean, dialog: Dialog) {
        context as MainActivity

        if (context.Pref.token.isNullOrEmpty()) {
            WARN_MotionToast(context.getString(R.string.loginFirst), context)
            val i = Intent(context, RegisterActivity::class.java)
            (context).startActivityForResult(i, 10000)
        } else {
            val walletFragment = WalletFragment().apply {
                arguments = bundleOf("walletClickable" to walletClickable)
            }

            (context).supportFragmentManager.beginTransaction()
                .addToBackStack(null)
                .replace(R.id.main_frame, walletFragment).commit()
        }
        dialog.dismiss()
    }

    fun OpenSupportFragment(context: Context, dialog: Dialog) {
        context as MainActivity
        if (context.Pref.token.isNullOrEmpty()) {
            WARN_MotionToast(context.getString(R.string.loginFirst), context)
            val i = Intent(context, RegisterActivity::class.java)
            (context).startActivityForResult(i, 10000)
        } else {

            (context).supportFragmentManager.beginTransaction()
                .addToBackStack(null)
                .replace(R.id.main_frame, SupportFragment()).commit()
        }
        dialog.dismiss()
    }

    fun OpenSupportFragment(context: Context) {
        context as MainActivity
        if (context.Pref.token.isNullOrEmpty()) {
            WARN_MotionToast(context.getString(R.string.loginFirst), context)
            val i = Intent(context, RegisterActivity::class.java)
            (context).startActivityForResult(i, 10000)
        } else {

            (context).supportFragmentManager.beginTransaction()
                .addToBackStack(null)
                .replace(R.id.main_frame, SupportFragment()).commit()
        }

    }


    fun openSortFragment(context: Context, viewModel: RestaurantsListViewModel) {
        val frag = SortFragment(viewModel)
        frag.apply {
            show((context as MainActivity).supportFragmentManager, SortFragment.TAG)
        }

    }

    fun openFilterFragment(context: Context, viewModel: RestaurantsListViewModel) {
        val frag = FilterFragment(viewModel)
        frag.apply {
            show((context as MainActivity).supportFragmentManager, FilterFragment.TAG)
        }

    }

    fun share(context: Context) {
        context as MainActivity
        if ((context).Pref.token.isNullOrEmpty()) {
            WARN_MotionToast((context).getString(R.string.loginFirst), context)
            val i = Intent(context, RegisterActivity::class.java)
            (context).startActivityForResult(i, 10000)
        } else {
            val intent = Intent(Intent.ACTION_SEND)
            val appLink = "https://play.google.com/store/apps/details?id=com.codesroots.cityrolls"
            val inviteContent = context.getString(R.string.inviteContent)
            val code = context.Pref.code + " " + context.getString(R.string.copyCode)
            val shareBody = appLink + "\n" + inviteContent + "\n" + code
            shareBody.lines()
            intent.type = "text/plain"
            intent.putExtra(Intent.EXTRA_SUBJECT,
                context.getString(R.string.app_name))
            intent.putExtra(Intent.EXTRA_TEXT, shareBody)
            context.startActivity(Intent.createChooser(intent,
                context.getString(R.string.app_name)))
        }
    }

    fun switchRestaurantsListFragment(CategoryId: Long, context: Context, title: String) {
        var fragment = StoresFragment((context as MainActivity).fragmentFactory,
            (context as MainActivity).Pref)
        var bundle = Bundle()
        bundle.putInt("CatId", CategoryId.toInt())
        bundle.putString("title", title)
        fragment.arguments = bundle
        SwitchBetweenFragments(context, fragment)
    }


    fun switchToSeeAllFragment(sectionName: String, context: Context, checkKey: String) {
        var fragment = StoresFragment((context as MainActivity).fragmentFactory,
            (context as MainActivity).Pref)
        var bundle = Bundle()
        bundle.putString("sectionName", sectionName)
        bundle.putString("checkKey", checkKey)
        fragment.arguments = bundle
        SwitchBetweenFragments(context, fragment)
    }

    fun switchRestaurantsDetailsFragmentFromBestSeller(
        RestaurantId: Long,
        area_id: Int,
        context: Context,
    ) {
        var fragment = VendorDetailsFragment((context as MainActivity).fragmentFactory)
        var bundle = Bundle()
        bundle.putInt("RestaurantـId", RestaurantId.toInt())
        bundle.putInt("area_id", area_id)
        fragment.arguments = bundle
        SwitchBetweenFragments(context, fragment)
    }

    fun switchRestaurantsDetailsFragment(RestaurantId: Long, context: Context) {
        var fragment = VendorDetailsFragment((context as MainActivity).fragmentFactory)
        var bundle = Bundle()
        bundle.putInt("RestaurantـId", RestaurantId.toInt())

        bundle.putInt("area_id", (context as MainActivity).Pref.areaId)

        fragment.arguments = bundle
        SwitchBetweenFragments(context, fragment)

    }

    fun switchRestaurantsDetailsFragmentList(
        RestaurantId: Long,
        area_id: Long,
        context: Context,
        storesFragment: StoresFragment,
    ) {
        storesFragment.viewModelStore
        var fragment = VendorDetailsFragment((context as MainActivity).fragmentFactory)
        var bundle = Bundle()
        bundle.putInt("RestaurantـId", RestaurantId.toInt())
        bundle.putInt("area_id", area_id.toInt())
        fragment.arguments = bundle
        SwitchBetweenFragments(context, fragment)

    }

    fun switchRestaurantsDetailsFragment(
        RestaurantId: Int,
        area_id: Int,
        category_id: Int,
        context: Context,
        storesFragment: HomeFragment,
    ) {
        storesFragment.viewModelStore
        var fragment = VendorDetailsFragment((context as MainActivity).fragmentFactory)
        var bundle = Bundle()
        bundle.putInt("RestaurantـId", RestaurantId)
        bundle.putInt("area_id", area_id)
        bundle.putInt("category_id", category_id)
        fragment.arguments = bundle
        SwitchBetweenFragments(context, fragment)

    }

    fun switchCartFragment(context: Context) {
        try {
            context as MainActivity
            checkForToken(context, CartFragment())
        } catch (e: Exception) {

        }
    }

    fun switchCartToReorder(context: Context, subtotal: Double?) {
        try {
            context as MainActivity
            val fragment = CartFragment()
            val bundle = Bundle()
            bundle.putDouble("subtotal", subtotal!!)
            fragment.arguments = bundle
            SwitchBetweenFragments(context, fragment)
        } catch (e: Exception) {

        }
    }

    fun switchAboutVendorFragment(context: Context, viewModel: RestaurantDetailsViewModel) {
        context as MainActivity
        enterFragments(context, AboutVendorFragment(viewModel))
    }


    fun switchEditAddressFragment(context: Context, data: UserAddressesItem) {
        (context as MainActivity)
        val fragment = EditAddressFragment()
        var bundle = Bundle()
        bundle.putSerializable("data", data)

        fragment.arguments = bundle
        context.supportFragmentManager.beginTransaction()
            .replace(R.id.main_frame, fragment).addToBackStack(null).commit()


    }

    fun switchReviewsVendorFragment(context: Context, viewModel: RestaurantDetailsViewModel) {
        context as MainActivity
        enterFragments(context, ReviewsVendorFragment(viewModel))
    }

    fun contactUsFragment(context: Context, dialog: Dialog) {
        context as MainActivity
        checkForToken(context, ContactUsFragment())
        dialog.dismiss()
    }

    fun contactUsFragment(context: Context) {
        context as MainActivity
        checkForToken(context, ContactUsFragment())
    }

    fun settingFragment(context: Context) {
        context as MainActivity
        checkForToken(context, MenuFragment())
    }

    fun addDriverFragment(context: Context, dialog: Dialog) {
        context as MainActivity
        SwitchBetweenFragments(context, CreateDriverAccountFragment())
        dialog.dismiss()
    }

    fun addVendorFragment(context: Context, dialog: Dialog) {
        context as MainActivity
        SwitchBetweenFragments(context, CreateVendorAccountFragment())
        dialog.dismiss()
    }


    fun switchMyOrdersFragment(context: Context, dialog: Dialog) {
        context as MainActivity
        checkForToken(context, MyOrdersFragment())
        dialog.dismiss()
    }

    fun switchMyOrdersFragment(context: Context) {
        context as MainActivity
        checkForToken(context, MyOrdersFragment())
    }

    fun switchNewProfileFragment(context: Context, dialog: Dialog?) {
        context as MainActivity
        checkForToken(context, NewProfileFragment())
        dialog!!.dismiss()
    }

    fun switchNewProfileFragment(context: Context) {
        context as MainActivity
        checkForToken(context, NewProfileFragment())
    }


    fun openPointsFromMenu(context: Context, dialog: Dialog) {
        context as MainActivity
        checkForToken(context, PointsFragment())
        dialog.dismiss()

    }

    fun openFavouriteFragment(context: Context, dialog: Dialog) {
        context as MainActivity
        checkForToken(context, FavouriteFragment(context.fragmentFactory))
        dialog.dismiss()

    }

    fun openItemDetailsFragment(
        context: Context,
        Item: MenuCategoriesItem,
        ResturantId: Int,
        viewModel: RestaurantDetailsViewModel, FromHome: Int,

        ) {
        if (Item.active != 0) {
            if (Item.menu_options_topics.isNullOrEmpty()) {
                if (Item.price != 0.0) {
                    val frag = ItemDetailsBottomSheet(viewModel)
                    var bundle = Bundle()
                    bundle.putSerializable("Item", Item)
                    bundle.putSerializable("FromHome", FromHome)
                    bundle.putInt("ResturantId", ResturantId)
                    frag.arguments = bundle
                    frag.apply {
                        show((context as MainActivity).supportFragmentManager, SortFragment.TAG)
                    }
                } else {
                    WARN_MotionToast(context.getString(R.string.available_plate),
                        context as MainActivity)
                }
            } else {
                (context as MainActivity)
                val fragment = ItemDetailsFragment(viewModel)
                var bundle = Bundle()
                bundle.putSerializable("Item", Item)
                bundle.putInt("ResturantId", ResturantId)
                fragment.arguments = bundle
                context.supportFragmentManager.beginTransaction()
                    .add(R.id.main_frame, fragment).addToBackStack(null).commit()
            }
        } else {
            WARN_MotionToast(context.getString(R.string.available_plate), context as MainActivity)
        }
    }


    fun openStaticFragment(context: Context, Item: StaticPagesItem) {
        (context as MainActivity)
        context.supportFragmentManager.beginTransaction()
            .replace(R.id.main_frame, StaticFragment(Item)).addToBackStack(null).commit()
    }

    fun openWebView(context: Context, url: String) {
        context as MainActivity
        if (url != null && url != "") {
            val intent = Intent(context, WebViewActivity::class.java)
            intent.putExtra("url", url)
            (context).startActivity(intent)
        } else {
            WARN_MotionToast(context.getString(R.string.emptyUrl), context)
        }
    }

    fun openOrderDetailsFragment(context: Context, Item: MyOrderModelItem) {
        (context as MainActivity)
        SwitchBetweenFragments(context, MyOrdersDetailsFragment(Item, context.fragmentFactory))
    }


    fun rateFragment(context: Context, Item: MyOrderModelItem) {
        (context as MainActivity)
        SwitchBetweenFragments(context, RateFragment(Item, context.fragmentFactory))
    }

    fun onBackPress(context: Context) {
        (context as MainActivity).onBackPressed()
    }


    fun switchToPaymentFragment(context: Context, CartItem: CartViewModel, total: Double) {
        context as MainActivity
        try {
            if (CartItem.data!![0].IsOpen == true) {
                if (context.Pref.UserId == 0) {
                    WARN_MotionToast(context.getString(R.string.loginFirst), context)
                    val i = Intent(context, RegisterActivity::class.java)
                    context.startActivityForResult(i, 100);
                } else {
                    if (CartItem.data!![0].min_order < total) {
                        enterFragments(context,
                            PaymentFragment(context.fragmentFactory, CartItem).apply {
                                arguments = bundleOf("total" to total)
                            })
                    } else {
                        WARN_MotionToast(context.getString(R.string.minimum).plus("  ")
                            .plus(CartItem.data!![0].min_order), context)
                    }
                }

            } else {
                WARN_MotionToast(context.getString(R.string.close), context)
            }
        } catch (e: Exception) {

        }
    }

    fun searchFragment(context: Context) {
        (context as MainActivity)
        SwitchBetweenFragments(context, SearchFragment())
    }


    fun logout(context: Context) {
        context as MainActivity
        context.Pref.UserId = 0
        context.Pref.token = null
        context.Pref.VendorId = 0
        context.Pref.userName = ""
        context.Pref.areaId = 0
        context.Pref.CityTileName = "قم بالضغط لتحديد المنطقة"
        //context.preferenceHelper.clearPreference()
        val i = Intent(context, RegisterActivity::class.java)
        (context).startActivityForResult(i, 10000)
    }

    fun logoutSideMenu(context: Context, dialog: Dialog) {
        context as MainActivity
        dialog.dismiss()
        context.Pref.UserId = 0
        context.Pref.token = null
        context.Pref.VendorId = 0
        context.Pref.BillingId = 0
        context.Pref.userName = null
        context.Pref.areaId = 0
        context.Pref.userPhoto = null
        context.Pref.CityTileName = "قم بالضغط لتحديد المنطقة"
        //context.preferenceHelper.clearPreference()
        val i = Intent(context, RegisterActivity::class.java)
        (context).startActivityForResult(i, 10000)


    }

    fun login(context: Context) {
        context as MainActivity
        val i = Intent(context, RegisterActivity::class.java)
        (context).startActivityForResult(i, 10000)
//        view.isVisible = false
    }

    fun loginSideMenu(context: Context, dialog: Dialog) {
        dialog.dismiss()
        context as MainActivity
        val i = Intent(context, RegisterActivity::class.java)
        (context).startActivityForResult(i, 10000)

    }

    fun switchToActivity(context: Context, activity: Activity) {
        try {
            val i = Intent(context, activity::class.java)
            (context).startActivity(i);
        } catch (e: Exception) {
        }
    }

    fun SwitchBetweenFragments(context: Context, fragment: Fragment) {
        (context as MainActivity)
        context.supportFragmentManager.beginTransaction()
            .setCustomAnimations(0, 0, 0, 0)
            .replace(R.id.main_frame, fragment).addToBackStack(null).commit()
    }

    fun switchBetweenFragmentsWithoutBack(context: Context, fragment: Fragment) {
        (context as MainActivity)
        context.supportFragmentManager.beginTransaction()
            .setCustomAnimations(0, 0, 0, 0)
            .replace(R.id.main_frame, fragment, "CompleteOrder").commit()
    }

    fun switchToForgentPassword(context: Context, fragment: Fragment) {
        (context as RegisterActivity)
        context.supportFragmentManager.beginTransaction()
            .setCustomAnimations(0, 0, 0, 0)
            .add(R.id.main_frame, fragment).addToBackStack(null).commit()
    }

    fun slideDownFragments(context: Context, fragment: Fragment) {
        (context as MainActivity)
        context.supportFragmentManager.beginTransaction()
            .setCustomAnimations(R.anim.slide_in_bottom,
                R.anim.slide_out_top,
                R.anim.slide_in_top,
                R.anim.slide_out_bottom)
            .replace(R.id.main_frame, fragment).addToBackStack(null).commit()
    }

    fun enterFragments(context: Context, fragment: Fragment) {
        (context as MainActivity)
        context.supportFragmentManager.beginTransaction()
            .setCustomAnimations(R.anim.slide_right,
                R.anim.exit_right_left,
                R.anim.slide_left,
                R.anim.exit_left_right)
            .replace(R.id.main_frame, fragment).addToBackStack(null).commit()
    }

    fun openAnswerFragment(context: Context, position: Int, data: Query? = null) {
        (context as MainActivity)
        val fragment = AnswerFragment()
        var bundle = Bundle()
        bundle.putInt("position", position)
        bundle.putSerializable("data", data)

        fragment.arguments = bundle
        context.supportFragmentManager.beginTransaction()
            .setCustomAnimations(R.anim.slide_in_bottom,
                R.anim.slide_out_top,
                R.anim.slide_in_top,
                R.anim.slide_out_bottom)
            .replace(R.id.main_frame, fragment).addToBackStack(null).commit()


    }

    fun SwitchToWalletDetailsFragment(context: Context, walletId: Int) {
        (context as MainActivity)
        val fragment = WalletDetailsFragment()
        var bundle = Bundle()
        bundle.putInt("walletId", walletId)
        fragment.arguments = bundle
        context.supportFragmentManager.beginTransaction()
            .replace(R.id.main_frame, fragment).addToBackStack(null).commit()
    }

    fun bottomNavItemSelected(context: Context, id: Int?, state: Boolean?) {
        try {
            (context as MainActivity).bottom_nav_bar.setItemSelected(id!!, state!!)
        } catch (e: Exception) {

        }
    }

    fun checkForToken(context: Context, fragment: Fragment): Boolean {
        context as MainActivity
        if ((context).Pref.token.isNullOrEmpty()) {
            WARN_MotionToast((context).getString(R.string.loginFirst), context)
            val i = Intent(context, RegisterActivity::class.java)
            (context).startActivityForResult(i, 100)
            return true
        } else
            SwitchBetweenFragments(context, fragment)
        return false
    }
}


