package com.codes_roots.imakeapp.presentaion

import android.app.Activity
import android.content.Context
import android.content.Intent
import android.graphics.Color
import android.os.Build
import androidx.annotation.ColorInt
import com.codes_roots.imakeapp.R
import com.codes_roots.imakeapp.presentaion.splash.SplashScreen


internal class ThemeColors(context: Context) {
    @ColorInt
    private val color: Int
    // Checking if title text color will be black
    private val isLightActionBar: Boolean
        private get() { // Checking if title text color will be black
            val rgb = (Color.red(color) + Color.green(color) + Color.blue(color)) / 3
            return rgb > 210
        }
    companion object {
        private const val NAME = "ThemeColors"
        private const val KEY = "color"
        fun setNewThemeColor(activity: Activity, red: Int, green: Int, blue: Int) {
            var red = red
            var green = green
            var blue = blue
            red = Math.round(red / 15.0f) * 15
            green = Math.round(green / 15.0f) * 15
            blue = Math.round(blue / 15.0f) * 15
            val stringColor = Integer.toHexString(Color.rgb(red, green, blue)).substring(2)
            val editor = activity.getSharedPreferences(NAME, Context.MODE_PRIVATE).edit()
            editor.putString(KEY, stringColor)
            editor.apply()
            if (Build.VERSION.SDK_INT >= Build.VERSION_CODES.HONEYCOMB) {
                val myIntent = Intent(activity, SplashScreen::class.java)
                activity.startActivity(myIntent)
            } else {
                val i = activity.packageManager.getLaunchIntentForPackage(activity.packageName)
                i!!.addFlags(Intent.FLAG_ACTIVITY_CLEAR_TOP)
                activity.startActivity(i)
            }
        }
    }

    init {
        val sharedPreferences = context.getSharedPreferences(NAME, Context.MODE_PRIVATE)
        val stringColor = sharedPreferences.getString(KEY, "004bff")
        color = Color.parseColor("#$stringColor")
        if (isLightActionBar)
            context.setTheme(R.style.AppTheme)
        context.setTheme(
            context.resources.getIdentifier(
                "T_$stringColor",
                "style",
                context.packageName
            )
        )
    }
}
