package com.codes_roots.imakeapp.presentaion.about_vendor

import android.os.Bundle
import android.view.LayoutInflater
import android.view.View
import android.view.ViewGroup
import androidx.databinding.DataBindingUtil
import androidx.fragment.app.Fragment
import androidx.lifecycle.ViewModelProvider
import com.codes_roots.imakeapp.R
import com.codes_roots.imakeapp.databinding.AboutVendorFragmentBinding
import com.codes_roots.imakeapp.helper.PreferenceHelper
import com.codes_roots.imakeapp.helper.WARN_MotionToast
import com.codes_roots.imakeapp.presentaion.mainactivity.MainActivity

import com.codes_roots.imakeapp.presentaion.vendordetailsfragment.viewmodel.RestaurantDetailsViewModel
import com.satafood.core.entities.paymentways.PaymentWaysItem
import javax.inject.Inject

class AboutVendorFragment @Inject constructor
    (var viewModel: RestaurantDetailsViewModel) : Fragment() {

    @Inject
    lateinit var viewModelFactory: ViewModelProvider.Factory
    var paymentWaysItem: ArrayList<PaymentWaysItem>? = null

    @Inject
    lateinit var Pref: PreferenceHelper
    lateinit var paymentWayAdapter: PaymentWayAdapter

    override fun onCreate(savedInstanceState: Bundle?) {

        super.onCreate(savedInstanceState)


    }

    private lateinit var view: AboutVendorFragmentBinding


    override fun onCreateView(
        inflater: LayoutInflater,
        container: ViewGroup?,
        savedInstanceState: Bundle?,
    ): View? {

        view = DataBindingUtil.inflate(inflater, R.layout.about_vendor_fragment, container, false)
        kotlin.runCatching {
            if (viewModel.data!=null){
            view.data = viewModel.data
            view.context = context as MainActivity
            view.description.apply {
                isSelected = true
                if (text == "")
                    viewModel.data!!.cuisines!!.forEachIndexed { index, cuisine ->
                        if (viewModel.data!!.cuisines!!.lastIndex != index)
                            append(cuisine.name + "-")
                        else append(cuisine.name)
                    }
            }
            }else {
                WARN_MotionToast(requireActivity().getString(R.string.errorOccurred),requireActivity())
            }
            view.backArrow.setOnClickListener {
                requireActivity().onBackPressed()
            }
        }.getOrElse {
            throw it
        }
        addPaymentWay()
        //setupPaymentWaysRecyclerView()


        return view.root
    }

    private fun addPaymentWay() {
        paymentWaysItem = ArrayList()
        paymentWaysItem!!.add(PaymentWaysItem(R.drawable.cash_method))
        paymentWaysItem!!.add(PaymentWaysItem(R.drawable.visa))
    }

//    private fun setupPaymentWaysRecyclerView() = view.cardsRecycleView.apply {
//        paymentWayAdapter = PaymentWayAdapter(context, paymentWaysItem!!)
//        adapter = paymentWayAdapter
//        view.cardsRecycleView.setHasFixedSize(true)
//
//    }

}




