package com.codes_roots.imakeapp.presentaion.add_address_fragment

import android.Manifest
import android.annotation.SuppressLint
import android.content.Context
import android.content.DialogInterface
import android.content.Intent
import android.content.pm.PackageManager
import android.location.Address
import android.location.Geocoder
import android.location.Location
import android.location.LocationManager
import android.os.Bundle
import android.os.Looper
import android.provider.Settings
import android.util.Log
import android.view.LayoutInflater
import android.view.View
import android.view.ViewGroup
import android.widget.ArrayAdapter
import android.widget.Toast
import androidx.appcompat.app.AlertDialog
import androidx.appcompat.app.AppCompatActivity
import androidx.core.content.ContextCompat
import androidx.databinding.DataBindingUtil
import androidx.fragment.app.Fragment
import androidx.fragment.app.FragmentFactory
import androidx.fragment.app.viewModels
import androidx.lifecycle.ViewModelProvider
import com.codes_roots.imakeapp.R
import com.codes_roots.imakeapp.databinding.AddAddressFragmentBinding
import com.codes_roots.imakeapp.helper.*
import com.codes_roots.imakeapp.presentaion.mainactivity.MainActivity
import com.codes_roots.imakeapp.presentaion.map_activity.viewmodel.MapViewModel
import com.codes_roots.imakeapp.presentaion.myaddress.cities.CitiesActivity
import com.codes_roots.imakeapp.presentaion.myaddress.viewmodel.UserAddressViewModel
import com.google.android.gms.common.ConnectionResult
import com.google.android.gms.common.api.GoogleApiClient
import com.google.android.gms.location.FusedLocationProviderClient
import com.google.android.gms.location.LocationCallback
import com.google.android.gms.location.LocationRequest
import com.google.android.gms.location.LocationServices
import com.google.android.gms.maps.CameraUpdateFactory
import com.google.android.gms.maps.GoogleMap
import com.google.android.gms.maps.GoogleMap.OnCameraIdleListener
import com.google.android.gms.maps.OnMapReadyCallback
import com.google.android.gms.maps.SupportMapFragment
import com.google.android.gms.maps.model.*
import com.google.android.gms.tasks.OnSuccessListener
import com.satafood.core.entities.addresses.UserAddressesItem
import kotlinx.android.synthetic.main.add_address_fragment.view.*
import java.io.IOException
import java.util.*
import javax.inject.Inject

class AddAdressFragment @Inject constructor(private val fragmentFactory: FragmentFactory) :
    Fragment(), OnMapReadyCallback,
    GoogleApiClient.ConnectionCallbacks, GoogleApiClient.OnConnectionFailedListener {

    private lateinit var view: AddAddressFragmentBinding
    val mapViewModel by viewModels<MapViewModel> { viewModelFactory }
    var intent1: Intent? = null

    @Inject
    lateinit var viewModelFactory: ViewModelProvider.Factory
    val viewModel by viewModels<UserAddressViewModel> { viewModelFactory }

    @Inject
    lateinit var Pref: PreferenceHelper
    private var place_ids: String? = null
    private var selectedPlaceId: String? = null

    var address = ""

    private lateinit var map: GoogleMap
    private val questionActivityCode = 1000
    internal lateinit var mLastLocation: Location
    internal lateinit var mLocationResult: LocationRequest
    private val REQUEST_LOCATION_PERMISSION = 1
    internal lateinit var mLocationCallback: LocationCallback
    internal var mCurrLocationMarker: Marker? = null
    internal var mGoogleApiClient: GoogleApiClient? = null
    internal lateinit var mLocationRequest: LocationRequest
    internal var mFusedLocationClient: FusedLocationProviderClient? = null
    private var mapReady = false
    var latitude: Double? = null //-33.867
    var longitude: Double? = null // 151.206
    val overlaySize = 100f
    var addresses: List<Address>? = null
    private val TAG = this::class.java.simpleName

    var isAllFieldsChecked = false

    override fun onCreate(savedInstanceState: Bundle?) {
        childFragmentManager.fragmentFactory = fragmentFactory
        super.onCreate(savedInstanceState)
        BaseApplication.appComponent.inject(this)
        mFusedLocationClient = LocationServices.getFusedLocationProviderClient(requireActivity())
    }

    override fun onCreateView(
        inflater: LayoutInflater, container: ViewGroup?, savedInstanceState: Bundle?,
    ): View? {
        view = DataBindingUtil.inflate(inflater, R.layout.add_address_fragment, container, false)
        view.userName.setText(Pref.userName)
        view.mobileNumber.setText(Pref.userPhone)
        view.addAddressBtn.setOnClickListener {
            isAllFieldsChecked = Validation().checkAllFields(view,requireContext())
            if (isAllFieldsChecked) {
                sendRequest()
            }else
                Error_MotionToast("أكمل البيانات", requireActivity())

        }
        try {
            val types =(context as MainActivity).resources.getStringArray(R.array.types)

            val spinner = view.spinnerType
            val adapter = ArrayAdapter(
                requireContext(),
                android.R.layout.simple_spinner_item, types
            )
            spinner.adapter = adapter


        }catch (e:Exception){}


        viewModel.AddAddressesLD?.observe(requireActivity()) {
            if (it != null) {
                SUCCESS_MotionToast(
                    requireActivity().getString(R.string.success),
                    requireActivity()
                )
                requireActivity().onBackPressed()

            } else
                Error_MotionToast("أكمل البيانات", requireActivity())
        }
        return view.root
    }




    @SuppressLint("MissingPermission")
    override fun onViewCreated(view: View, savedInstanceState: Bundle?) {
        super.onViewCreated(view, savedInstanceState)

        val mapFragment = childFragmentManager.findFragmentById(R.id.usermap) as SupportMapFragment?

        mapFragment!!.getMapAsync(this)
        view.changeAreaBtn.setOnClickListener { openSomeActivityForResult() }
        mapViewModel.PlaceID.observe(requireActivity(), androidx.lifecycle.Observer {
            it.results.map {
                if (it.types.first() == "administrative_area_level_3")
                {
                    Pref.latitude = it.geometry.location.lat.toString()
                    latitude = it.geometry.location.lat
                    Pref.longitude = it.geometry.location.lng.toString()
                    longitude = it.geometry.location.lng

                    Pref.googleID = it.place_id

                    Log.i("", " it.place_id: " + it)

                    Pref.userLocation = it.address_components[2].long_name +'-'+ it.address_components[1].long_name
                    view.chooseArea.text  = it.address_components[2].long_name +'-'+ it.address_components[1].long_name
                    //  place_ids = it.place_id

                    val gcd = Geocoder(context, Locale.getDefault())
                    try {
                        addresses = gcd.getFromLocation(it.geometry.location.lat!!, it.geometry.location.lng!!, 1)
                        if (place_ids != null) {
                            place_ids = null
                            selectedPlaceId = null
                            val latLng = LatLng(it.geometry.location.lat, it.geometry.location.lng)
//
                            map.animateCamera(CameraUpdateFactory.newLatLng(latLng))

                        }
                    } catch (e: IOException) {
                        e.printStackTrace()
                    }
//
                }else if (it.types.first() == "postal_code") {
                    Pref.userLocation = it.address_components.first().long_name
                }else
                    if(it.types.first() == "street_address"){

                        view.area.setText(it.formatted_address)

                    }
            }
        })


    }

    override fun onActivityResult(requestCode: Int, resultCode: Int, data: Intent?) {
        if (requestCode == questionActivityCode) {
            if (data != null) {
                val name = data.getStringExtra("name")

                selectedPlaceId = data.getStringExtra("place_id")
                place_ids = data.getStringExtra("place_id")

                view.chooseArea.text = name

        //        getLocationAddress(selectedPlaceId!!,"placeid")

            } else
                WARN_MotionToast(requireActivity().getString(R.string.changeArea),
                    requireActivity())
            // onBackPressed();
        }
    }
//
//    fun getLocationAddress(value:String,type:String) {
//        if (selectedPlaceId != null) {
//            mapViewModel.getPlaceIdByGeoCode(selectedPlaceId!!,"en","placeid")
//        }else {
//            mapViewModel.getPlaceIdByGeoCode(value,"en",type)
//        }
//    }

    fun openSomeActivityForResult() {
        val i = Intent(context, CitiesActivity::class.java)
        (context as MainActivity).startActivityForResult(i, questionActivityCode)
    }

    override fun onMapReady(googleMap: GoogleMap) {
        map = googleMap
        map.clear()
        MapHelper().setPoiClick(map)
        MapHelper().setMapStyle(map, requireContext())

        statusCheck()

        if (MapHelper().CheckPermission(requireContext())) {
            if (MapHelper().isLocationEnabled(requireContext())) {
                enableMyLocation(requireContext())

            } else {
                MapHelper().RequestPermission(requireContext())
                Toast.makeText(
                    requireContext(),
                    "Please Turn on Your device Location",
                    Toast.LENGTH_LONG
                ).show()
            }
        } else {

            MapHelper().RequestPermission(requireContext())

        }

    }

    fun statusCheck() {
        val manager: LocationManager = requireActivity().getSystemService(AppCompatActivity.LOCATION_SERVICE) as LocationManager
        if (!manager.isProviderEnabled(LocationManager.GPS_PROVIDER)) {
            buildAlertMessageNoGps()
        }
    }

    fun gpsStatus() {
        intent1 = Intent(Settings.ACTION_LOCATION_SOURCE_SETTINGS)
        startActivity(intent1)
    }

    private fun buildAlertMessageNoGps() {
        val builder: AlertDialog.Builder = AlertDialog.Builder(requireContext())
        builder.setMessage("Your GPS seems to be disabled, do you want to enable it?")
            .setCancelable(false)
        builder.setPositiveButton(android.R.string.yes, positiveButtonClick)
        builder.setNegativeButton(android.R.string.no, negativeButtonClick)
        val alert: AlertDialog = builder.create()
        alert.show()
    }
    val positiveButtonClick = { dialog: DialogInterface, which: Int ->
        gpsStatus()
    }
    val negativeButtonClick = { dialog: DialogInterface, which: Int ->
        dialog.cancel()
    }

    @SuppressLint("MissingPermission")
    private fun getLocationPermission() {
        if (MapHelper().CheckPermission(requireContext())) {
            mFusedLocationClient?.lastLocation?.addOnSuccessListener(requireActivity(),
                OnSuccessListener<Location?> { location ->
                    // Got last known location. In some rare situations this can be null.
                    if (location != null) {
                        latitude = location.latitude
                        longitude = location.longitude
                        goToAddress(latitude!!, longitude!!)
                    }

                })
        } else {
            MapHelper().RequestPermission(requireContext())
        }
    }

    private fun goToAddress(mlatitude: Double, mLogitude: Double) {
        //  map.animateCamera(CameraUpdateFactory.newLatLngZoom(LatLng(mlatitude, mLogitude), 16.0f))
        map.setOnCameraIdleListener(GoogleMap.OnCameraIdleListener {
            latitude = map.cameraPosition.target.latitude
            longitude = map.cameraPosition.target.longitude
        //    getLocationAddress("${latitude!!},${longitude!!}","latlng")

        })

    }


    fun enableMyLocation(context: Context) {
        map.isMyLocationEnabled = true
        mFusedLocationClient!!.lastLocation.addOnCompleteListener { task ->
            val location: Location? = task.result
            if (location == null) {
                MapHelper().NewLocationData(context)
            } else {

                latitude = location.latitude
                longitude = location.longitude
                val homeLatLng = LatLng(latitude!!, longitude!!)
                val zoomLevel = 15f
                map.moveCamera(CameraUpdateFactory.newLatLngZoom(homeLatLng, zoomLevel))
                map.addMarker(MarkerOptions().position(homeLatLng))


                //   setMapLongClick(map)

                map.mapType = GoogleMap.MAP_TYPE_TERRAIN

                val googleOverlay = GroundOverlayOptions()
                    .image(BitmapDescriptorFactory.fromResource(R.drawable.android))
                    .position(homeLatLng, overlaySize)

                map.addGroundOverlay(googleOverlay)

            }
            Pref.currentLatitude = location?.latitude.toString()
            Pref.currentLongitude = location?.longitude.toString()

        }

    }

    override fun onConnected(bundle: Bundle?) {
        mLocationRequest = LocationRequest()
        mLocationRequest.interval = 1000
        mLocationRequest.fastestInterval = 1000
        mLocationRequest.priority = LocationRequest.PRIORITY_BALANCED_POWER_ACCURACY
        if (ContextCompat.checkSelfPermission(
                requireContext(),
                Manifest.permission.ACCESS_FINE_LOCATION
            ) == PackageManager.PERMISSION_GRANTED
        ) {
            mFusedLocationClient =
                LocationServices.getFusedLocationProviderClient(requireActivity())
            mFusedLocationClient?.requestLocationUpdates(
                mLocationRequest,
                mLocationCallback,
                Looper.myLooper()
            )
        }
    }


    override fun onConnectionSuspended(p0: Int) {
        Toast.makeText(requireActivity(), "connection suspended", Toast.LENGTH_SHORT).show()
    }


    override fun onConnectionFailed(p0: ConnectionResult) {
        Toast.makeText(requireActivity(), "connection failed", Toast.LENGTH_SHORT).show()
    }


    private fun sendRequest() {
        val addressInfo = UserAddressesItem(
            address = view.area.text.toString(),
            apartment_number = view.apartment.text.toString(),
            area_id = Pref.areaId.toString(),
            first_name = view.userName.text.toString(),
            address_type = view.spinnerType.selectedItem.toString(),
            phone = view.mobileNumber.text.toString(),
            latitude = latitude,
            longitude = longitude,
            user_id = Pref.UserId,
            floor_number = view.floor.text.toString(),
            building_number = view.homeNum.text.toString(),
            place_id = Pref.googleID,
        )

        viewModel.addUsersAddress(addressInfo)
    }


    override fun onResume() {
        super.onResume()
        getLocationPermission()
    }

}