package com.codes_roots.imakeapp.presentaion.add_address_fragment

import android.content.Context
import android.view.LayoutInflater
import android.view.View
import android.view.ViewGroup
import android.widget.AdapterView
import android.widget.ArrayAdapter
import android.widget.TextView
import com.codes_roots.imakeapp.R

import com.satafood.core.entities.addresses.Type


class TypeAdapter(
    context: Context,
    private var cities: List<Type> = listOf(),
    private val onItemClick: (Type?) -> Unit
) : ArrayAdapter<Type>(context, R.layout.row_item_spinner, cities), AdapterView.OnItemSelectedListener {

    override fun getView(position: Int, convertView: View?, parent: ViewGroup): View {
        return initView(position, convertView, parent)
    }

    override fun getDropDownView(position: Int, convertView: View?, parent: ViewGroup): View {
        return initView(position, convertView, parent)
    }

    private fun initView(
        position: Int,
        convertView: View?,
        parent: ViewGroup
    ): View {
        val view: View
        val viewHolder: ViewHolder
        if (convertView == null) {
            view =
                LayoutInflater.from(context).inflate(R.layout.row_item_spinner, parent, false)
            viewHolder = ViewHolder(view)
            view.tag = viewHolder
        } else {
            view = convertView
            viewHolder = view.tag as ViewHolder
        }

        if(position == 0)
            viewHolder.bind(context.getString(R.string.select_address_type))
        else
            viewHolder.bind(getItem(position - 1)!!)

        return view
    }

    override fun getItem(position: Int): Type? {
        if(cities.isEmpty())
            return null
        return cities[position]
    }

    override fun getCount(): Int {
        return cities.size + 1
    }

    fun submitList(cities: List<Type>) {
        this.cities = cities
        notifyDataSetChanged()
    }

    private inner class ViewHolder(val view: View) {
        val tvCityName: TextView = view.findViewById(R.id.tv_name)

        fun bind(city: Type) {
            city.apply {
                tvCityName.text = name
            }

        }
        fun bind(text: String) {
            tvCityName.text = text
        }
    }

    override fun onItemSelected(p0: AdapterView<*>?, p1: View?, position: Int, p3: Long) {
        if(position > 0)
            onItemClick(getItem(position - 1))
    }

    override fun onNothingSelected(p0: AdapterView<*>?) {}
}