package com.codes_roots.imakeapp.presentaion.cartfragment.mvi

import com.satafood.core.entities.google.GoogleModel
import com.satafood.core.entities.restaurantdetails.MenuCategoriesItem


sealed class CartIntents(
    open val viewState: CartViewState? = null,
    open val restaurantId: Int? = null,
    open val areaId: Int? = null,
    open val ItemList: Array<Int>? = null,
    open val item: MenuCategoriesItem? = null,
    open val index: Int? = null,
    open val googleModel: GoogleModel? = null,
) {

    class LoadData(
        override val viewState: CartViewState,
        override val restaurantId: Int?,
        override val areaId: Int?,
        override val ItemList: Array<Int>,

    ) : CartIntents()

    class AddItem(
        override val viewState: CartViewState? = null,
        override val item: MenuCategoriesItem, override val index: Int,
    ) : CartIntents()


    class RemoveItem(
        override val viewState: CartViewState? = null,
        override val item: MenuCategoriesItem,
        override val index: Int,
    ) : CartIntents()

    class MinusItem(
        override val viewState: CartViewState? = null,
        override val item: MenuCategoriesItem,
        override val index: Int,
    ) : CartIntents()

    class DisplayErrors(override val viewState: CartViewState) : CartIntents()

    class NoItem(override val viewState: CartViewState) : CartIntents()


}
