package com.codes_roots.imakeapp.presentaion.choose_language


import android.net.Uri
import android.os.Bundle
import android.view.View
import android.widget.VideoView
import androidx.appcompat.app.AppCompatActivity
import androidx.appcompat.app.AppCompatDelegate
import com.codes_roots.imakeapp.R
import com.codes_roots.imakeapp.helper.PreferenceHelper
import com.codes_roots.imakeapp.helper.ResourceUtil
import com.codes_roots.imakeapp.helper.SUCCESS_MotionToast
import com.codes_roots.imakeapp.presentaion.ClickHandler
import com.codes_roots.imakeapp.presentaion.splash.SplashScreen

import dagger.android.AndroidInjection
import dagger.android.AndroidInjector
import dagger.android.DispatchingAndroidInjector
import dagger.android.HasAndroidInjector
import kotlinx.android.synthetic.main.fragment_language.*
import java.util.*

import javax.inject.Inject


class LanguageActivity @Inject constructor() : AppCompatActivity(), HasAndroidInjector {


    @Inject
    lateinit var Pref: PreferenceHelper

    var isClicked: Boolean = false

    override fun onCreate(savedInstanceState: Bundle?) {
        AndroidInjection.inject(this@LanguageActivity)
        super.onCreate(savedInstanceState)
        setContentView(R.layout.fragment_language)
        AppCompatDelegate.setDefaultNightMode(AppCompatDelegate.MODE_NIGHT_NO)


        val simpleVideoView = findViewById<View>(R.id.simpleVideoView) as VideoView
        // set the absolute path of the video file which is going to be played
        simpleVideoView.setVideoURI(
            Uri.parse(
                "android.resource://"
                        + packageName + "/" + R.raw.sataf2
            )
        )

        simpleVideoView.requestFocus()

        // starting the video
        simpleVideoView.start()
        bt_language_ar.setOnClickListener {
            ResourceUtil().changeLang("ar", this)
            Pref.lang = "ar"
            Pref.langChosen = true
            var   myLocale = Locale("ar")
            Locale.setDefault(myLocale)
            SUCCESS_MotionToast(Locale.getDefault().getLanguage(),this)

            it.backgroundTintList = getColorStateList(R.color.light_orange)
            bt_language_en.backgroundTintList = getColorStateList(R.color.dish_details_linear_bg)
            ClickHandler().switchToActivity(this, SplashScreen())

        }

        bt_language_en.setOnClickListener {
            it.backgroundTintList = getColorStateList(R.color.light_orange)
            Pref.lang = "en"
            Pref.langChosen = true
          var   myLocale = Locale("en")
            Locale.setDefault(myLocale)

            SUCCESS_MotionToast(Locale.getDefault().getLanguage(),this)

            ResourceUtil().changeLang("en", this)
            bt_language_ar.backgroundTintList = getColorStateList(R.color.dish_details_linear_bg)
            ClickHandler().switchToActivity(this, SplashScreen())

        }



    }

//    private fun noColoredView() {
//        whiteView(bt_language_en)
//        whiteView(bt_language_ar)
//    }
//
//    private fun coloredView(view: View) {
////        view.backgroundTintList(ContextCompat
////            .getColor(this, R.color.light_orange))
//       // view.background = AppCompatResources.getDrawable(this, R.drawable.language_orange_bg)
//    }
//
//    private fun whiteView(view: View) {
//        view.setBackgroundColor(ContextCompat
//            .getColor(this, R.color.white))
//    }

    @Inject
    lateinit var androidInjector: DispatchingAndroidInjector<Any>
    override fun androidInjector(): AndroidInjector<Any> {
        return androidInjector
    }

}