package com.codes_roots.imakeapp.presentaion.confirmedfragment

import android.os.Bundle
import android.view.LayoutInflater
import android.view.View
import android.view.ViewGroup
import androidx.databinding.DataBindingUtil
import androidx.fragment.app.Fragment
import androidx.fragment.app.viewModels
import androidx.lifecycle.ViewModelProvider
import com.codes_roots.imakeapp.R
import com.codes_roots.imakeapp.databinding.ConfirmedFragmentBinding
import com.codes_roots.imakeapp.helper.BaseApplication
import com.codes_roots.imakeapp.helper.PreferenceHelper
import com.codes_roots.imakeapp.helper.setImageResource
import com.codes_roots.imakeapp.presentaion.ClickHandler
import com.codes_roots.imakeapp.presentaion.cartfragment.viewmodel.CartViewModel
import com.codes_roots.imakeapp.presentaion.myorders.MyOrdersFragment
import javax.inject.Inject

class ConfirmedFragment : Fragment() {

    private lateinit var view: ConfirmedFragmentBinding

    @Inject
    lateinit var viewModelFactory: ViewModelProvider.Factory

    @Inject
    lateinit var Pref: PreferenceHelper

    val viewModel by viewModels<CartViewModel> { viewModelFactory }

    override fun onCreate(savedInstanceState: Bundle?) {
        super.onCreate(savedInstanceState)
        BaseApplication.appComponent.inject(this)

    }

    override fun onCreateView(
        inflater: LayoutInflater, container: ViewGroup?, savedInstanceState: Bundle?,
    ): View? {

        view = DataBindingUtil.inflate(inflater, R.layout.confirmed_fragment, container, false)
        setImageResource(view.img, Pref.appLogo)

        view.detailsButton.setOnClickListener {
            ClickHandler().SwitchBetweenFragments(requireContext(), MyOrdersFragment())
        }

        setImageResource(view.img, Pref.appLogo)

        return view.root
    }


}