package com.codes_roots.imakeapp.presentaion.contactus

import android.content.ActivityNotFoundException
import android.content.Intent
import android.graphics.Color
import android.graphics.PorterDuff
import android.os.Bundle
import android.view.LayoutInflater
import android.view.View
import android.view.ViewGroup
import android.widget.Toast
import androidx.databinding.DataBindingUtil
import androidx.fragment.app.Fragment
import androidx.fragment.app.viewModels
import androidx.lifecycle.ViewModelProvider
import com.codes_roots.imakeapp.R
import com.codes_roots.imakeapp.databinding.ContactUsFramgentBinding
import com.codes_roots.imakeapp.helper.BaseApplication
import com.codes_roots.imakeapp.helper.PreferenceHelper
import com.codes_roots.imakeapp.helper.SUCCESS_MotionToast
import com.codes_roots.imakeapp.presentaion.support.SupportViewModel
import com.satafood.core.entities.support.Complaints
import javax.inject.Inject

class ContactUsFragment @Inject constructor() : Fragment() {

    @Inject
    lateinit var Pref: PreferenceHelper

    @Inject
    lateinit var viewModelFactory: ViewModelProvider.Factory
    lateinit var view: ContactUsFramgentBinding
    val viewModel by viewModels<SupportViewModel> { viewModelFactory }

    override fun onCreate(savedInstanceState: Bundle?) {
        super.onCreate(savedInstanceState)
        if (savedInstanceState == null) {
            BaseApplication.appComponent.inject(this)
        }
    }

    override fun onCreateView(
        inflater: LayoutInflater, container: ViewGroup?,
        savedInstanceState: Bundle?,
    ): View? {
        view = DataBindingUtil.inflate(
            inflater,
            R.layout.contact_us_framgent, container, false
        )


        view.topHalf.background.setColorFilter(
            Color.parseColor(Pref.appPrimaryColor),
            PorterDuff.Mode.SRC_ATOP
        )
        view.sendComplain.background.setColorFilter(
            Color.parseColor(Pref.appPrimaryColor),
            PorterDuff.Mode.SRC_ATOP
        )


        view.sendComplain.setOnClickListener {
            val data = Complaints(
                user_id = Pref.UserId,
                title = view.complainAddress.text.toString(),
                message = view.complainDetails.text.toString(),
                vendor_id = Pref.restaurantId
            )
            viewModel.addComplaints(data)
            view.loading = true
        }

        viewModel.compalaintsLD.observe(requireActivity()) {
            if (it != null) {
                requireActivity().onBackPressed()
                view.loading = false
                SUCCESS_MotionToast(
                    requireActivity().getString(R.string.doneComplain),
                    requireActivity()
                )
            }
        }


        return view.root
    }


}





