package com.codes_roots.imakeapp.presentaion.edit_address_fragment

import android.Manifest
import android.annotation.SuppressLint
import android.content.Context
import android.content.Intent
import android.content.pm.PackageManager
import android.location.Address
import android.location.Geocoder
import android.location.Location
import android.os.Bundle
import android.os.Looper
import android.util.Log
import android.view.LayoutInflater
import android.view.View
import android.view.ViewGroup
import android.widget.ArrayAdapter
import android.widget.Toast
import androidx.core.content.ContextCompat
import androidx.databinding.DataBindingUtil
import androidx.fragment.app.Fragment
import androidx.fragment.app.viewModels
import androidx.lifecycle.ViewModelProvider
import com.codes_roots.imakeapp.R
import com.codes_roots.imakeapp.helper.*
import com.codes_roots.imakeapp.presentaion.mainactivity.MainActivity
import com.codes_roots.imakeapp.presentaion.myaddress.cities.CitiesActivity
import com.codes_roots.imakeapp.presentaion.myaddress.viewmodel.UserAddressViewModel
import com.google.android.gms.common.ConnectionResult
import com.google.android.gms.common.api.GoogleApiClient
import com.google.android.gms.location.FusedLocationProviderClient
import com.google.android.gms.location.LocationCallback
import com.google.android.gms.location.LocationRequest
import com.google.android.gms.location.LocationServices
import com.google.android.gms.maps.CameraUpdateFactory
import com.google.android.gms.maps.GoogleMap
import com.google.android.gms.maps.GoogleMap.OnCameraIdleListener
import com.google.android.gms.maps.OnMapReadyCallback
import com.google.android.gms.maps.SupportMapFragment
import com.google.android.gms.maps.model.*
import com.google.android.gms.tasks.OnSuccessListener
import com.codes_roots.imakeapp.databinding.EditAddressFragmentBinding
import com.codes_roots.imakeapp.presentaion.map_activity.viewmodel.MapViewModel
import com.satafood.core.entities.addresses.UserAddressesItem
import kotlinx.android.synthetic.main.add_address_fragment.view.*
import java.io.IOException
import java.util.*
import javax.inject.Inject

class EditAddressFragment @Inject constructor() :
    Fragment(), OnMapReadyCallback,
    GoogleApiClient.ConnectionCallbacks, GoogleApiClient.OnConnectionFailedListener {

    private lateinit var view: EditAddressFragmentBinding


    @Inject
    lateinit var viewModelFactory: ViewModelProvider.Factory


    @Inject
    lateinit var Pref: PreferenceHelper


    val viewModel by viewModels<UserAddressViewModel> { viewModelFactory }
    val mapViewModel by viewModels<MapViewModel> { viewModelFactory }
    var intent1: Intent? = null

    var address = ""
    var areaId = 0
    private var place_ids: String? = null
    private var selectedPlaceId: String? = null

    private lateinit var map: GoogleMap

    internal lateinit var mLocationCallback: LocationCallback
    internal lateinit var mLocationRequest: LocationRequest
    internal var mFusedLocationClient: FusedLocationProviderClient? = null
    var latitude: Double? = null //-33.867
    var longitude: Double? = null // 151.206
    val overlaySize = 100f
    var data: UserAddressesItem? = null

    var addresses: List<Address>? = null

    var isAllFieldsChecked = false

    override fun onCreate(savedInstanceState: Bundle?) {

        super.onCreate(savedInstanceState)
        BaseApplication.appComponent.inject(this)
        mFusedLocationClient = LocationServices.getFusedLocationProviderClient(requireActivity())


    }

    override fun onCreateView(
        inflater: LayoutInflater, container: ViewGroup?, savedInstanceState: Bundle?,
    ): View? {
        view = DataBindingUtil.inflate(inflater, R.layout.edit_address_fragment, container, false)

        data = arguments?.get("data") as UserAddressesItem

        view.userName.setText(Pref.userName)
        view.mobileNumber.setText(Pref.userPhone)
        view.addAddressBtn.setOnClickListener {
            isAllFieldsChecked =
                EditAddressFragmentValidation().checkAllFields(view, requireContext());
            if (isAllFieldsChecked) {
                sendRequest()
            } else
                Error_MotionToast(
                    requireContext().getString(R.string.allFeildsRequired),
                    requireActivity()
                )
        }
        try {
            val types = (context as MainActivity).resources.getStringArray(R.array.types)
            val spinner = view.spinnerType
            val adapter = ArrayAdapter(
                requireContext(),
                android.R.layout.simple_spinner_item, types
            )
            spinner.adapter = adapter

        } catch (e: Exception) {
        }

        view.data = data
        areaId = Pref.areaId
        latitude = data?.latitude
        longitude = data?.longitude
        view.chooseArea.text = data?.areas?.name.toString()
        view.homeNum.setText(data?.building_number.toString())
        view.apartment.setText(data?.apartment_number.toString())
        view.floor.setText(data?.floor_number.toString())
        view.area.setText(data?.address.toString())
        place_ids = data?.place_id

        viewModel.AddAddressesLD?.observe(requireActivity()) {
            if (it != null) {
                SUCCESS_MotionToast(
                    requireActivity().getString(R.string.success),
                    requireActivity()
                )
                requireActivity().onBackPressed()

            } else
                Error_MotionToast("أكمل البيانات", requireActivity())
        }

        return view.root
    }


    @SuppressLint("MissingPermission")
    override fun onViewCreated(view: View, savedInstanceState: Bundle?) {
        super.onViewCreated(view, savedInstanceState)
        val mapFragment = childFragmentManager.findFragmentById(R.id.usermap) as SupportMapFragment?
        mapFragment!!.getMapAsync(this)
        view.changeAreaBtn.setOnClickListener { openSomeActivityForResult() }

        mapViewModel.PlaceID.observe(requireActivity(), androidx.lifecycle.Observer {
            it.results.map {
                if (it.types.first() == "administrative_area_level_3") {
                    Pref.latitude = it.geometry.location.lat.toString()
                    Pref.longitude = it.geometry.location.lng.toString()
                    Pref.googleID = it.place_id

                    place_ids = it.place_id

                    Pref.userLocation =
                        it.address_components[1].long_name + '-' + it.address_components.first().long_name
                    view.chooseArea.text =
                        it.address_components[1].long_name + '-' + it.address_components.first().long_name


                    val gcd = Geocoder(context, Locale.getDefault())
                    try {
                        addresses = gcd.getFromLocation(
                            it.geometry.location.lat!!,
                            it.geometry.location.lng!!,
                            1
                        )
                        if (addresses!!.size > 0) {
                            System.out.println(addresses!![0].getLocality())
                            //      view.streetName.setText(addresses!![0].featureName)
                            view.area.setText(addresses!![0].locality)

                        }
                    } catch (e: IOException) {
                        e.printStackTrace()
                    }
//
                } else if (it.types.first() == "postal_code") {
                    Pref.userLocation = it.address_components.first().long_name
                }
            }
        })

    }

    override fun onActivityResult(requestCode: Int, resultCode: Int, data: Intent?) {
        super.onActivityResult(requestCode, resultCode, data);
        if (requestCode == 2000) {
            if (data != null) {
                val name = data.getStringExtra("name")

                areaId = data.getIntExtra("area_id", Pref.areaId)

                selectedPlaceId = data.getStringExtra("place_id")


                view.chooseArea.text = name
                SUCCESS_MotionToast(
                    requireActivity().getString(R.string.edit),
                    requireActivity()
                )
            } else
                WARN_MotionToast(
                    requireActivity().getString(R.string.changeArea),
                    requireActivity()
                )
            // onBackPressed();
        }
    }

    fun openSomeActivityForResult() {
        val i = Intent(context, CitiesActivity::class.java)
        (context as MainActivity).startActivityForResult(i, 2000);
    }

    override fun onMapReady(googleMap: GoogleMap) {
        map = googleMap
        map.clear();
        MapHelper().setPoiClick(map)
        MapHelper().setMapStyle(map, requireContext())


        if (MapHelper().CheckPermission(requireContext()))
            if (MapHelper().isLocationEnabled(requireContext())) {
                enableMyLocation(requireContext())
                getLocationPermission()
            } else {

                Toast.makeText(
                    requireContext(),
                    "Please Turn on Your device Location",
                    Toast.LENGTH_SHORT
                ).show()
            } else {

            MapHelper().RequestPermission(requireContext())

        }

    }

    @SuppressLint("MissingPermission")
    private fun getLocationPermission() {
        if (MapHelper().CheckPermission(requireContext())
        ) {
            if (viewModel.state.subscriptionCount.value == 0){
                goToAddress(data?.latitude!!, data?.longitude!!)}
            else{
                mFusedLocationClient?.lastLocation?.addOnSuccessListener(requireActivity(),
                    OnSuccessListener<Location?> { location ->
                        // Got last known location. In some rare situations this can be null.
                        if (location != null) {
                            latitude = location.latitude
                            longitude = location.longitude
                            goToAddress(latitude!!, longitude!!)
                        }

                    })}

        } else {
            MapHelper().RequestPermission(requireContext())
        }
    }

    private fun goToAddress(mlatitude: Double, mLogitude: Double) {
        map.animateCamera(CameraUpdateFactory.newLatLngZoom(LatLng(mlatitude, mLogitude), 16.0f))
        map.setOnCameraIdleListener(GoogleMap.OnCameraIdleListener {
            latitude = map.cameraPosition.target.latitude
            longitude = map.cameraPosition.target.longitude

        })
    }



    @SuppressLint("MissingPermission")
    fun enableMyLocation(context: Context) {
        map.isMyLocationEnabled = true

    }

    override fun onConnectionSuspended(p0: Int) {
        Toast.makeText(requireActivity(), "connection suspended", Toast.LENGTH_SHORT).show()
    }
    override fun onConnectionFailed(p0: ConnectionResult) {
        Toast.makeText(requireActivity(), "connection failed", Toast.LENGTH_SHORT).show()
    }


    private fun sendRequest() {
        val addressInfo = UserAddressesItem(
            address = view.area.text.toString(),
            apartment_number = view.apartment.text.toString(),
            area_id = Pref.areaId.toString(),
            first_name = view.userName.text.toString(),
            phone = view.mobileNumber.text.toString(),
            user_id = Pref.UserId,
            address_type = view.spinnerType.selectedItem.toString(),
            place_id = place_ids,
            floor_number = view.floor.text.toString()
        )
        viewModel.editUsersAddress(data?.id!!, addressInfo)
    }

    override fun onConnected(bundle: Bundle?) {
        mLocationRequest = LocationRequest()
        mLocationRequest.interval = 1000
        mLocationRequest.fastestInterval = 1000
        mLocationRequest.priority = LocationRequest.PRIORITY_BALANCED_POWER_ACCURACY
        if (ContextCompat.checkSelfPermission(
                requireContext(),
                Manifest.permission.ACCESS_FINE_LOCATION
            ) == PackageManager.PERMISSION_GRANTED
        ) {
            mFusedLocationClient =
                LocationServices.getFusedLocationProviderClient(requireActivity())
            mFusedLocationClient?.requestLocationUpdates(
                mLocationRequest,
                mLocationCallback,
                Looper.myLooper()
            )
        }
    }
}