package com.codes_roots.imakeapp.presentaion.favouritefragment.adapter

import android.annotation.SuppressLint
import android.content.Context
import android.view.LayoutInflater
import android.view.ViewGroup
import androidx.databinding.DataBindingUtil
import androidx.recyclerview.widget.DiffUtil
import androidx.recyclerview.widget.ListAdapter
import androidx.recyclerview.widget.RecyclerView
import com.codes_roots.imakeapp.R
import com.codes_roots.imakeapp.databinding.FavouriteAdapterBinding
import com.codes_roots.imakeapp.helper.ShapeAppearanceModel
import com.codes_roots.imakeapp.presentaion.ClickHandler
import com.codes_roots.imakeapp.presentaion.favouritefragment.FavouriteFragment
import com.codes_roots.imakeapp.presentaion.favouritefragment.mvi.FavouriteViewModel
import com.codes_roots.imakeapp.presentaion.mainactivity.MainActivity
import com.satafood.core.entities.favourite.FavouriteModelItem

class Favourites_Adapter(
    var viewModel: FavouriteViewModel, var context: Context?,var favouriteFragment: FavouriteFragment
) :


    ListAdapter<FavouriteModelItem, BranchesViewHolder>(BranchesDiffCallback()) {

    override fun onCreateViewHolder(p0: ViewGroup, p1: Int): BranchesViewHolder {
        val binding: FavouriteAdapterBinding = DataBindingUtil.inflate(
            LayoutInflater.from(p0.context),
            R.layout.favourite_adapter, p0, false
        )
        ShapeAppearanceModel(context!!, binding.appCompatImageView)
        return BranchesViewHolder(binding)

    }

    override fun onBindViewHolder(holder: BranchesViewHolder, position: Int) {
        holder.bind(context, currentList[position])
holder.binding.favoriteIcon.setOnClickListener {
    viewModel.deleteFavortie(currentList[position].id!!)
    favouriteFragment.data!!.removeAt(position)
    notifyDataSetChanged()
}

    }

}

private class BranchesDiffCallback : DiffUtil.ItemCallback<FavouriteModelItem
        >() {

    override fun areItemsTheSame(
        oldItem: FavouriteModelItem, newItem: FavouriteModelItem
    ) =
        oldItem.id == newItem.id

    @SuppressLint("DiffUtilEquals")
    override fun areContentsTheSame(
        oldItem: FavouriteModelItem, newItem: FavouriteModelItem
    ) =
        oldItem == newItem
}


class BranchesViewHolder(
    val binding: FavouriteAdapterBinding
) : RecyclerView.ViewHolder(binding.root) {


    fun bind(context: Context?, data: FavouriteModelItem) {

        binding.listener = ClickHandler()
        binding.data = data
        binding.context = context as MainActivity?
    }


}
