package com.codes_roots.imakeapp.presentaion.favouritefragment.mvi


import com.codes_roots.imakeapp.presentaion.homefragment.viewmodel.UserError
import com.codes_roots.imakeapp.repository.homepage.DataRepo
import com.satafood.core.entities.favourite.FavouriteModelItem
import kotlinx.coroutines.flow.Flow
import kotlinx.coroutines.flow.first


/**
 * this is the model function in MVI, it's responsibility is to convert intents into views states
 */
suspend fun mapIntentToViewState(intent: MainIntent, Datarepo: DataRepo,
    loadMainData: suspend () -> Flow<Result<ArrayList<FavouriteModelItem>>> = { Datarepo.getFavorite(intent.userId!!) },
) = when (intent) {
    is MainIntent.Initialize -> proceedWithInitialize(loadMainData,intent)
    is MainIntent.ErrorDisplayed -> intent.viewState.copy(error = null)
    is MainIntent.AddFavorite -> TODO()
}


private suspend fun proceedWithInitialize(loadCart: suspend () -> Flow<Result<ArrayList<FavouriteModelItem>>>, intent:MainIntent): MainViewState {
    val response =   loadCart()
    val data = response.first()
    return runCatching {
        intent.viewState!!.copy(data = (data.getOrThrow()),noFavouriteYet = true, error = null, progress = false)
    }
        .getOrElse {
            intent.viewState!!.copy(error = UserError.NetworkError(it))
        }
}
private suspend fun proceedAddFavorite( AddFavorite : suspend () -> Flow<Result<Boolean>>   ,intent: com.codes_roots.imakeapp.presentaion.vendordetailsfragment.mvi.MainIntent
): com.codes_roots.imakeapp.presentaion.vendordetailsfragment.mvi.MainViewState
{
    var response =  AddFavorite().first()

    return runCatching {

        return intent.viewState!!.copy(IsFave = response.getOrThrow())
    }.getOrElse {
        intent.viewState!!.copy(Errors = UserError.NetworkError(it))

    }
}




