package com.codes_roots.imakeapp.presentaion.gallery_fragment

import android.os.Bundle
import android.view.LayoutInflater
import android.view.View
import android.view.ViewGroup
import androidx.databinding.DataBindingUtil
import androidx.fragment.app.Fragment
import androidx.fragment.app.viewModels
import androidx.lifecycle.ViewModelProvider
import com.codes_roots.imakeapp.R
import com.codes_roots.imakeapp.databinding.GalleryFragmentBinding
import com.codes_roots.imakeapp.helper.*
import com.codes_roots.imakeapp.presentaion.gallery_fragment.adapters.GalleryAdapter
import com.codes_roots.imakeapp.presentaion.gallery_fragment.viewmodel.GalleryViewModel

import com.satafood.core.entities.gallery.BranchesGalleryModelItem
import javax.inject.Inject

class GalleryFragment @Inject constructor() : Fragment() {

    @Inject
    lateinit var viewModelFactory: ViewModelProvider.Factory


    @Inject
    lateinit var Pref: PreferenceHelper
    lateinit var galleryAdapter: GalleryAdapter

    val viewModel by viewModels<GalleryViewModel> { viewModelFactory }

    override fun onCreate(savedInstanceState: Bundle?) {
        super.onCreate(savedInstanceState)
        BaseApplication.appComponent.inject(this)
    }

    private lateinit var view: GalleryFragmentBinding


    override fun onCreateView(
        inflater: LayoutInflater,
        container: ViewGroup?,
        savedInstanceState: Bundle?,
    ): View? {

        view = DataBindingUtil.inflate(inflater, R.layout.gallery_fragment, container, false)
        setupBranchesGalleryAdapter()
        kotlin.runCatching {
            viewModel.getBranchesLocation()
        }.getOrElse {
            throw it
        }

        viewModel.galleryBranchesLD!!.observe(viewLifecycleOwner) {
            setupBranchesGalleryRecyclerView(it)
        }



        return view.root
    }

    private fun setupBranchesGalleryRecyclerView(gallery: List<BranchesGalleryModelItem>) {
        if (!gallery.isNullOrEmpty()) {
            galleryAdapter.submitList(gallery)
//            binding.walletsAvailable = true
        } else {
//            binding.walletsAvailable = false
        }
    }
    private fun setupBranchesGalleryAdapter() {
        galleryAdapter = GalleryAdapter(requireContext(),{

        })
        view.galleriesRecycle.apply {
            adapter = galleryAdapter
            addItemDecoration(
                VerticalMarginItemDecoration(
                    dpToPx(10f, requireContext())
                )
            )
        }

    }

}




