package com.codes_roots.imakeapp.presentaion.gallery_fragment.adapters


import android.animation.Animator
import android.animation.AnimatorListenerAdapter
import android.animation.AnimatorSet
import android.animation.ObjectAnimator
import android.annotation.SuppressLint
import android.content.Context
import android.graphics.Point
import android.graphics.Rect
import android.graphics.RectF
import android.view.LayoutInflater
import android.view.View
import android.view.ViewGroup
import android.view.animation.DecelerateInterpolator
import android.widget.ImageView
import androidx.appcompat.widget.AppCompatImageView
import androidx.recyclerview.widget.DiffUtil
import androidx.recyclerview.widget.LinearLayoutManager
import androidx.recyclerview.widget.ListAdapter
import androidx.recyclerview.widget.RecyclerView
import com.codes_roots.imakeapp.R
import com.codes_roots.imakeapp.databinding.BranchesGalleryItemBinding
import com.codes_roots.imakeapp.databinding.QueryItemBinding
import com.codes_roots.imakeapp.presentaion.ClickHandler
import com.codes_roots.imakeapp.presentaion.mainactivity.MainActivity
import com.codes_roots.imakeapp.presentaion.support.SubmenuAdapter
import com.satafood.core.entities.gallery.BranchesGalleryModelItem


class GalleryAdapter(
    val context: Context,
    private val onItemClick: (BranchesGalleryModelItem) -> Unit
) :
    ListAdapter<BranchesGalleryModelItem, GalleryAdapter.GalleryViewHolder>(Companion) {

    companion object : DiffUtil.ItemCallback<BranchesGalleryModelItem>() {
        override fun areItemsTheSame(
            oldItem: BranchesGalleryModelItem,
            newItem: BranchesGalleryModelItem
        ): Boolean {
            return oldItem.id == newItem.id
        }

        override fun areContentsTheSame(
            oldItem: BranchesGalleryModelItem,
            newItem: BranchesGalleryModelItem
        ): Boolean {
            return oldItem.hashCode() == newItem.hashCode()
        }
    }

    override fun onCreateViewHolder(parent: ViewGroup, viewType: Int): GalleryViewHolder {
        val binding =
            BranchesGalleryItemBinding.inflate(LayoutInflater.from(parent.context), parent, false)
        return GalleryViewHolder(binding) {
            onItemClick(it)
        }
    }

    @SuppressLint("SetTextI18n")
    override fun onBindViewHolder(holder: GalleryViewHolder, position: Int) {
        val item = currentList[position]
        item?.let {
            holder.bind(it)
        }
        context as MainActivity
        holder.binding.apply {
            val photosAdapter = GalleryImagesAdapter(context as MainActivity)
            val galleryData = currentList[position]
            mainAddress.setOnClickListener {
                ClickHandler().goToBranchLocation((context as MainActivity),
                    currentList[position].latitude!!,currentList[position].longitude!!)

            }
            data = currentList[position]
            photosRecycle.adapter = photosAdapter
            photosRecycle.layoutManager =
                LinearLayoutManager(context, LinearLayoutManager.HORIZONTAL, false)
            photosAdapter.photosData = galleryData.gallery!!
            showGalleryBtn.setOnClickListener {
                expand = expand != true
                arrow = arrow != true
            }
        }
    }

    inner class GalleryViewHolder(
        var binding: BranchesGalleryItemBinding,
        private val onItemClick: (BranchesGalleryModelItem) -> Unit
    ) : RecyclerView.ViewHolder(binding.root) {
        init {
              binding.context = context as MainActivity
        }

        fun bind(item: BranchesGalleryModelItem) {
            item.apply {

            }
        }
    }

}