package com.codes_roots.imakeapp.presentaion.homefragment

import android.annotation.SuppressLint
import android.content.Context
import android.view.LayoutInflater
import android.view.ViewGroup
import androidx.databinding.DataBindingUtil
import androidx.recyclerview.widget.DiffUtil
import androidx.recyclerview.widget.ListAdapter
import androidx.recyclerview.widget.RecyclerView
import com.codes_roots.imakeapp.R
import com.codes_roots.imakeapp.databinding.BestCellAdapterBinding
import com.codes_roots.imakeapp.presentaion.ClickHandler
import com.codes_roots.imakeapp.presentaion.mainactivity.MainActivity
import com.satafood.core.mapper.homepage.MostOrderedBranchUseCase


class BestSell_Adapter : ListAdapter<MostOrderedBranchUseCase, BestSellViewHolder>(BestSellDiffCallback()) {
    var context: Context? = null


    override fun onCreateViewHolder(p0: ViewGroup, p1: Int): BestSellViewHolder {
        val binding: BestCellAdapterBinding = DataBindingUtil.inflate(
            LayoutInflater.from(p0.context), R.layout.best_cell_adapter, p0, false
        )


        return BestSellViewHolder(binding)
    }


    override fun onBindViewHolder(holder: BestSellViewHolder, position: Int) {
        holder.bind(context, currentList[position])

        try {

            holder.binding.description.apply {
                isSelected = true
              if (text == "")
                if (currentList[position].cuisines!!.isNotEmpty())
                    currentList[position].cuisines!!.map { cuisine -> holder.binding.description.append(cuisine!!.name + "-") }
                else
                    text = currentList[position].name
            }
        }catch (e:Exception){

        }
    }
}

class BestSellDiffCallback : DiffUtil.ItemCallback<MostOrderedBranchUseCase>() {

    override fun areItemsTheSame(oldItem: MostOrderedBranchUseCase, newItem: MostOrderedBranchUseCase) =
        oldItem.id == newItem.id
    @SuppressLint("DiffUtilEquals")
    override fun areContentsTheSame(oldItem: MostOrderedBranchUseCase, newItem: MostOrderedBranchUseCase) =
        oldItem == newItem
}

class BestSellViewHolder(
    val binding: BestCellAdapterBinding,
) : RecyclerView.ViewHolder(binding.root) {
    fun bind(context: Context?, data: MostOrderedBranchUseCase){
        binding.listener = ClickHandler()
        binding.data = data
        binding.context = context as MainActivity?
    }
}
