package com.codes_roots.imakeapp.presentaion.homefragment.adapters

import android.annotation.SuppressLint
import android.content.Context
import android.view.LayoutInflater
import android.view.ViewGroup
import androidx.databinding.DataBindingUtil
import androidx.recyclerview.widget.DiffUtil
import androidx.recyclerview.widget.ListAdapter
import androidx.recyclerview.widget.RecyclerView
import com.codes_roots.imakeapp.R
import com.codes_roots.imakeapp.databinding.BestItemAdapterBinding
import com.codes_roots.imakeapp.presentaion.ClickHandler
import com.codes_roots.imakeapp.presentaion.mainactivity.MainActivity
import com.satafood.core.mapper.homepage.MostSellItemUseCase


class Best_Item_Adapter(private val onItemClick: (MostSellItemUseCase) -> Unit) :
    ListAdapter<MostSellItemUseCase, Best_Item_Adapter.Best_ItemViewHolder>(Best_ItemDiffCallback()) {
    var context: Context? = null


    override fun onCreateViewHolder(p0: ViewGroup, p1: Int): Best_ItemViewHolder {
        val binding: BestItemAdapterBinding = DataBindingUtil.inflate(
            LayoutInflater.from(p0.context), R.layout.best_item_adapter, p0, false
        )
        return Best_ItemViewHolder(binding) {
            onItemClick(it)
        }
    }


    override fun onBindViewHolder(holder: Best_ItemViewHolder, position: Int) {
        holder.bind(context, currentList[position])
        try {

//            holder.binding.description.apply {
//                isSelected = true
//                text = currentList[position].descriptions
//
//            }
        } catch (e: Exception) {

        }
    }


    inner class Best_ItemViewHolder(
        val binding: BestItemAdapterBinding,
        private val onItemClick: (MostSellItemUseCase) -> Unit,
    ) : RecyclerView.ViewHolder(binding.root) {

        init {
            binding.root.setOnClickListener {
                onItemClick(currentList[adapterPosition])
            }
        }

        fun bind(context: Context?, data: MostSellItemUseCase) {
            binding.listener = ClickHandler()
            binding.data = data
            binding.pref = (context as MainActivity).Pref
            binding.context = context as MainActivity?
        }

    }
}

class Best_ItemDiffCallback : DiffUtil.ItemCallback<MostSellItemUseCase>() {

    override fun areItemsTheSame(oldItem: MostSellItemUseCase, newItem: MostSellItemUseCase) =
        oldItem.id == newItem.id

    @SuppressLint("DiffUtilEquals")
    override fun areContentsTheSame(oldItem: MostSellItemUseCase, newItem: MostSellItemUseCase) =
        oldItem == newItem
}


