package com.codes_roots.imakeapp.presentaion.homefragment.adapters

import android.annotation.SuppressLint
import android.content.Context
import android.graphics.ColorMatrix
import android.graphics.ColorMatrixColorFilter
import android.view.LayoutInflater
import android.view.ViewGroup
import android.widget.ImageView
import androidx.databinding.DataBindingUtil
import androidx.recyclerview.widget.DiffUtil
import androidx.recyclerview.widget.ListAdapter
import androidx.recyclerview.widget.RecyclerView
import com.codes_roots.imakeapp.R
import com.codes_roots.imakeapp.databinding.MainItemsAdapterBinding
import com.codes_roots.imakeapp.presentaion.ClickHandler
import com.codes_roots.imakeapp.presentaion.homefragment.HomeFragment
import com.codes_roots.imakeapp.presentaion.mainactivity.MainActivity
import com.satafood.core.mapper.homepage.CateogryUseCase


class Main_Adapter(val context: Context, var fragment: HomeFragment?) :
    ListAdapter<CateogryUseCase, CustomViewHolder>(
        ItemDiffCallback()
    ) {


    override fun onCreateViewHolder(p0: ViewGroup, p1: Int): CustomViewHolder {
        val binding: MainItemsAdapterBinding = DataBindingUtil.inflate(
            LayoutInflater.from(p0.context),
            R.layout.main_items_adapter, p0, false
        )

        return CustomViewHolder(binding)
    }

    // extension function to image view grayscale filter
    fun setLocked(v: ImageView) {
        val matrix = ColorMatrix()
        matrix.setSaturation(4f) //0 means grayscale
        val cf = ColorMatrixColorFilter(matrix)
        v.colorFilter = cf
        v.imageAlpha = 128 // 128 = 0.5
    }

    override fun onBindViewHolder(holder: CustomViewHolder, position: Int) {
        holder.bind(context, currentList[position], fragment!!)
        context as MainActivity
//        if (position >= 1){
//            //setLocked(holder.binding.appCompatImageView)
//            holder.binding.comingSoon.visibility = View.VISIBLE
//        }

        holder.binding.cardView.setOnClickListener {
            ClickHandler().switchRestaurantsDetailsFragment(currentList[position].RestauranthId!!, context.Pref.areaId,
               position, context, fragment!!)

//            if (position == 0){
//                holder.binding.listener?.switchRestaurantsListFragment(holder.binding.data?.id!!.toLong(), context, holder.binding.data?.name!!)
//
//            }
//            else {
//                InfoMotionToast(
//                    context.getString(R.string.comingSoon) + " " + currentList[position].name,
//                    context as MainActivity
//                )
//
//            }
        }
    }


    class ItemDiffCallback : DiffUtil.ItemCallback<CateogryUseCase>() {
        override fun areItemsTheSame(oldItem: CateogryUseCase, newItem: CateogryUseCase) =
            oldItem.id == newItem.id

        @SuppressLint("DiffUtilEquals")
        override fun areContentsTheSame(oldItem: CateogryUseCase, newItem: CateogryUseCase) =
            oldItem == newItem
    }


}

class CustomViewHolder(
    val binding: MainItemsAdapterBinding,
) : RecyclerView.ViewHolder(binding.root) {

    fun bind(context: Context?, data: CateogryUseCase, fragment: HomeFragment) {

        binding.listener = ClickHandler()
        binding.data = data
        binding.context = context as MainActivity?
        binding.pref = context!!.Pref
        binding.fragment = fragment
    }


}