package com.codes_roots.imakeapp.presentaion.homefragment

import android.annotation.SuppressLint
import android.content.Context
import android.view.LayoutInflater
import android.view.ViewGroup
import androidx.databinding.DataBindingUtil
import androidx.recyclerview.widget.DiffUtil
import androidx.recyclerview.widget.ListAdapter
import androidx.recyclerview.widget.RecyclerView
import com.codes_roots.imakeapp.R
import com.codes_roots.imakeapp.databinding.NearestStoreAdapterBinding
import com.codes_roots.imakeapp.presentaion.ClickHandler
import com.codes_roots.imakeapp.presentaion.mainactivity.MainActivity
import com.satafood.core.mapper.homepage.NearestBrancheUseCase


class Nearest_Store_Adapter : ListAdapter<NearestBrancheUseCase,NearestBrancheViewHolder>(NearestBrancheDiffCallback()) {
    var context: Context? = null


    override fun onCreateViewHolder(p0: ViewGroup, p1: Int): NearestBrancheViewHolder {
        val binding: NearestStoreAdapterBinding = DataBindingUtil.inflate(
            LayoutInflater.from(p0.context), R.layout.nearest_store_adapter, p0, false
        )


        return NearestBrancheViewHolder(binding)
    }


    override fun onBindViewHolder(holder: NearestBrancheViewHolder, position: Int) {
        holder.bind(context, currentList[position])


    }
}

class NearestBrancheDiffCallback : DiffUtil.ItemCallback<NearestBrancheUseCase>() {

    override fun areItemsTheSame(oldItem: NearestBrancheUseCase, newItem: NearestBrancheUseCase) =
        oldItem.id == newItem.id

    @SuppressLint("DiffUtilEquals")
    override fun areContentsTheSame(oldItem: NearestBrancheUseCase, newItem: NearestBrancheUseCase) =
        oldItem == newItem
}

class NearestBrancheViewHolder(
    val binding: NearestStoreAdapterBinding,
) : RecyclerView.ViewHolder(binding.root) {

    fun bind(context: Context?, data: NearestBrancheUseCase) {
        binding.listener = ClickHandler()
        binding.data = data
        binding.context = context as MainActivity?
    }


}
