package com.codes_roots.imakeapp.presentaion.homefragment.adapters

import android.app.Activity
import android.content.Context
import android.view.LayoutInflater
import android.view.View
import android.view.ViewGroup
import android.widget.ImageView
import com.bumptech.glide.Glide
import com.bumptech.glide.load.resource.drawable.DrawableTransitionOptions
import com.bumptech.glide.request.RequestOptions
import com.codes_roots.imakeapp.R
import com.codes_roots.imakeapp.helper.Constants
import com.codes_roots.imakeapp.helper.Error_MotionToast
import com.codes_roots.imakeapp.presentaion.ClickHandler
import com.satafood.core.entities.homepage.sliders.AdsSpacesprice
import com.smarteist.autoimageslider.SliderViewAdapter
import javax.inject.Inject


class NewSliderAdapter @Inject constructor(val context: Context, var images: List<AdsSpacesprice>, private val onItemClick: (Int,) -> Unit,) : SliderViewAdapter<NewSliderAdapter.Holder>() {

    override fun onCreateViewHolder(parent: ViewGroup): NewSliderAdapter.Holder {
        val view: View = LayoutInflater.from(parent.context)
            .inflate(R.layout.viewpagerslide_home, parent, false)
        return Holder(view)
    }

    override fun onBindViewHolder(viewHolder: NewSliderAdapter.Holder, position: Int) {
        //viewHolder.imageView.setImageResource(images[position].sliders!!.photo)
        val requestOptions = RequestOptions()
        requestOptions.error(R.drawable.empty_meal_2)
        val image = images[position]

        viewHolder.imageView.setOnClickListener {
          //  val restaurantId = image.sliders!!.restaurant_id
            val item_id = image.sliders!!.item_id
          //  if (item_id == 0 && restaurantId != null && restaurantId != 0) {
                //   ClickHandler().SwitchBetweenFragments(context,ItemDetailsFragment(context.restaurantViewModel))
             //   ClickHandler().switchRestaurantsDetailsFragment(restaurantId.toLong(), context)

         //   } else if (item_id != 0) {
                onItemClick(item_id!!)
                //   ClickHandler().SwitchBetweenFragments(context,ItemDetailsFragment(context.restaurantViewModel))

          //  } else
          //      Error_MotionToast("no data", context as Activity)
        }

        Glide.with(viewHolder.imageView.context)
            .load(Constants.IMAGE_URL + images[position].sliders!!.photo)
            .transition(DrawableTransitionOptions.withCrossFade())
            .apply(requestOptions)
            .fitCenter()
            .into(viewHolder.imageView)
    }

    override fun getCount(): Int {
        return images.size
    }

    inner class Holder(itemView: View) : ViewHolder(itemView) {
        var imageView: ImageView = itemView.findViewById(R.id.im_slider)

    }
}