package com.codes_roots.imakeapp.presentaion.homefragment.adapters

import android.annotation.SuppressLint
import android.content.Context
import android.os.Build
import android.view.LayoutInflater
import android.view.ViewGroup
import androidx.annotation.RequiresApi
import androidx.databinding.DataBindingUtil
import androidx.recyclerview.widget.DiffUtil
import androidx.recyclerview.widget.ListAdapter
import androidx.recyclerview.widget.RecyclerView
import com.codes_roots.imakeapp.R
import com.codes_roots.imakeapp.databinding.NewOfferAdapterBinding
import com.codes_roots.imakeapp.helper.ShapeAppearanceModel
import com.codes_roots.imakeapp.presentaion.ClickHandler
import com.codes_roots.imakeapp.presentaion.mainactivity.MainActivity
import com.satafood.core.mapper.homepage.MostSellItemUseCase
import com.satafood.core.mapper.homepage.OffersUseCase


class New_Offers_Adapter(private val onItemClick: (OffersUseCase) -> Unit) :
    ListAdapter<OffersUseCase, New_Offers_Adapter.OffersViewHolder>(
    OffersDiffCallback()
) {
    var context: Context? = null

    override fun onCreateViewHolder(p0: ViewGroup, p1: Int): OffersViewHolder {
        val binding: NewOfferAdapterBinding = DataBindingUtil.inflate(
            LayoutInflater.from(p0.context), R.layout.new_offer_adapter, p0, false
        )
         ShapeAppearanceModel(context!!, binding.cover)
        return OffersViewHolder(binding){
            onItemClick(it)
        }
    }
    @RequiresApi(Build.VERSION_CODES.S)
    override fun onBindViewHolder(holder: OffersViewHolder, position: Int){
        holder.bind(context, currentList[position])

}

inner class OffersViewHolder(
    val binding: NewOfferAdapterBinding,
    private val onItemClick: (OffersUseCase) -> Unit,
) : RecyclerView.ViewHolder(binding.root) {
    init {
        binding.root.setOnClickListener {
            onItemClick(currentList[adapterPosition])
        }
    }

    fun bind(context: Context?, data: OffersUseCase) {
        binding.listener = ClickHandler()
        binding.data = data
        binding.context = context as MainActivity?
    }
}
}
class OffersDiffCallback : DiffUtil.ItemCallback<OffersUseCase>() {

    override fun areItemsTheSame(oldItem: OffersUseCase, newItem: OffersUseCase) =
        oldItem.id == newItem.id

    @SuppressLint("DiffUtilEquals")
    override fun areContentsTheSame(oldItem: OffersUseCase, newItem: OffersUseCase) =
        oldItem == newItem
}

