package com.codes_roots.imakeapp.presentaion.homefragment.adapters

import android.annotation.SuppressLint
import android.content.Context
import android.graphics.Paint
import android.view.LayoutInflater
import android.view.ViewGroup
import androidx.core.view.isVisible
import androidx.databinding.DataBindingUtil
import androidx.recyclerview.widget.DiffUtil
import androidx.recyclerview.widget.ListAdapter
import androidx.recyclerview.widget.RecyclerView
import com.codes_roots.imakeapp.R
import com.codes_roots.imakeapp.databinding.PercentageVendorAdapterBinding
import com.codes_roots.imakeapp.presentaion.ClickHandler
import com.codes_roots.imakeapp.presentaion.mainactivity.MainActivity
import com.satafood.core.mapper.homepage.DiscountItemUseCase
import com.satafood.core.mapper.homepage.MostSellItemUseCase


class PercentageForVendors_Adapter (private val onItemClick: (DiscountItemUseCase) -> Unit):
    ListAdapter<DiscountItemUseCase, PercentageForVendors_Adapter.PercentageViewHolder>(
        PercentageDiffCallback()
    ) {
    var context: Context? = null


    override fun onCreateViewHolder(p0: ViewGroup, p1: Int): PercentageViewHolder {
        val binding: PercentageVendorAdapterBinding = DataBindingUtil.inflate(
            LayoutInflater.from(p0.context), R.layout.percentage_vendor_adapter, p0, false
        )

        return PercentageViewHolder(binding) {
            onItemClick(it)
        }
    }


    override fun onBindViewHolder(holder: PercentageViewHolder, position: Int) {
        holder.bind(context, currentList[position])
        try {

            if (currentList[position].discount!=null){
                if (currentList[position].price!=0.0){
                    holder.binding.priceAfter.text = calculatePriceAfterDiscount(position)
                    holder.binding.price.apply {
                        paintFlags = paintFlags or Paint.STRIKE_THRU_TEXT_FLAG
                    }
                }else{
                    holder.binding.price.apply {
                        paintFlags = 0
                    }
                    holder.binding.priceAfter.apply {
                        isVisible = false
                    }
                }
            }else{
                holder.binding.priceAfter.apply {
                    paintFlags = 0
                }
            }
        }catch (e:Exception){

        }

    }
    private  fun calculatePriceAfterDiscount(position: Int) :String {
        val priceBeforeDiscount = currentList[position].price!!.toInt()
        val discountPercentage = currentList[position].discount!!.toInt()
        val discountValue = priceBeforeDiscount * discountPercentage / 100
        val priceAfterDiscount = priceBeforeDiscount- discountValue

        return " -> "  + priceAfterDiscount.toString()+((context as MainActivity).Pref.currency)
    }
    inner class PercentageViewHolder(
        val binding: PercentageVendorAdapterBinding,
        private val onItemClick: (DiscountItemUseCase) -> Unit,
    ) : RecyclerView.ViewHolder(binding.root) {

        init {
            binding.root.setOnClickListener {
                onItemClick(currentList[adapterPosition])
            }
        }

        fun bind(context: Context?, data: DiscountItemUseCase) {
            binding.listener = ClickHandler()
            binding.data = data
            binding.context = context as MainActivity?
        }
}


}
class PercentageDiffCallback : DiffUtil.ItemCallback<DiscountItemUseCase>() {

    override fun areItemsTheSame(
        oldItem: DiscountItemUseCase,
        newItem: DiscountItemUseCase,
    ) =
        oldItem.id == newItem.id

    @SuppressLint("DiffUtilEquals")
    override fun areContentsTheSame(
        oldItem: DiscountItemUseCase,
        newItem: DiscountItemUseCase,
    ) =
        oldItem == newItem
}