package com.codes_roots.imakeapp.presentaion.homefragment.adapters

import android.content.Context
import android.view.LayoutInflater
import android.view.View
import android.view.ViewGroup
import androidx.viewpager.widget.PagerAdapter

import com.codes_roots.imakeapp.R
import com.codes_roots.imakeapp.helper.Error_MotionToast
import com.codes_roots.imakeapp.helper.setImageResource
import com.codes_roots.imakeapp.presentaion.ClickHandler
import com.codes_roots.imakeapp.presentaion.mainactivity.MainActivity
import com.satafood.core.entities.homepage.sliders.AdsSpacesprice

import kotlinx.android.synthetic.main.viewpagerslide_home1.view.*
import javax.inject.Inject


class SliderAdapter @Inject constructor(
    val context: Context, val slidersData: List<AdsSpacesprice>,
    private val onItemClick: (Int) -> Unit,
) :
    PagerAdapter() {

    override fun getCount(): Int {
        return slidersData.size
    }

    override fun isViewFromObject(p0: View, p1: Any): Boolean {
        return p0 == p1 //To change body of created functions use File | Settings | File Templates.
    }

    override fun instantiateItem(container: ViewGroup, position: Int): Any {
        val layoutInflater =
            (context as MainActivity).getSystemService(Context.LAYOUT_INFLATER_SERVICE) as LayoutInflater
        val view = layoutInflater.inflate(R.layout.viewpagerslide_home, container, false)

        setImageResource(view.im_slider, slidersData[position].sliders!!.photo)

        container.addView(view)

        view.im_slider.setOnClickListener {
            val restaurantId = slidersData[position].sliders!!.restaurant_id
            val item_id = slidersData[position].sliders?.item_id
            if (item_id == 0 && restaurantId != null && restaurantId != 0) {
                //   ClickHandler().SwitchBetweenFragments(context,ItemDetailsFragment(context.restaurantViewModel))
                ClickHandler().switchRestaurantsDetailsFragment(restaurantId.toLong(), context)

            } else if (item_id != 0) {
                onItemClick(item_id!!)
                //   ClickHandler().SwitchBetweenFragments(context,ItemDetailsFragment(context.restaurantViewModel))

            } else
                Error_MotionToast("no data", context)
        }


        return view
    }

    override fun destroyItem(container: ViewGroup, position: Int, `object`: Any) {
        val view = `object` as View
        container.removeView(view)
    }



}
