package com.codes_roots.imakeapp.presentaion.homefragment.adapters

import android.content.Context
import android.view.LayoutInflater
import android.view.View
import android.view.ViewGroup
import androidx.viewpager.widget.PagerAdapter

import com.codes_roots.imakeapp.R
import com.codes_roots.imakeapp.helper.Error_MotionToast
import com.codes_roots.imakeapp.helper.ShapeAppearanceModel
import com.codes_roots.imakeapp.helper.setImageResource
import com.codes_roots.imakeapp.presentaion.ClickHandler
import com.codes_roots.imakeapp.presentaion.gallery_fragment.GalleryFragment
import com.codes_roots.imakeapp.presentaion.mainactivity.MainActivity
import com.satafood.core.entities.gallery.Gallery
import com.satafood.core.entities.homepage.sliders.AdsSpacesprice
import kotlinx.android.synthetic.main.viewpagerslide_home1.view.*
import javax.inject.Inject


class GallerySliderAdapter @Inject constructor(
    val context: Context, val slidersData: List<Gallery>,
    private val onItemClick: (Int) -> Unit,
) :
    PagerAdapter() {

    override fun getCount(): Int {
        return slidersData.size
    }

    override fun isViewFromObject(p0: View, p1: Any): Boolean {
        return p0 == p1 //To change body of created functions use File | Settings | File Templates.
    }

    override fun instantiateItem(container: ViewGroup, position: Int): Any {
        val layoutInflater =
            (context as MainActivity).getSystemService(Context.LAYOUT_INFLATER_SERVICE) as LayoutInflater
        val view = layoutInflater.inflate(R.layout.viewpagerslide_home1, container, false)

        setImageResource(view.im_slider, slidersData[position].photo)

        container.addView(view)

        view.im_slider.setOnClickListener {
            ClickHandler().SwitchBetweenFragments(context, GalleryFragment())
        }

        return view
    }

    override fun destroyItem(container: ViewGroup, position: Int, `object`: Any) {
        val view = `object` as View
        container.removeView(view)
    }


}
