package com.codes_roots.imakeapp.presentaion.homefragment


import android.app.Dialog
import android.content.Context
import android.content.Intent
import android.graphics.Color
import android.graphics.PorterDuff
import android.graphics.Typeface
import android.graphics.drawable.ColorDrawable
import android.os.Bundle
import android.text.Html
import android.util.Log
import android.view.*
import android.widget.TextView
import android.widget.Toast
import androidx.appcompat.content.res.AppCompatResources
import androidx.constraintlayout.widget.ConstraintLayout
import androidx.core.content.res.ResourcesCompat
import androidx.core.view.isVisible
import androidx.databinding.BindingAdapter
import androidx.databinding.DataBindingUtil
import androidx.fragment.app.Fragment
import androidx.fragment.app.FragmentFactory
import androidx.fragment.app.viewModels
import androidx.lifecycle.ViewModelProvider
import androidx.lifecycle.lifecycleScope
import androidx.recyclerview.widget.LinearLayoutManager
import com.google.android.gms.tasks.OnCompleteListener
import com.google.firebase.messaging.FirebaseMessaging
import com.codes_roots.imakeapp.R
import com.codes_roots.imakeapp.databinding.AddRateDialogBinding
import com.codes_roots.imakeapp.databinding.MainFragmentBinding
import com.codes_roots.imakeapp.databinding.SideMenuBinding
import com.codes_roots.imakeapp.helper.*
import com.codes_roots.imakeapp.presentaion.ClickHandler
import com.codes_roots.imakeapp.presentaion.Permissions
import com.codes_roots.imakeapp.presentaion.choose_language.LanguageActivity
import com.codes_roots.imakeapp.presentaion.homefragment.adapters.*
import com.codes_roots.imakeapp.presentaion.homefragment.viewmodel.MainIntent
import com.codes_roots.imakeapp.presentaion.homefragment.viewmodel.MainViewModel
import com.codes_roots.imakeapp.presentaion.homefragment.viewmodel.UserError
import com.codes_roots.imakeapp.presentaion.mainactivity.MainActivity
import com.codes_roots.imakeapp.presentaion.map_activity.MapActivity
import com.codes_roots.imakeapp.presentaion.menufragment.adapter.StaticPagesAdapter
import com.codes_roots.imakeapp.presentaion.menufragment.viewmodel.StaticPagesViewModel
import com.codes_roots.imakeapp.presentaion.myaddress.UserAddressesFragment.Companion.TAG
import com.codes_roots.imakeapp.presentaion.mywallet.mvi.HomeIntent
import com.codes_roots.imakeapp.presentaion.ratefragment.viewmodel.RateViewModel
import com.codes_roots.imakeapp.presentaion.vendordetailsfragment.viewmodel.RestaurantDetailsViewModel
import com.google.firebase.ktx.Firebase
import com.google.firebase.messaging.ktx.messaging
import com.satafood.core.base.DataState
import com.satafood.core.entities.google.GoogleModel
import com.satafood.core.entities.login.LoginModel
import com.satafood.core.entities.myorders.MyOrderModelItem
import com.satafood.core.entities.rate.RateModel
import com.smarteist.autoimageslider.IndicatorView.animation.type.IndicatorAnimationType
import com.smarteist.autoimageslider.SliderAnimations
import kotlinx.android.synthetic.main.add_rate_dialog.*
import kotlinx.android.synthetic.main.add_rate_fragment.sendRate
import kotlinx.android.synthetic.main.bottom_nav_content.*
import kotlinx.android.synthetic.main.custom_layout_dialog.*
import kotlinx.android.synthetic.main.main_fragment.*
import kotlinx.coroutines.flow.collect
import kotlinx.coroutines.launch
import javax.inject.Inject


open class HomeFragment @Inject constructor(
    private val fragmentFactory: FragmentFactory?,
) : Fragment() {
    lateinit var staticPagesAdapter: StaticPagesAdapter
    private lateinit var view: MainFragmentBinding
    lateinit var newOffersAdapter: New_Offers_Adapter
    lateinit var bestCellsAdapter: BestSell_Adapter
    lateinit var percentage_Adapter: PercentageForVendors_Adapter
    lateinit var bestSellingDishAdapter: Best_Item_Adapter
    lateinit var MainAdapter: Main_Adapter
var restaurantId = 0
    val menuViewModel by viewModels<StaticPagesViewModel> { viewModelFactory }

    var binding: SideMenuBinding? = null


    var rateFragmentBinding: AddRateDialogBinding? = null

    @Inject
    lateinit var pref: PreferenceHelper

    @Inject
    lateinit var viewModelFactory: ViewModelProvider.Factory

    var firebaseToken: String? = ""
    var locatlNotificationCount: Int? = 0

    var Item: MyOrderModelItem? = null
    private val viewModelRestaurants by viewModels<RestaurantDetailsViewModel> { viewModelFactory }

    private val homeViewModel by viewModels<HomeViewModel> { viewModelFactory }
    private val viewModel by viewModels<MainViewModel> { viewModelFactory }
    val rateViewModel by viewModels<RateViewModel> { viewModelFactory }


    override fun onCreate(savedInstanceState: Bundle?) {
        childFragmentManager.fragmentFactory = fragmentFactory!!
        super.onCreate(savedInstanceState)
        BaseApplication.appComponent.inject(this)


        (context as MainActivity).bottom_nav_bar.setItemSelected(R.id.home)

        Firebase.messaging.subscribeToTopic(pref.areaId.toString())
            .addOnCompleteListener { task ->
                var msg = "Subscribed + ${pref.areaId}"
                if (!task.isSuccessful) {
                    msg = "Subscribe failed"
                }
                Log.d(TAG, msg)

            }
        FirebaseMessaging.getInstance().token.addOnCompleteListener(OnCompleteListener { task ->
            if (!task.isSuccessful) {
                Log.d("TAG", "token:/// ${task.exception}")
                return@OnCompleteListener
            }
            // Get new FCM registration token
            firebaseToken = task.result
            // Log and toast
            registerTokenRequest(firebaseToken!!)
            Log.d("TAG", "token:///" + firebaseToken)
        })
    }

    override fun onCreateView(
        inflater: LayoutInflater, container: ViewGroup?, savedInstanceState: Bundle?,
    ): View? {

        view = DataBindingUtil.inflate(inflater, R.layout.main_fragment, container, false)
        view.top.context = context as MainActivity
        view.top.mapActivity = MapActivity()
        view.top.listener = ClickHandler()
        view.context = context as MainActivity
        view.listener = ClickHandler()
        view.top.pref = (context as MainActivity).Pref

        view.shimmerCategories.startShimmerAnimation()
        view.shimmerSlider.startShimmerAnimation()
        view.shimmerOffers.startShimmerAnimation()

//        view.top.welcomeUser.isVisible = !(context as MainActivity).Pref.token.isNullOrEmpty()
//
//        view.top.login.isVisible = (context as MainActivity).Pref.token.isNullOrEmpty()
//
//
//        // primary color
//        view.top.login.background.setColorFilter(
//            Color.parseColor(pref.appPrimaryColor),
//            PorterDuff.Mode.SRC_ATOP
//        )
        view.top.header.background.setColorFilter(
            Color.parseColor(pref.appPrimaryColor),
            PorterDuff.Mode.SRC_ATOP
        )

   //     setImageResource(view.top.imageHeader, (context as MainActivity).Pref.appHeader)


//        view.top.notificationIcon.setOnClickListener {
//            ClickHandler().SwitchBetweenFragments(requireContext(), NotificationFragment())
//            pref.areaNotifications = locatlNotificationCount!!
//        }
        if (!(context as MainActivity).Pref.userLocation.isNullOrEmpty())
            view.top.locationName.text = (context as MainActivity).Pref.userLocation

//        view.top.locationName.setOnClickListener { ClickHandler().switchToActivity(context as MainActivity, MapActivity()) }


        val googleModelInfo = GoogleModel(googleId = (context as MainActivity).Pref.googleID)
        viewModel.intents.trySend(
            MainIntent.LoadCategoryData(
                viewModel.state.value!!,
                googleModelInfo
            )
        )
        viewModel.intents.trySend(
            MainIntent.LoadSlidesData(
                viewModel.state.value!!,
                googleModelInfo
            )
        )
        viewModel.intents.trySend(
            MainIntent.LoadGalleryData(
                viewModel.state.value!!
            )
        )
        viewModel.intents.trySend(
            MainIntent.Initialize(
                viewModel.state.value!!,
                googleModelInfo,
                userId = pref.UserId
            )
        )

        viewModel.intents.trySend(MainIntent.GetUserLastOrderForRating(viewModel.state.value!!))

        myView()


        setImageResource( view.top.logo, (context as MainActivity).Pref.appLogo)

//        view.top.notificationIcon.setOnClickListener {
//            ClickHandler().SwitchBetweenFragments(requireContext(), NotificationFragment())
//            pref.areaNotifications = locatlNotificationCount!!
//        }
        return view.root
    }


    fun registerTokenRequest(firebaseToken : String) {
        val registerTokenInfo = LoginModel(
            token = firebaseToken, user_id = pref.UserId)
        viewModel.registerToken(registerTokenInfo)
    }


    fun loginToWinDialog(){
        if (viewModel.state.subscriptionCount.value == 0) {
            if (pref.token == "") {
                val dialog = Dialog(activity!!, android.R.style.Theme_Holo_Dialog_NoActionBar)
                dialog.setContentView(R.layout.custom_layout_dialog)
                if (pref.lang!!.contains("ar")) {
                    dialog.win_image.setImageResource(R.drawable.win_image)
                } else {
                    dialog.win_image.setImageResource(R.drawable.get_two_hundred)
                }
                dialog.window?.attributes?.windowAnimations = R.style.animationdialog
                dialog.getWindow()
                    ?.setBackgroundDrawable(ColorDrawable(Color.TRANSPARENT))
                //        dialog.show()
                dialog.content.setOnClickListener {
                    dialog.dismiss()
                    ClickHandler().Switch_to_Register_Activity(
                        requireContext(),
                        requireActivity()
                    )
                }
                dialog.register.setOnClickListener {
                    dialog.dismiss()
                }


            }
        }

    }
    fun myView() {
        TopicTitle()
        getAllData()
        //setUpViews()
        // getHomeData()
        percentageRecycleView()
        favFoodRecycleView()
        offersRecycleView()
        bestSellRecycleView()
        bestSellDishRecycleView()
//        freeDeliveryRecycleView()
//        nearestStoresRecycleView()

    }


//    private  fun setUpViews() {
//        val parentActivity: MainActivity? = activity as MainActivity?
//        resideMenu = parentActivity!!.getResideMenu()
//        resideMenu!!.addIgnoredView(view.top.menuIcon)
//    }

    override fun onActivityResult(requestCode: Int, resultCode: Int, data: Intent?) {
        super.onActivityResult(requestCode, resultCode, data)
        if (requestCode == 10000) {
            if (PreferenceHelper(requireContext()).UserId > 0) {
//                view.top.userName.text = pref.userName
//                view.top.welcomeUser.text = context!!.getString(R.string.welcome) + pref.userName
//                view.top.login.isVisible = false
//                view.top.welcomeUser.isVisible = true

                if (binding != null) {
                    binding!!.myname.text = pref.userName
                    binding!!.loginLayout.visibility = View.GONE
                    binding!!.logoutLayout.visibility = View.VISIBLE
                }

            } else {
//                view.top.welcomeUser.text = ""
//                (context as MainActivity).Pref.userName = ""
//                (context as MainActivity).Pref.userPhoto = ""
//                view.top.welcomeUser.isVisible = false
//                view.top.login.isVisible = true
                if (binding != null) {
                    binding!!.myname.text = ""
                    binding!!.logoutLayout.visibility = View.GONE
                    binding!!.loginLayout.visibility = View.VISIBLE
                }
            }
        }
    }

    private fun rateRestaurant(data: MyOrderModelItem) {
        if (viewModel.state.subscriptionCount.value == 1) {
            val dialog = Dialog(activity!!, android.R.style.Theme_Holo_Dialog_NoActionBar)
            rateFragmentBinding = AddRateDialogBinding.inflate(LayoutInflater.from(context))
            dialog.setContentView(rateFragmentBinding!!.root)
            rateFragmentBinding?.data = data
            dialog.window?.attributes?.windowAnimations = R.style.animationdialog
            dialog.getWindow()
                ?.setBackgroundDrawable(ColorDrawable(Color.TRANSPARENT))
            val width: Int = (this.resources.getDisplayMetrics().widthPixels * 0.90).toInt()
            //     dialog.show()
            dialog.window?.apply {
                setLayout(width, ViewGroup.LayoutParams.MATCH_PARENT)
                setBackgroundDrawable(object : ColorDrawable(Color.TRANSPARENT) {})

                // attributes?.windowAnimations = R.style.DialogAnimation

            }
             dialog.show()
            dialog.sendRate.setOnClickListener {
                val ratedValue = MyOrderModelItem(rated = 1)
                rateRequest()
                viewModel.intents.trySend(
                    MainIntent.Rate(
                        viewModel.state.value!!, Item?.id, ratedValue
                    )
                )
                dialog.dismiss()
            }
            dialog.cancelRate.setOnClickListener {
                val ratedValue = MyOrderModelItem(rated = 1)
                viewModel.intents.trySend(
                    MainIntent.Rate(
                        viewModel.state.value!!, Item?.id, ratedValue
                    )
                )
                dialog.dismiss()
            }
        }
    }

    private fun setUpViews() {
        val dialog = Dialog(requireContext())
        dialog.requestWindowFeature(Window.FEATURE_NO_TITLE)
        binding = SideMenuBinding.inflate(LayoutInflater.from(context))
        dialog.setContentView(binding!!.root)

        binding!!.click = ClickHandler()
        binding!!.context = context as MainActivity
        binding!!.pref = (context as MainActivity).Pref

        if (PreferenceHelper(requireContext()).UserId > 0)
            binding!!.loginLayout.visibility = View.GONE
        else {
            binding!!.logoutLayout.visibility = View.GONE
        }
        myOrderRecycleView(binding!!)
        getMenuData()
        binding!!.dialog = dialog
        binding!!.langLayout.setOnClickListener {
            dialog.dismiss()
            changeAppLanguage()
        }

        val width: Int = (this.resources.getDisplayMetrics().widthPixels * 0.80).toInt()
        dialog.show()
        dialog.window?.apply {
            setLayout(width, ViewGroup.LayoutParams.MATCH_PARENT)
            setBackgroundDrawable(object : ColorDrawable(Color.TRANSPARENT) {})

            // attributes?.windowAnimations = R.style.DialogAnimation

        }

        // to change background when language change to arabic
        if (pref.lang!!.contains("ar")) {
            dialog.findViewById<ConstraintLayout>(R.id.bg_view).background =
                AppCompatResources.getDrawable(requireContext(), R.drawable.menu_right)
            dialog.window?.setGravity(Gravity.END)
            dialog.window?.attributes?.windowAnimations = R.style.DialogAnimation

        } else {
            dialog.findViewById<ConstraintLayout>(R.id.bg_view).background =
                AppCompatResources.getDrawable(requireContext(), R.drawable.menu_left)
            dialog.window?.setGravity(Gravity.START)
        }

        // to setup menu recyclerView

//        dialog.findViewById<RecyclerView>(R.id.pagesRecycle).apply {
//        favoriteAdapter = MyOrdersAdapter(this@MainActivity,list)
//        adapter = favoriteAdapter
//        layoutManager = LinearLayoutManager(this@MainActivity, LinearLayoutManager.VERTICAL, false)
//        }

    }

    private fun changeAppLanguage() {
        val i = Intent(activity, LanguageActivity::class.java)
        startActivity(i)
    }

    fun favFoodRecycleView() {
        MainAdapter = Main_Adapter(requireContext(), this)
        view.favFoodRecycleView.apply {
            adapter = MainAdapter;
            setNestedScrollingEnabled(false)
        }
    }
    fun bestSellDishRecycleView() {
        bestSellingDishAdapter = Best_Item_Adapter {
            lifecycleScope.launch {
                it.id?.let { id ->
                    homeViewModel.intentChannel.send(HomeIntent.GetItemDetails(id))
                }
            }
//
        }
        bestSellingDishAdapter.context = requireContext()
        view.bestSellDishRecycleView.apply {
            adapter = bestSellingDishAdapter;
            isNestedScrollingEnabled = false
            setHasFixedSize(true)
        }

    }
    fun offersRecycleView() {
        newOffersAdapter = New_Offers_Adapter{
            lifecycleScope.launch {
                it.id?.let { id ->
                    homeViewModel.intentChannel.send(HomeIntent.GetItemDetails(id))
                }
            }
        }
        newOffersAdapter.context = requireContext()
        view.offersRecycleView.apply {
            adapter = newOffersAdapter
            isNestedScrollingEnabled = false
            setHasFixedSize(true)
        }
    }

    fun percentageRecycleView() {
        percentage_Adapter = PercentageForVendors_Adapter {
            lifecycleScope.launch {
                it.id?.let { id ->
                    homeViewModel.intentChannel.send(HomeIntent.GetItemDetails(id))
                }
            }
        }
        percentage_Adapter.context = requireContext()

        view.bestDiscountRecycleView.apply {
            adapter = percentage_Adapter
            isNestedScrollingEnabled = false
            setHasFixedSize(true)
        }
    }



    fun bestSellRecycleView() {
        bestCellsAdapter = BestSell_Adapter()
        bestCellsAdapter.context = requireContext()

        view.bestSellRestaurantRecycleView.apply {
            adapter = bestCellsAdapter
            isNestedScrollingEnabled = false
            setHasFixedSize(true)
        }
    }



    fun getAllData() {
        lifecycleScope.launchWhenStarted {
            viewModel.state.collect {
                kotlin.runCatching {
                    if (it != null) {
                        try {
                            if (it.error != null) {
                                it.error?.let {
                                    when (it) {
                                        is UserError.InvalidId -> "Invalid id"
                                        is UserError.NetworkError -> it.throwable.message
                                        UserError.ServerError -> "Server error"
                                        UserError.Unexpected -> "Unexpected error"
                                        is UserError.UserNotFound -> "User not found"
                                        UserError.ValidationFailed -> "Validation failed"
                                        else -> {}
                                    }
                                }
                                //  viewModel.intents.send(MainIntent.ErrorDisplayed(it))
                            } else {
                                if (it.checkRatingData?.BranchUserId != null) {
                                    Item = it.checkRatingData!!
                                    Log.d("OrderId", " ${it.checkRatingData!!.id}")
                                    rateRestaurant(it.checkRatingData!!)
                                }
                                if (it.categorydata != null) {
                                    view.shimmerCategories.isVisible = it.progress ?: false

                                    MainAdapter.submitList(it.categorydata?.categories!!)
                                }

                                /// Notification Icon
                                if (it.mainhomepagedata != null) {

                                    if (!it.mainhomepagedata?.areanotificatons.isNullOrEmpty()) {
                                        val areaNotifications =
                                            it.mainhomepagedata?.areanotificatons?.get(0)?.data?.count

                                        locatlNotificationCount = areaNotifications

                                        val notificationCount =
                                            it.mainhomepagedata?.notificationCount?.get(0)?.data?.count

//                                        if (areaNotifications!! > pref.areaNotifications) {
//                                            val unSeenNotifications =
//                                                areaNotifications.minus(pref.areaNotifications)
//                                                    .plus(notificationCount!!)
//                                            view.top.newNotificationIcon.text =
//                                                unSeenNotifications.toString()
//                                            view.top.newNotificationIcon.isVisible = true
//
//                                        } else {
//                                            view.top.newNotificationIcon.isVisible = false
//                                        }
                                    }

                                    view.data = it.mainhomepagedata!!.mainData
                                    //// favFoodRecycleViewData
                                    ///newOffersAdapter
                                    //  view.categoryData = it.homepagedata?.categories!![0]
                                    if (!it.mainhomepagedata?.lastoffers.isNullOrEmpty()){
                                        view.shimmerOffers.isVisible = it.progress ?: false
                                        newOffersAdapter.submitList(it.mainhomepagedata?.lastoffers!!)
                                    }
                                    else {
                                        view.offersRecycleView.isVisible = false
                                        view.seeAllBestOffers.isVisible = false
                                        view.bestOffers.isVisible = false
                                    }
                                    if (!it.mainhomepagedata?.mostOrderedBranch.isNullOrEmpty()) {
                                        view.shimmerOffers.isVisible = it.progress ?: false

                                        bestCellsAdapter.submitList(it.mainhomepagedata?.mostOrderedBranch)
                                        view.seeAllBestOffersBestRestaurant.isVisible = true
                                    }
                                    else {
                                        view.bestSellRestaurantText.visibility = View.GONE
                                        view.seeAllBestOffersBestRestaurant.isVisible =
                                            false
                                    }

                                    if (!it.mainhomepagedata!!.mostsellitems.isNullOrEmpty()) {
                                        view.shimmerOffers.isVisible = it.progress ?: false
                                        bestSellingDishAdapter.submitList(it.mainhomepagedata!!.mostsellitems!!)
                                        //     view.seeAllBestOffersBestDish.isVisible = true

                                    } else {
                                        view.bestSellDishText.visibility = View.GONE
                                        view.seeAllBestOffersBestDish.isVisible = false
                                    }

                                    if (!it.mainhomepagedata!!.DiscountedItem.isNullOrEmpty()) {
                                        percentage_Adapter.submitList(it.mainhomepagedata!!.DiscountedItem!!)
                                    } else {
                                        view.bestDiscountRecycleView.visibility = View.GONE
                                        view.bestDiscount.isVisible = false
                                    }
                                    //////// Slider viewPager
                                }

                                if (!it.sliderdata.isNullOrEmpty()) {
                                    view.shimmerSlider.isVisible = it.progress ?: false

                                    if (!it.sliderdata?.get(0)!!.AdsSpacesprice.isNullOrEmpty()) {
                                        view.slider.setSliderAdapter(it.sliderdata?.get(0)?.AdsSpacesprice!!.let { it ->
                                                NewSliderAdapter(
                                                    requireContext(),
                                                    it
                                                ) { id ->
                                                    lifecycleScope.launch {
                                                        homeViewModel.intentChannel.send(
                                                            HomeIntent.GetItemDetails(id)
                                                        )
                                                    }
                                                }

                                        })
                                        view.slider.setIndicatorAnimation(
                                            IndicatorAnimationType.WORM
                                        )
                                        view.slider.setSliderTransformAnimation(
                                            SliderAnimations.FADETRANSFORMATION
                                        )
                                        view.slider.startAutoCycle();


                                    } else {
                                        view.slider.isVisible = false
                                    }
                                    if (!it.sliderdata?.get(1)!!.AdsSpacesprice.isNullOrEmpty()) {
                                        view.pager2.adapter =
                                            it.sliderdata?.get(1)?.AdsSpacesprice.let { it ->
                                                BottomSliderAdapter(
                                                    requireContext(),
                                                    it!!
                                                ) { id ->
                                                    lifecycleScope.launch {
                                                        homeViewModel.intentChannel.send(
                                                            HomeIntent.GetItemDetails(id)
                                                        )
                                                    }
                                                }
                                            }
                                        view.indicator2.setViewPager(view.pager2)
                                    } else {
                                        view.pager2.isVisible = false
                                    }

                                    if (it.sliderdata!!.size > 2) {
                                        view.pager3.adapter =
                                            it.sliderdata?.get(2)?.AdsSpacesprice.let { it ->
                                                BottomSliderAdapter(
                                                    requireContext(),
                                                    it!!
                                                ) { id ->
                                                    lifecycleScope.launch {
                                                        homeViewModel.intentChannel.send(
                                                            HomeIntent.GetItemDetails(id)
                                                        )
                                                    }
                                                }
                                            }

                                        view.indicator3.setViewPager(view.pager3)
                                    } else {

                                        view.pager3.isVisible = false

                                    }


                                    it.sliderdata.let { itS ->
//                                            Permissions().init(itS?.get(0)!!.AdsSpacesprice?.size,
//                                                context as MainActivity,
//                                                view,
//                                                view.indicator)
                                        Permissions().init(
                                            itS?.get(1)!!.AdsSpacesprice?.size,
                                            context as MainActivity,
                                            view,
                                            view.indicator2
                                        )

                                    }
                                }

//                                if (!it.galleryData?.data?.gallery.isNullOrEmpty()) {
//                                    view.pager3.adapter =
//                                        it.galleryData?.data?.gallery.let { it ->
//                                            GallerySliderAdapter(
//                                                requireContext(),
//                                                it!!
//                                            ) { id ->
//                                                lifecycleScope.launch {
//                                                    homeViewModel.intentChannel.send(
//                                                        HomeIntent.GetItemDetails(id)
//                                                    )
//                                                }
//                                            }
//
//                                        }
//                                    Permissions().init(
//                                        it.galleryData?.data?.gallery!!.size,
//                                        context as MainActivity,
//                                        view,
//                                        view.indicator3
//                                    )
//                                    view.indicator3.setViewPager(view.pager3)
//                                }
                                else {
                                }


                            }


                        } catch (e: Exception) {

                        }

                    }
                }.getOrElse { throw it }
            }
        }

        lifecycleScope.launchWhenCreated {
            homeViewModel.itemDetails.observe(viewLifecycleOwner) {
                when (it!!.status) {
                    DataState.Status.LOADING -> {
                        view.progress.isVisible = true
                    }

                    DataState.Status.SUCCESS -> {
                        view.progress.isVisible = false
                        if (!it.data.isNullOrEmpty())
                            it.data?.first()?.let { it1 ->
                                ClickHandler().openItemDetailsFragment(
                                    requireContext(),
                                    it1,
                                    it1.menu_categories!!.vendor_id!!, viewModelRestaurants, 1
                                )
                            }
                        else
                            Error_MotionToast(
                                "no data for this item",
                                requireActivity()
                            )
                    }
                    DataState.Status.ERROR -> {
                        Error_MotionToast(it.error?.throwableMessage.toString(), requireActivity())
                    }
                }
            }
        }

    }



    fun TopicTitle() {
        //// top topic title
        val Enjoy = getString(R.string.enjoy)
        val first = "<font color='#ff7309'>$Enjoy</font>"
        val next = getString(R.string.title)
        view.title.setText(Html.fromHtml(first + next))
    }



    private fun getMenuData() {
        lifecycleScope.launchWhenStarted {
            menuViewModel.state.collect {
                if (it != null) {
                    if (it.error != null) {
                        it.error?.let { userError ->
                            when (userError) {
                                is UserError.InvalidId -> "Invalid id"
                                is UserError.NetworkError -> userError.throwable.message
                                UserError.ServerError -> "Server error"
                                UserError.Unexpected -> "Unexpected error"
                                is UserError.UserNotFound -> "User not found"
                                UserError.ValidationFailed -> "Validation failed"
                                else -> {}
                            }
                        }
                    } else {
                        if (it.progress == true) {
                        } else {
                            if (it.data?.isNotEmpty() == true)
                            ///newOffersAdapter
                                staticPagesAdapter.submitList(it.data!!)

                            view.progress.isVisible = it.progress!!


                        }
                    }
                }

            }
        }
    }

    private fun rateRequest() {
        val rateInfo = RateModel(
            comment = rateFragmentBinding?.comment?.text.toString(),
            order_id = Item?.id,
            rate = rateFragmentBinding?.ratingBar?.rating.toString(),
            vendor_id = pref.restaurantId,
            user_id = pref.UserId
        )
        rateViewModel.rateOrder(rateInfo)
    }

    private fun myOrderRecycleView(binding: SideMenuBinding) {
        staticPagesAdapter = StaticPagesAdapter(requireContext())
        binding.pagesRecycle.apply {
            layoutManager = LinearLayoutManager(
                context
            )
            adapter = staticPagesAdapter;
            isNestedScrollingEnabled = true
            setHasFixedSize(true)
        }
    }

}


@BindingAdapter("bind:changeFont")
fun setFont(textView: TextView, context: Context) {
    context as MainActivity
    if (context.Pref.lang!!.contains("ar")) {
        // You'd probably want to actually use `typefaceName` to determine the font to use
        var typeFace: Typeface? =
            ResourcesCompat.getFont(context.applicationContext, R.font.din_next_arabic_bold)
        textView.setTypeface(typeFace)
    } else {
        var typeFace: Typeface? =
            ResourcesCompat.getFont(context.applicationContext, R.font.lato_bold)
        // You'd probably want to actually use `typefaceName` to determine the font to use
        textView.setTypeface(typeFace)
    }
}