package com.codes_roots.imakeapp.presentaion.homefragment.viewmodel



sealed interface UserError {
    data class NetworkError(var throwable: Throwable) : UserError
    data class UserNotFound(val id: String) : UserError
    data class TokenNeeded(var throwable: Throwable) : UserError
    data class InvalidId(val id: String) : UserError
    object ValidationFailed : UserError
    object ServerError : UserError
    object Unexpected : UserError
}





