package com.codes_roots.imakeapp.presentaion.homefragment.viewmodel

import com.satafood.core.entities.google.GoogleModel
import com.satafood.core.entities.myorders.MyOrderModelItem


sealed class MainIntent(open val viewState: MainViewState? = null, open val googleModel: GoogleModel?=null, open val rated: MyOrderModelItem?=null, open val  orderId: Int?=null, open val  userId: Int?=null) {

    data class Initialize(override val viewState: MainViewState, override val googleModel: GoogleModel?,
                          override val userId: Int?) : MainIntent()
    data class Rate(override val viewState: MainViewState,override val orderId: Int?,override val rated: MyOrderModelItem?) : MainIntent()
    data class ErrorDisplayed(override val viewState: MainViewState) : MainIntent()
    data class LoadCategoryData(override val viewState: MainViewState,override val googleModel: GoogleModel?,) : MainIntent()
    data class GetUserLastOrderForRating(override val viewState: MainViewState) : MainIntent()

    data class LoadSlidesData(override val viewState: MainViewState,override val googleModel: GoogleModel?,) : MainIntent()
    data class LoadGalleryData(override val viewState: MainViewState) : MainIntent()


}