package com.codes_roots.imakeapp.presentaion.itemdetails

import android.app.Dialog
import android.graphics.Color
import android.graphics.PorterDuff
import android.os.Bundle
import android.util.Log
import android.view.LayoutInflater
import android.view.View
import android.view.ViewGroup
import android.view.Window
import androidx.databinding.DataBindingUtil
import androidx.fragment.app.Fragment
import androidx.fragment.app.viewModels
import androidx.lifecycle.ViewModelProvider
import cn.pedant.SweetAlert.SweetAlertDialog
import com.codes_roots.imakeapp.R
import com.codes_roots.imakeapp.databinding.ItemDetailsFragmentBinding
import com.codes_roots.imakeapp.helper.BaseApplication
import com.codes_roots.imakeapp.helper.Error_MotionToast
import com.codes_roots.imakeapp.helper.PreferenceHelper
import com.codes_roots.imakeapp.helper.SUCCESS_MotionToast
import com.codes_roots.imakeapp.presentaion.ClickHandler
import com.codes_roots.imakeapp.presentaion.mainactivity.MainActivity
import com.codes_roots.imakeapp.presentaion.vendordetailsfragment.viewmodel.RestaurantDetailsViewModel
import com.satafood.core.entities.restaurantdetails.MenuCategoriesItem
import kotlinx.android.synthetic.main.alert_dialog.*

import javax.inject.Inject

class ItemDetailsFragment @Inject constructor
    (var viewmodel: RestaurantDetailsViewModel) : Fragment() {

    @Inject
    lateinit var Pref: PreferenceHelper

    @Inject
    lateinit var viewModelFactory: ViewModelProvider.Factory
    private val viewModel by viewModels<RestaurantDetailsViewModel> { viewModelFactory }
    lateinit var pDialog: SweetAlertDialog

    lateinit var optionListAdapter: Option_List_Adapter
    var Total: Double = 0.0
    var cartSize = 0
    var notes: String = ""
    var ResturantId:Int ?=null
    var Item:MenuCategoriesItem? = null
    lateinit var view: ItemDetailsFragmentBinding

    var data: MenuCategoriesItem? = null

    override fun onCreate(savedInstanceState: Bundle?) {
        super.onCreate(savedInstanceState)
        if (savedInstanceState == null) {
            BaseApplication.appComponent.inject(this)
        //    viewmodel.ItemInDetails = Item
        }else {

//            Item = viewmodel.ItemInDetails!!
        }
        Item = arguments?.get("Item") as MenuCategoriesItem
        ResturantId = arguments?.getInt("ResturantId")!!
    }

    override fun onCreateView(
        inflater: LayoutInflater, container: ViewGroup?,
        savedInstanceState: Bundle?
    ): View {
        view = DataBindingUtil.inflate(
            inflater,
            R.layout.item_details_fragment, container, false
        )

        view.listener = ClickHandler()
        view.context = context as MainActivity
        view.data = Item
        viewmodel.Required = 0
        viewmodel.OptionsArrayVariable?.value = 0.0
        viewmodel.OptionsArray.clear()

        if (Item!!.menu_options_topics.isNullOrEmpty()) {
   //         view.additionsScrollView.isVisible = false

        } else {
            optionListAdapter =
                Option_List_Adapter(viewmodel, requireContext(), Item!!.menu_options_topics!!)
            view.optionRecycle.apply { adapter = optionListAdapter }
        }
        Total = if (Item!!.discount!=null){
            calculatePriceAfterDiscount()
        }else{
            Item!!.price?:0.0
        }
        //call server data
     //   viewModel.intents.trySend(MainIntent.LoadAdsData(viewModel.state.value!!, 1))

        notes = view.note.text.toString()

        view.TotalItem.text = (Total).toString().plus(Pref.currency)
        viewmodel.OptionsArrayVariable?.observe(requireActivity()) {
            Total += it
            view.TotalItem.text =
                (Total * view.quintityValue.text.toString().toDouble()).toString()
        }
        view.ButtonClick.background.setColorFilter(
            Color.parseColor(Pref.appPrimaryColor),
            PorterDuff.Mode.SRC_ATOP
        )

        view.quintityPlus.setOnClickListener { increaseInteger() }
        view.quintityMinus.setOnClickListener { decreaseInteger() }

        view.ButtonClick.setOnClickListener {
            Log.i("req", viewmodel.Required.toString())
            if (viewmodel.Required <= 0) {
            when (Pref.restaurantId) {
                0 -> {
                    addItemToCart()
                    viewmodel.quantity!!.value = (++cartSize)

                }
                ResturantId -> {
                    addItemToCart()
                    viewmodel.quantity!!.value = (++cartSize)

                }
                else -> {
                    pDialog = SweetAlertDialog(activity, SweetAlertDialog.SUCCESS_TYPE)
                    val pDialog = Dialog(requireContext())
                    pDialog.getWindow()?.requestFeature(Window.FEATURE_NO_TITLE);
                    pDialog.setContentView(getLayoutInflater().inflate(R.layout.alert_dialog, null));
                    pDialog.done.setOnClickListener {
                        Pref.clearCart()
                        pDialog.hide()
                        Pref.restaurantId =0
                        viewmodel.quantity!!.value = 0

                    }
                    pDialog.cancel.setOnClickListener { pDialog.hide() }
                    pDialog.show();
                }
            }
                }else {
                    Error_MotionToast("قم بتحديد الاختيارات المطلوبة", context as MainActivity)
            }

        }


        view.CloseFragment.setOnClickListener {
            requireActivity().onBackPressed()
        }
        return view.root
    }
    private fun calculatePriceAfterDiscount(): Double {
        val priceBeforeDiscount = Item!!.price!!
        val discountPercentage = Item!!.discount!!
        val discountValue = priceBeforeDiscount * discountPercentage / 100

        return priceBeforeDiscount - discountValue
    }
private fun addItemToCart(){
    try {
    Pref.addItemtoCart(
        Item!!.copy(
            quintity = view.quintityValue.text.toString().toInt(),
            notes = view.note.text.toString(),
            total = Total *  view.quintityValue.text.toString().toInt(),
            price = Total,
            menu_options = viewmodel.OptionsArray,
            delivery_cost = Item!!.delivery_cost,
            )
    )
    Pref.restaurantId = ResturantId!!
    // viewmodel.OptionsArray.clear()
    SUCCESS_MotionToast(getString(R.string.success), requireActivity())
  //  viewmodel.OptionsArrayVariable?.value = 0.0
    activity?.supportFragmentManager?.popBackStack()
    }catch (e:Exception){
    }
}

    fun increaseInteger() {
        display(view.quintityValue.text.toString().toInt() + 1)
        view.TotalItem.text =
            ((Total * view.quintityValue.text.toString().toInt()).toString()).plus(Pref.currency)

    }

    fun decreaseInteger() {
        if (view.quintityValue.text.toString().toInt() > 1) {
            display(view.quintityValue.text.toString().toInt() - 1)
            view.TotalItem.text =
                ((Total * view.quintityValue.text.toString().toInt()).toString()).plus(Pref.currency)
        } else {
            Error_MotionToast(getString(R.string.minimum1), requireActivity())
        }
    }


    private fun display(number: Int) {
        view.quintityValue.setText("$number")
    }


}