package com.codes_roots.imakeapp.presentaion.itemdetails

import android.content.Context
import android.view.LayoutInflater
import android.view.ViewGroup
import androidx.databinding.DataBindingUtil
import androidx.recyclerview.widget.RecyclerView
import com.codes_roots.imakeapp.R
import com.codes_roots.imakeapp.databinding.OptionListBinding
import com.codes_roots.imakeapp.presentaion.vendordetailsfragment.viewmodel.RestaurantDetailsViewModel
import com.satafood.core.entities.restaurantdetails.MenuOptionsTopic


class Option_List_Adapter (var viewModel: RestaurantDetailsViewModel, var context :Context, var data:List<MenuOptionsTopic>) : RecyclerView.Adapter<CustomViewHolders>() {

    var row_index : Int ? = -1

    lateinit var checkboxAdapter: CheckBox_Adapter

    override fun getItemCount(): Int {
        return  data.size
    }


    override fun onBindViewHolder(p0: CustomViewHolders, position: Int) {
        p0.bind(data[position])

        checkboxAdapter = CheckBox_Adapter(this,viewModel,context,data[position],position)

        p0.binding.recyclerView.apply { adapter = checkboxAdapter }
        checkboxAdapter.notifyDataSetChanged()
        p0.binding.numberOfChecks.text = ('('+ (context.getString(R.string.numberOfOptions)) + data[position].max_option_checks+')')

      if (data[position].required != 0) {
          viewModel.Required += 1
          p0.binding.required.text = ('(' + (context.getString(R.string.required)) + ')')
      }   else {
          p0.binding.required.text = ('(' + (context.getString(R.string.optional)) + ')')
      }

//        android:text="@{(data.required == 0) ? `(اختياري)` : `(مطلوب)`}"
    }

    override fun onCreateViewHolder(p0: ViewGroup, p1: Int): CustomViewHolders {
        val  binding: OptionListBinding = DataBindingUtil.inflate (LayoutInflater.from(p0.context),
          R.layout.option_list,p0,false)

        return  CustomViewHolders(binding)
    }


}
class CustomViewHolders (
     var binding:OptionListBinding
) : RecyclerView.ViewHolder(binding.root){

    fun bind(data:MenuOptionsTopic) {
        binding.data = data

    }

}

