package com.codes_roots.imakeapp.presentaion.mainactivity

import android.content.Context
import android.content.Intent
import androidx.fragment.app.Fragment
import androidx.fragment.app.FragmentFactory
import com.codes_roots.imakeapp.R
import com.codes_roots.imakeapp.presentaion.favouritefragment.FavouriteFragment
import com.codes_roots.imakeapp.presentaion.homefragment.viewmodel.MainViewModel
import com.codes_roots.imakeapp.presentaion.menufragment.MenuFragment
import com.ismaeldivita.chipnavigation.ChipNavigationBar
import com.codes_roots.imakeapp.presentaion.homefragment.HomeFragment
import com.codes_roots.imakeapp.presentaion.menufragment.MenuFragmentCompose
import com.codes_roots.imakeapp.presentaion.myorders.MyOrdersFragment
import com.codes_roots.imakeapp.presentaion.search_fragment.SearchFragment
import com.yalantis.contextmenu.lib.ContextMenuDialogFragment
import com.yalantis.contextmenu.lib.MenuObject
import com.yalantis.contextmenu.lib.MenuParams
import kotlinx.android.synthetic.main.bottom_nav_content.*
import javax.inject.Inject


class Menus @Inject constructor(
    private val viewModel: MainViewModel, private val fragmentFactory: FragmentFactory?
) {

    var chipNavigationBar: ChipNavigationBar? = null
    lateinit var contextMenuDialogFragment: ContextMenuDialogFragment

    var context: Context? = null
    var fragment: Fragment? = null

    //////// Horizontal Menu /////

    fun bottomMenu(context: Context) {

        initMenuFragment(context)
        chipNavigationBar = (context as MainActivity).bottom_nav_bar

//
//        chipNavigationBar!!.setItemSelected(R.id.bottom_nav_bar, true)
//        context.supportFragmentManager.beginTransaction()
//            .replace(R.id.main_frame, HomeFragment(viewModel,fragmentFactory)).commit()

        /// default fragment
 //       context.bottom_nav_bar.setItemSelected(R.id.home)

        chipNavigationBar?.setOnItemSelectedListener(object :
            ChipNavigationBar.OnItemSelectedListener {
            override fun onItemSelected(i: Int) {

                when (i) {

                    R.id.home -> fragment = HomeFragment(context.fragmentFactory)

                    R.id.favorites -> fragment = MyOrdersFragment()

                    R.id.settings -> fragment = MenuFragment()

                    R.id.search -> fragment = SearchFragment()
                }

                if (fragment != null) {
                    (context).supportFragmentManager.beginTransaction()
                        .setCustomAnimations(R.anim.slide_right, 0, 0, 0)
                        .replace(R.id.main_frame, fragment!!).commit()
                }
            }
        })


    }


    fun switchFragment(fragment: Fragment, context: Context) {
        (context as MainActivity).supportFragmentManager.beginTransaction()
            .setCustomAnimations(R.anim.slide_right, 0, 0, 0)
            .replace(R.id.main_frame, fragment).addToBackStack(null).commit()
    }

    fun popupFragments(context: Context) {

        val fm = (context as MainActivity).supportFragmentManager
        for (i in 0 until fm.backStackEntryCount) {
            fm.popBackStack()
        }
    }


    ////////     Vertical Menu     /////////

    fun showContextMenuDialogFragment(context: Context) {

        if ((context as MainActivity).supportFragmentManager.findFragmentByTag(
                ContextMenuDialogFragment.TAG
            ) == null
        ) {
            contextMenuDialogFragment.show(
                (context).supportFragmentManager,
                ContextMenuDialogFragment.TAG
            )
        }
    }

    fun initMenuFragment(context: Context) {
        val menuParams = MenuParams(
            actionBarSize = 260,
            menuObjects = getMenuObjects(context),
            isClosableOutside = false,
            animationDuration = 70
        )
        menuParams.isClosableOutside = true

        contextMenuDialogFragment = ContextMenuDialogFragment.newInstance(menuParams).apply {
            menuItemClickListener = { view, position ->
                when (position) {
                    1 -> {
                        val mainIntent = Intent(context as MainActivity, MainActivity::class.java)
                        context.startActivity(mainIntent)
                        context.finish()
                    }
                    2 -> {
                        switchFragment(FavouriteFragment(fragmentFactory!!), context)
                    }
                    3 -> {
                        //  switchFragment(HomeFragment(), context)
                    }
                    4 -> {
                        //     switchFragment(HomeFragment(), context)
                    }

                }
            }

        }
    }

    private fun getMenuObjects(context: Context) = mutableListOf<MenuObject>().apply {
        val close = MenuObject().apply { setResourceValue(R.drawable.ic_baseline_close_24) }

        val home = MenuObject((context as MainActivity).getString(R.string.main)).apply {
            setResourceValue(R.drawable.ic_baseline_close_24)
        }

        home.menuTextAppearanceStyle = (R.style.TabLayoutTextStyle)


        val addFavorite = MenuObject((context as MainActivity).getString(R.string.app_name)).apply {
            setResourceValue(R.drawable.ic_baseline_close_24)
        }
        val settings =
            MenuObject((context as MainActivity).getString(R.string.more)).apply {
                setResourceValue(R.drawable.ic_baseline_close_24)
            }


        add(close)
        add(home)
        add(addFavorite)
        add(settings)
        add(settings)
        add(settings)
        add(settings)
        add(settings)
    }

}