package com.codes_roots.dagger.di.module

import com.codes_roots.imakeapp.presentaion.mainactivity.di.MainModule
import com.codes_roots.dagger.di.scopes.ActivityScope
import com.codes_roots.imakeapp.helper.FragmentFactoryModule
import com.codes_roots.imakeapp.presentaion.choose_language.LanguageActivity
import com.codes_roots.imakeapp.presentaion.mainactivity.MainActivity
import com.codes_roots.imakeapp.presentaion.map_activity.MapActivity
import com.codes_roots.imakeapp.presentaion.register.RegisterActivity
import com.codes_roots.imakeapp.presentaion.splash.CoreSplashScreen
import com.codes_roots.imakeapp.presentaion.splash.SplashScreen
import com.codes_roots.imakeapp.presentaion.webview.WebViewActivity
import dagger.Module
import dagger.android.ContributesAndroidInjector

/**
Created by Prokash Sarkar on Tue, January 19, 2021
 **/

@Module
interface ActivityBuildersModule {

    @ActivityScope
    @ContributesAndroidInjector(modules = [MainModule::class, FragmentFactoryModule::class])
    fun contributeMainActivity(): MainActivity



  @ActivityScope
    @ContributesAndroidInjector(modules = [MainModule::class, FragmentFactoryModule::class])
    fun contributeLoginAsActivity(): RegisterActivity

  @ActivityScope
    @ContributesAndroidInjector(modules = [MainModule::class, FragmentFactoryModule::class])
    fun contributeWebViewActivity(): WebViewActivity

  @ActivityScope
    @ContributesAndroidInjector(modules = [MainModule::class, FragmentFactoryModule::class])
    fun contributeSplashScreen(): SplashScreen
  @ActivityScope
    @ContributesAndroidInjector(modules = [MainModule::class, FragmentFactoryModule::class])
    fun contributeCoreSplashScreen(): CoreSplashScreen

  @ActivityScope
    @ContributesAndroidInjector(modules = [MainModule::class, FragmentFactoryModule::class])
    fun contributeLanguageActivity(): LanguageActivity

  @ActivityScope
    @ContributesAndroidInjector(modules = [MainModule::class, FragmentFactoryModule::class])
    fun contributeMapActivity(): MapActivity




}