package com.codes_roots.imakeapp.presentaion.mainactivity.di

import androidx.lifecycle.ViewModel
import com.codes_roots.imakeapp.create_vendor_driver_account.viewmodel.CreateDriverAccViewModel
import com.codes_roots.imakeapp.helper.ViewModelKey

import com.codes_roots.imakeapp.presentaion.mywallet.WalletViewModel
import com.codes_roots.imakeapp.presentaion.cartfragment.viewmodel.CartViewModel
import com.codes_roots.imakeapp.presentaion.favouritefragment.mvi.FavouriteViewModel
import com.codes_roots.imakeapp.presentaion.gallery_fragment.viewmodel.GalleryViewModel
import com.codes_roots.imakeapp.presentaion.homefragment.HomeViewModel

import com.codes_roots.imakeapp.presentaion.homefragment.viewmodel.MainViewModel
import com.codes_roots.imakeapp.presentaion.map_activity.viewmodel.MapViewModel
import com.codes_roots.imakeapp.presentaion.menufragment.viewmodel.StaticPagesViewModel
import com.codes_roots.imakeapp.presentaion.myaddress.viewmodel.UserAddressViewModel
import com.codes_roots.imakeapp.presentaion.myorders.mvi.MyOrderViewModel
import com.codes_roots.imakeapp.presentaion.mypoints.viewmodel.MyPointsViewModel
import com.codes_roots.imakeapp.presentaion.notification.mvi.NotificationViewModel
import com.codes_roots.imakeapp.presentaion.paymentfragment.mvi.CheckoutViewModel
import com.codes_roots.imakeapp.presentaion.ratefragment.viewmodel.RateViewModel
import com.codes_roots.imakeapp.presentaion.register.viewmodel.AuthViewModel
import com.codes_roots.imakeapp.presentaion.reviews_fragment.mvi.ReviewsViewModel
import com.codes_roots.imakeapp.presentaion.vendordetailsfragment.viewmodel.RestaurantDetailsViewModel
import com.codes_roots.imakeapp.presentaion.search_fragment.mvi.SearchViewModel
import com.codes_roots.imakeapp.presentaion.splash.mvi.SplashViewModel
import com.codes_roots.imakeapp.presentaion.stores_fragment.viewmodel.RestaurantsListViewModel
import com.codes_roots.imakeapp.presentaion.support.SupportViewModel
import com.codes_roots.imakeapp.presentaion.wallet_details.mvi.WalletDetailsViewModel
import dagger.Binds
import dagger.Module
import dagger.multibindings.IntoMap

/**
Created by Prokash Sarkar on Tue, January 19, 2021
 **/

@Module
interface MainModule {

    @Binds
    @IntoMap
    @ViewModelKey(MainViewModel::class)
    fun bindMainViewModel(mainViewModel: MainViewModel): ViewModel

    @Binds
    @IntoMap
    @ViewModelKey(RestaurantsListViewModel::class)
    fun RestaurantsListViewModel(mainViewModel: RestaurantsListViewModel): ViewModel
    @Binds
    @IntoMap
    @ViewModelKey(GalleryViewModel::class)
    fun GalleryViewModel(galleryViewModel: GalleryViewModel): ViewModel

    @Binds
    @IntoMap
    @ViewModelKey(RestaurantDetailsViewModel::class)
    fun RestaurantsDetailsViewModel(mainViewModel: RestaurantDetailsViewModel): ViewModel

    @Binds
    @IntoMap
    @ViewModelKey(WalletDetailsViewModel::class)
    fun WalletDetailsViewModel(mainViewModel: WalletDetailsViewModel): ViewModel

    @Binds
    @IntoMap
    @ViewModelKey(CartViewModel::class)
    fun CartViewModelViewModel(mainViewModel: CartViewModel): ViewModel


    @Binds
    @IntoMap
    @ViewModelKey(CreateDriverAccViewModel::class)
    fun CreateDriverAccViewModel(mainViewModel: CreateDriverAccViewModel): ViewModel


    @Binds
    @IntoMap
    @ViewModelKey(SplashViewModel::class)
    fun SplashViewModel(mainViewModel: SplashViewModel): ViewModel



    @Binds
    @IntoMap
    @ViewModelKey(UserAddressViewModel::class)
    fun AddressViewModelViewModel(mainViewModel: UserAddressViewModel): ViewModel

    @Binds
    @IntoMap
    @ViewModelKey(MyOrderViewModel::class)
    fun myOrderViewModel(mainViewModel: MyOrderViewModel): ViewModel

    @Binds
    @IntoMap
    @ViewModelKey(MyPointsViewModel::class)
    fun MyPointsViewModel(mainViewModel: MyPointsViewModel): ViewModel
    @Binds
    @IntoMap
    @ViewModelKey(CheckoutViewModel::class)
    fun checkoutViewModel(mainViewModel: CheckoutViewModel): ViewModel

    @Binds
    @IntoMap
    @ViewModelKey(FavouriteViewModel::class)
    fun FavouriteModel(mainViewModel: FavouriteViewModel): ViewModel

     @Binds
    @IntoMap
    @ViewModelKey(SearchViewModel::class)
    fun SearchViewModel(mainViewModel: SearchViewModel): ViewModel


    @Binds
    @IntoMap
    @ViewModelKey(RateViewModel::class)
    fun RateModel(rateViewModel: RateViewModel): ViewModel
    @Binds
    @IntoMap
    @ViewModelKey(ReviewsViewModel::class)
    fun ReviewsViewModel(rateViewModel: ReviewsViewModel): ViewModel

    @Binds
    @IntoMap
    @ViewModelKey(MapViewModel::class)
    fun MapViewModel(mapViewModel: MapViewModel): ViewModel

    @Binds
    @IntoMap
    @ViewModelKey(AuthViewModel::class)
    fun AuthViewModel(AuthViewModel: AuthViewModel): ViewModel


    @Binds
    @IntoMap
    @ViewModelKey(NotificationViewModel::class)
    fun notificationViewModel(NotificationViewModel: NotificationViewModel): ViewModel

    @Binds
    @IntoMap
    @ViewModelKey(StaticPagesViewModel::class)
    fun StaticPagesViewModel(StaticPagesViewModel: StaticPagesViewModel): ViewModel


    @Binds
    @IntoMap
    @ViewModelKey(WalletViewModel::class)
    fun myWalletViewModel(walletViewModel: WalletViewModel): ViewModel

    @Binds
    @IntoMap
    @ViewModelKey(com.codes_roots.imakeapp.presentaion.mainactivity.MainViewModel::class)
    fun mainViewModel(mainViewModel: com.codes_roots.imakeapp.presentaion.mainactivity.MainViewModel): ViewModel

    @Binds
    @IntoMap
    @ViewModelKey(SupportViewModel::class)
    fun supportViewModel(supportViewModel: SupportViewModel): ViewModel

    @Binds
    @IntoMap
    @ViewModelKey(HomeViewModel::class)
    fun homeViewModel(homeViewModel: HomeViewModel): ViewModel


}