package com.codes_roots.imakeapp.presentaion.menufragment

import android.content.Intent
import android.os.Bundle
import android.view.LayoutInflater
import android.view.View
import android.view.View.GONE
import android.view.View.VISIBLE
import android.view.ViewGroup
import androidx.compose.ui.platform.ComposeView
import androidx.core.view.isVisible
import androidx.databinding.DataBindingUtil
import androidx.fragment.app.Fragment
import androidx.fragment.app.viewModels
import androidx.lifecycle.ViewModelProvider
import androidx.lifecycle.lifecycleScope
import androidx.recyclerview.widget.LinearLayoutManager
import com.codes_roots.imakeapp.R
import com.codes_roots.imakeapp.create_vendor_driver_account.create_driver_account_fragment.CreateDriverAccountFragment
import com.codes_roots.imakeapp.create_vendor_driver_account.create_vendor_account_fragment.CreateVendorAccountFragment
import com.codes_roots.imakeapp.helper.BaseApplication
import com.codes_roots.imakeapp.helper.PreferenceHelper
import com.codes_roots.imakeapp.helper.ResourceUtil
import com.codes_roots.imakeapp.presentaion.ClickHandler
import com.codes_roots.imakeapp.presentaion.choose_language.LanguageActivity
import com.codes_roots.imakeapp.presentaion.homefragment.viewmodel.UserError
import com.codes_roots.imakeapp.presentaion.mainactivity.MainActivity
import com.codes_roots.imakeapp.presentaion.menufragment.adapter.StaticPagesAdapter
import com.codes_roots.imakeapp.presentaion.menufragment.mvi.MainIntent
import com.codes_roots.imakeapp.presentaion.menufragment.viewmodel.StaticPagesViewModel
import com.codes_roots.imakeapp.presentaion.mypoints.PointsFragment
import kotlinx.android.synthetic.main.map_activity.*
import kotlinx.coroutines.flow.collect
import javax.inject.Inject


open class MenuFragmentCompose @Inject constructor() : Fragment() {

    private var curremtlang ///true if arabic
            = false

    lateinit var staticPagesAdapter: StaticPagesAdapter

    @Inject
    lateinit var Pref: PreferenceHelper

    @Inject
    lateinit var viewModelFactory: ViewModelProvider.Factory

    val viewModel by viewModels<StaticPagesViewModel> { viewModelFactory }
    override fun onCreate(savedInstanceState: Bundle?) {
        super.onCreate(savedInstanceState)
        if (savedInstanceState == null) {
            BaseApplication.appComponent.inject(this)
        }
    }


    override fun onCreateView(
        inflater: LayoutInflater,
        container: ViewGroup?,
        savedInstanceState: Bundle?,
    ): View? {
            return ComposeView(requireContext()).apply {
                setContent {
                 MenuScreen()
                }
            }

    }

    private fun changeAppLanguage() {
        val i = Intent(activity, LanguageActivity::class.java)
        startActivity(i)
    }

    override fun onActivityResult(requestCode: Int, resultCode: Int, data: Intent?) {
        super.onActivityResult(requestCode, resultCode, data);
        if (requestCode == 10000) {

            if (PreferenceHelper(requireContext()).UserId > 0) {

            } else {

            }


        }
    }

    fun getAllData() {
        lifecycleScope.launchWhenStarted {
            viewModel.state.collect {
                if (it != null) {
                    if (it.error != null) {
                        it.error?.let { userError ->
                            when (userError) {
                                is UserError.InvalidId -> "Invalid id"
                                is UserError.NetworkError -> userError.throwable.message
                                UserError.ServerError -> "Server error"
                                UserError.Unexpected -> "Unexpected error"
                                is UserError.UserNotFound -> "User not found"
                                UserError.ValidationFailed -> "Validation failed"
                                else -> {}
                            }
                        }
                        viewModel.intents.trySend(MainIntent.ErrorDisplayed(it))
                    } else {

                        if (it.progress == true) {
                            viewModel.intents.send(MainIntent.Initialize(it))
                        } else {

                            if (it.data?.isNotEmpty() == true)
                            ///newOffersAdapter
                                staticPagesAdapter.submitList(it.data!!)



                        }
                    }
                }

            }
        }
    }


}