package com.codes_roots.imakeapp.presentaion.menufragment.adapter

import android.annotation.SuppressLint
import android.content.Context
import android.view.LayoutInflater
import android.view.ViewGroup
import androidx.databinding.DataBindingUtil
import androidx.recyclerview.widget.DiffUtil
import androidx.recyclerview.widget.ListAdapter
import androidx.recyclerview.widget.RecyclerView
import com.codes_roots.imakeapp.R
import com.codes_roots.imakeapp.databinding.SocialItemBinding
import com.codes_roots.imakeapp.presentaion.ClickHandler
import com.codes_roots.imakeapp.presentaion.mainactivity.MainActivity
import com.satafood.core.entities.social_media.SocialMediaModelItem

class SocialAdapter(var context: Context?) :
    ListAdapter<SocialMediaModelItem, SocialViewHolder>(SocialDiffCallback()) {

    override fun onCreateViewHolder(p0: ViewGroup, p1: Int): SocialViewHolder {
        val binding: SocialItemBinding = DataBindingUtil.inflate(
            LayoutInflater.from(p0.context),
            R.layout.social_item, p0, false)

        return SocialViewHolder(binding)
    }

    override fun onBindViewHolder(holder: SocialViewHolder, position: Int) {
        holder.bind(context, currentList[position])

    }

}

private class SocialDiffCallback : DiffUtil.ItemCallback<SocialMediaModelItem
        >() {

    override fun areItemsTheSame(
        oldItem: SocialMediaModelItem, newItem: SocialMediaModelItem
    ) =
        oldItem.id == newItem.id

    @SuppressLint("DiffUtilEquals")
    override fun areContentsTheSame(
        oldItem: SocialMediaModelItem, newItem: SocialMediaModelItem
    ) =
        oldItem == newItem
}


class SocialViewHolder(
    val binding: SocialItemBinding
) : RecyclerView.ViewHolder(binding.root) {


    fun bind(context: Context?, data: SocialMediaModelItem) {

        binding.listener = ClickHandler()
        binding.data = data
        binding.context = context as MainActivity?
        binding.pref = (context as MainActivity).Pref
    }


}
