package com.codes_roots.imakeapp.presentaion.menufragment.staticfragment

import android.os.Bundle
import android.view.LayoutInflater
import android.view.View
import android.view.ViewGroup
import androidx.core.view.isVisible
import androidx.databinding.DataBindingUtil
import androidx.fragment.app.Fragment
import com.codes_roots.imakeapp.R
import com.codes_roots.imakeapp.databinding.StaticFragmentBinding
import com.codes_roots.imakeapp.helper.BaseApplication
import com.codes_roots.imakeapp.helper.PreferenceHelper
import com.codes_roots.imakeapp.presentaion.ClickHandler
import com.codes_roots.imakeapp.presentaion.mainactivity.MainActivity
import com.satafood.core.entities.static_pages.StaticPagesItem
import javax.inject.Inject

class StaticFragment @Inject constructor
    (var contentData: StaticPagesItem) : Fragment() {

    @Inject
    lateinit var Pref: PreferenceHelper


    lateinit var view: StaticFragmentBinding

    override fun onCreate(savedInstanceState: Bundle?) {
        super.onCreate(savedInstanceState)
        if (savedInstanceState == null) {
            BaseApplication.appComponent.inject(this)
        }
    }

    override fun onCreateView(
        inflater: LayoutInflater, container: ViewGroup?,
        savedInstanceState: Bundle?,
    ): View {
        view = DataBindingUtil.inflate(inflater,

            R.layout.static_fragment, container, false)

        view.listener = ClickHandler()

        view.context = context as MainActivity

        view.data = contentData

        view.progress.isVisible = false


        return view.root

    }


}





