package com.codes_roots.imakeapp.presentaion.myaddress


import android.content.Context
import android.view.LayoutInflater
import android.view.View
import android.view.ViewGroup
import android.widget.Toast
import androidx.databinding.DataBindingUtil
import androidx.recyclerview.widget.RecyclerView
import com.facebook.FacebookSdk.getApplicationContext
import com.codes_roots.imakeapp.R
import com.codes_roots.imakeapp.databinding.MyAddressesItemBinding
import com.codes_roots.imakeapp.helper.WARN_MotionToast
import com.codes_roots.imakeapp.presentaion.ClickHandler
import com.codes_roots.imakeapp.presentaion.mainactivity.MainActivity
import com.satafood.core.entities.addresses.UserAddressesItem
import com.shreyaspatil.MaterialDialog.MaterialDialog
import kotlinx.android.synthetic.main.my_addresses_item.view.*


class AddressesAdapter(
    var context: Context,
    var data: ArrayList<UserAddressesItem>, var addressesFragment: UserAddressesFragment? = null,
) : RecyclerView.Adapter<CustomViewHolders>() {

    var checkData : ArrayList<UserAddressesItem> ? = null
var index = 0

    override fun getItemCount(): Int {
        return data.size
    }

    override fun onBindViewHolder(p0: CustomViewHolders, position: Int) {
        p0.bind(data[position], context)
        try {
            p0.binding.isAvailable.visibility = View.GONE
            p0.binding.myAddress.visibility = View.VISIBLE

            p0.binding.deleteAddress.setOnClickListener {
                val mDialog = MaterialDialog.Builder(context as MainActivity)
                    .setTitle(context.getString(R.string.delete))
                    .setMessage(context.getString(R.string.sure_delete))
                    .setCancelable(false)
                    .setPositiveButton(
                        context.getString(R.string.delete), R.drawable.ic_delete_
                    ) { dialogInterface, which ->
                        addressesFragment!!.viewModel.deleteUsersAddress(data[position].id!!)
                        data.removeAt(position)
                        notifyItemRemoved(position)
                        dialogInterface.dismiss()
                        Toast.makeText(
                            getApplicationContext(),
                            context.getString(R.string.deleted),
                            Toast.LENGTH_SHORT
                        ).show();
                    }
                    .setNegativeButton(
                        context.getString(R.string.cancel), R.drawable.ic_close
                    ) { dialogInterface, which -> dialogInterface.dismiss() }
                    .build()
                mDialog.show()

                notifyDataSetChanged()

            }

            if (data[position].branchId != null) {
            p0.binding.myAddress.visibility = View.VISIBLE
            p0.binding.isAvailable.visibility = View.GONE
            }else{
          //          p0.binding.myAddress.visibility = View.GONE
              //      p0.binding.isAvailable.visibility = View.VISIBLE
            }
            p0.binding.layouts.setOnClickListener {
                index = position
                    val mDialog = MaterialDialog.Builder(context as MainActivity)
                        .setTitle(context.getString(R.string.sure_choose))
                        .setMessage(context.getString(R.string.sure_choose))
                        .setCancelable(false)
                        .setPositiveButton(
                            context.getString(R.string.confirm),
                            R.drawable.pin
                        ) { dialogInterface, which ->
                            try {
                            val context = context as MainActivity
                            (context).Pref.userName = data[position].first_name + data[position].last_name
                            (context).Pref.userAddress = data[position].address
                            (context).Pref.userPhone = data[position].phone
                            (context).Pref.BillingId = data[position].id!!.toInt()
                            (context).Pref.areaId = data[position].area_id!!.toInt()
                            //context.preferenceHelper.CityTileName = data[position].areas!!.name!!
                            dialogInterface.dismiss()
                            context.onBackPressed()
                            }catch (e:Exception){}
                        }

                        .setNegativeButton(
                            context.getString(R.string.cancel),
                            R.drawable.ic_close
                        ) { dialogInterface, which -> dialogInterface.dismiss() }
                        .build()
                    mDialog.show()

                notifyDataSetChanged()

            }

            addressesFragment!!.viewModel.checkAddressesLD.observe(addressesFragment!!.viewLifecycleOwner) {
                if (!it.isNullOrEmpty()) {
                    checkData = it

                }

            }


        } catch (e: Exception) {
            Toast.makeText(getApplicationContext(), e.toString(), Toast.LENGTH_SHORT).show();
        }

    }


    override fun onCreateViewHolder(p0: ViewGroup, p1: Int): CustomViewHolders {
        val binding: MyAddressesItemBinding =
            DataBindingUtil.inflate(
                LayoutInflater.from(p0.context),
                R.layout.my_addresses_item, p0, false
            )

        return CustomViewHolders(binding)
    }


}

class CustomViewHolders(
    var binding: MyAddressesItemBinding,
) : RecyclerView.ViewHolder(binding.root) {

    fun bind(data: UserAddressesItem, context: Context?) {
        binding.data = data
        binding.listener = ClickHandler()
        binding.context = context as MainActivity

    }

}

