package com.codes_roots.imakeapp.presentaion.myaddress

import android.os.Bundle
import android.view.LayoutInflater
import android.view.View
import android.view.ViewGroup
import android.widget.Toast
import androidx.core.view.isVisible
import androidx.databinding.DataBindingUtil
import androidx.fragment.app.Fragment
import androidx.fragment.app.viewModels
import androidx.lifecycle.ViewModelProvider
import com.codes_roots.imakeapp.R
import com.codes_roots.imakeapp.databinding.MyaddressFragmentBinding
import com.codes_roots.imakeapp.helper.BaseApplication
import com.satafood.core.entities.homepage.CitiesModelItem
import com.codes_roots.imakeapp.presentaion.ClickHandler
import com.codes_roots.imakeapp.presentaion.add_address_fragment.AddAdressFragment
import com.codes_roots.imakeapp.presentaion.mainactivity.MainActivity
import com.codes_roots.imakeapp.presentaion.myaddress.viewmodel.UserAddressViewModel
import io.github.muddz.styleabletoast.StyleableToast
import javax.inject.Inject


open class UserAddressesFragment : Fragment() {


    @Inject
    lateinit var viewModelFactory: ViewModelProvider.Factory

    val viewModel by viewModels<UserAddressViewModel> { viewModelFactory }

    var data: CitiesModelItem? = null

    lateinit var addressAdapter: AddressesAdapter
      var branch_id: Int = 0

    companion object {

        const val TAG = "TownBottomSheetDialogFragment"

    }

    lateinit var view: MyaddressFragmentBinding

    override fun onCreate(savedInstanceState: Bundle?) {
        super.onCreate(savedInstanceState)
        BaseApplication.appComponent.inject(this)

    }

    override fun onCreateView(
        inflater: LayoutInflater,
        container: ViewGroup?,
        savedInstanceState: Bundle?,
    ): View? {

        view = DataBindingUtil.inflate(inflater,
            R.layout.myaddress_fragment, container, false)

      //  view.chooseArea.visibility = View.GONE

        view.listener = ClickHandler()
        view.context = context as MainActivity

        // val id = arguments?.getInt("city_id")!!
            if (!viewModel.isAddressError){
                viewModel.getUserAddresses()
            }else{
                StyleableToast.makeText(requireContext(), "Error loading your addresses, Please check your connection", Toast.LENGTH_SHORT, R.style.myInternetToast).show();
            }

//
        arguments?.let {

             branch_id = it.getInt("branch_id", 0)

        }

        viewModel.checkRestaurantAddress(branch_id)

        viewModel.checkAddressesLD.observe(viewLifecycleOwner) {
            if (!it.isNullOrEmpty()){
                view.noAddress.isVisible = false
                addressAdapter = AddressesAdapter(requireContext(), it, this)
                view.citiesRecycle.apply {
                    adapter = addressAdapter;
            }
            }else{
                view.noAddress.isVisible = true
            }
        }

        view.backArrow.setOnClickListener { requireActivity().onBackPressed() }
        view.addAddressBtn.setOnClickListener {
            ClickHandler().checkForToken(context as MainActivity,
                AddAdressFragment((context as MainActivity).fragmentFactory))
        }
        return view.root
    }


}