package com.codes_roots.imakeapp.presentaion.myaddress.cities

import android.annotation.SuppressLint
import android.content.Context
import android.content.Intent
import android.view.LayoutInflater
import android.view.ViewGroup
import androidx.databinding.DataBindingUtil
import androidx.recyclerview.widget.DiffUtil
import androidx.recyclerview.widget.ListAdapter
import androidx.recyclerview.widget.RecyclerView
import com.codes_roots.imakeapp.R
import com.codes_roots.imakeapp.databinding.CitiesAdapterBinding
import com.codes_roots.imakeapp.presentaion.ClickHandler
import com.codes_roots.imakeapp.presentaion.myaddress.cities.mvi.MainIntent
import com.codes_roots.imakeapp.presentaion.myaddress.viewmodel.UserAddressViewModel
import com.satafood.core.entities.homepage.CitiesModelItem
import kotlinx.coroutines.CoroutineScope
import kotlinx.coroutines.Dispatchers
import kotlinx.coroutines.channels.Channel


class Cities_Adapter(
    var viewModel: UserAddressViewModel,
    var Intent: Channel<MainIntent>,
    var context: CitiesActivity?
) : ListAdapter<CitiesModelItem, MenuViewHolder>(MenuDiffCallback()) {

    val scope = CoroutineScope(Dispatchers.Main)
    var name = ""
    override fun onBindViewHolder(holder: MenuViewHolder, position: Int) {
        holder.bind(context, Intent, currentList[position])

        holder.binding.firstChar.text = currentList[position].name?.substring(0, 1)

        val viewState = viewModel.state.value

        holder.binding.hhhh.setOnClickListener {
            try {
            if (currentList[position].city_id == null && currentList[position].town_id == null) {
                viewModel.intents.trySend(
                    MainIntent.InitializeCities(
                        viewState?.copy(progress = true, townsdata = currentList[position].towns),
                    )
                )
      //          name += currentList[position].name + "-"
            } else if (currentList[position].city_id != null) {
                val addressData = Intent()
                addressData.putExtra("name",currentList[position].name)
                addressData.putExtra("place_id",currentList[position].google_id)
                addressData.putExtra("area_id",currentList[position].id)
                addressData.putExtra("lat",currentList[position].id)
                addressData.putExtra("long",currentList[position].id)
                context!!.Pref.areaId = currentList[position].id!!
                context!!.Pref.CityTileName = currentList[position].name
                (context as CitiesActivity).setResult(1000, addressData)
                (context as CitiesActivity).finish()
            }
            }catch (e:Exception){}

        }
    }

    override fun onCreateViewHolder(p0: ViewGroup, p1: Int): MenuViewHolder {
        val binding: CitiesAdapterBinding = DataBindingUtil.inflate(
            LayoutInflater.from(p0.context),
            R.layout.cities_adapter, p0, false
        )
        return MenuViewHolder(binding)
    }
}

private class MenuDiffCallback : DiffUtil.ItemCallback<CitiesModelItem>() {

    override fun areItemsTheSame(oldItem: CitiesModelItem, newItem: CitiesModelItem) =
        oldItem.id == newItem.id

    @SuppressLint("DiffUtilEquals")
    override fun areContentsTheSame(oldItem: CitiesModelItem, newItem: CitiesModelItem) =
        oldItem == newItem
}

class MenuViewHolder(
    val binding: CitiesAdapterBinding
) : RecyclerView.ViewHolder(binding.root) {


    fun bind(context: Context?, viewModel: Channel<MainIntent>, data: CitiesModelItem) {
        binding.listener = ClickHandler()
        binding.context = context as CitiesActivity?
        binding.data = data
        binding.pref = context!!.Pref
    }
}
