package com.codes_roots.imakeapp.presentaion.myorderDetails.adapter

import android.annotation.SuppressLint
import android.content.Context
import android.view.LayoutInflater
import android.view.ViewGroup
import androidx.databinding.DataBindingUtil
import androidx.recyclerview.widget.DiffUtil
import androidx.recyclerview.widget.ListAdapter
import androidx.recyclerview.widget.RecyclerView
import com.codes_roots.imakeapp.R
import com.codes_roots.imakeapp.databinding.MyOrdersDetailsAdapter2Binding
import com.codes_roots.imakeapp.databinding.MyOrdersDetailsAdapterBinding
import com.codes_roots.imakeapp.presentaion.ClickHandler
import com.codes_roots.imakeapp.presentaion.mainactivity.MainActivity
import com.codes_roots.imakeapp.presentaion.myorders.mvi.MainViewState
import com.satafood.core.entities.myorders.OrderDetail
import kotlinx.coroutines.CoroutineScope
import kotlinx.coroutines.Dispatchers
import kotlinx.coroutines.flow.MutableStateFlow

class OrdersDetailsAdapter (var context:Context)
    : ListAdapter<OrderDetail, MenuViewHolder>(MenuDiffCallback()) {
    lateinit var viewModel: MutableStateFlow<MainViewState?>
    val scope = CoroutineScope(Dispatchers.Main)

    override  fun onBindViewHolder(holder: MenuViewHolder, position: Int) {
        holder.bind(context, currentList[position])
        /// item options
        if (holder.binding.itemDetails.text == "")
            currentList[position]!!.order_details_options?.forEachIndexed { index, value ->
                if (currentList[position].order_details_options!!.lastIndex != index)
                    holder.binding.itemDetails.append(value.menu_options?.name + "-")
                else holder.binding.itemDetails.append(value.menu_options?.name)
            }
    }
    override fun onCreateViewHolder(p0: ViewGroup, p1: Int): MenuViewHolder {
        val binding: MyOrdersDetailsAdapter2Binding = DataBindingUtil.inflate(
            LayoutInflater.from(p0.context),
            R.layout.my_orders_details_adapter2, p0, false
        )

        return MenuViewHolder(binding)
    }
}

private  class MenuDiffCallback : DiffUtil.ItemCallback<OrderDetail>() {

    override fun areItemsTheSame(oldItem: OrderDetail, newItem: OrderDetail) =
        oldItem.id == newItem.id

    @SuppressLint("DiffUtilEquals")
    override fun areContentsTheSame(oldItem: OrderDetail, newItem: OrderDetail) =
        oldItem == newItem
}

class MenuViewHolder(
    val binding: MyOrdersDetailsAdapter2Binding
) : RecyclerView.ViewHolder(binding.root) {
    fun bind(context: Context?, data: OrderDetail) {
        binding.listener = ClickHandler()
        binding.data = data
        binding.context = context as MainActivity?

        binding.containNotes = !binding.notes.text.isEmpty()

    }


}
