package com.codes_roots.imakeapp.presentaion.mywallet

import android.annotation.SuppressLint
import android.content.Context
import android.view.LayoutInflater
import android.view.ViewGroup
import androidx.recyclerview.widget.DiffUtil
import androidx.recyclerview.widget.ListAdapter
import androidx.recyclerview.widget.RecyclerView
import com.codes_roots.imakeapp.R
import com.codes_roots.imakeapp.databinding.RowItemWalletClientBinding
import com.codes_roots.imakeapp.presentaion.ClickHandler
import com.codes_roots.imakeapp.presentaion.mainactivity.MainActivity
import com.satafood.core.entities.wallet.WalletModel

class WalletAdapter(val context: Context, private val onItemClick: (WalletModel) -> Unit) :
    ListAdapter<WalletModel, WalletAdapter.WalletViewHolder>(Companion) {

    companion object : DiffUtil.ItemCallback<WalletModel>() {
        override fun areItemsTheSame(oldItem: WalletModel, newItem: WalletModel): Boolean {
            return oldItem.id == newItem.id
        }

        override fun areContentsTheSame(oldItem: WalletModel, newItem: WalletModel): Boolean {
            return oldItem.hashCode() == newItem.hashCode()
        }
    }

    override fun onCreateViewHolder(parent: ViewGroup, viewType: Int): WalletViewHolder {
        val binding =
            RowItemWalletClientBinding.inflate(LayoutInflater.from(parent.context), parent, false)
        return WalletViewHolder(binding) {
            onItemClick(it)
        }
    }

    @SuppressLint("SetTextI18n")
    override fun onBindViewHolder(holder: WalletViewHolder, position: Int) {
        val item = currentList[position]
        item?.let {
            holder.bind(it)
        }
        context as MainActivity
        holder.itemBinding.details.setOnClickListener {
            ClickHandler().SwitchToWalletDetailsFragment(context, currentList[position].id!!)
        }
        holder.itemBinding.messageView.text = context.getString(R.string.you_wallet_balance_now_is) + item.value.toString() +
                context.Pref.currency + context.getString(R.string.you_can_get_a_discount_of) +
                item.value.toString() + context.Pref.currency +
                context.getString(R.string.on_every_order_value_more_than) + item.minimum.toString() + context.Pref.currency +
                context.getString(R.string.maximum) + item.maximum.toString() + context.Pref.currency
        if (item.totalTransactions == null)
            item.totalTransactions = 0.0

            holder.itemBinding.totalTransaction = item.totalTransactions.toString()


        if (item.end_date == null)
            holder.itemBinding.isNull = true

    }

    inner class WalletViewHolder(
        val itemBinding: RowItemWalletClientBinding,
        private val onItemClick: (WalletModel) -> Unit
    ) : RecyclerView.ViewHolder(itemBinding.root) {
        init {
            itemBinding.walletLayout.setOnClickListener {
                onItemClick(currentList[adapterPosition])
            }
        }
        fun bind(item: WalletModel) {
            item.apply {
                itemBinding.wallet = this
            }
        }
    }

}