package com.codes_roots.imakeapp.presentaion.notification

import android.annotation.SuppressLint
import android.content.Context
import android.view.LayoutInflater
import android.view.ViewGroup
import androidx.databinding.DataBindingUtil
import androidx.recyclerview.widget.DiffUtil
import androidx.recyclerview.widget.ListAdapter
import androidx.recyclerview.widget.RecyclerView
import com.codes_roots.imakeapp.R
import com.codes_roots.imakeapp.databinding.NotificationAdapterBinding
import com.codes_roots.imakeapp.presentaion.ClickHandler
import com.codes_roots.imakeapp.presentaion.mainactivity.MainActivity
import com.codes_roots.imakeapp.presentaion.notification.mvi.NotificationViewModel
import com.satafood.core.entities.notification.NotificationModelItem

class NotificationAdapter(
    var viewModel: NotificationViewModel, var context: Context?
) :
    ListAdapter<NotificationModelItem, NotificationViewHolder>(BranchesDiffCallback()) {

    override fun onCreateViewHolder(p0: ViewGroup, p1: Int): NotificationViewHolder {
        val binding: NotificationAdapterBinding = DataBindingUtil.inflate(
            LayoutInflater.from(p0.context),
            R.layout.notification_adapter, p0, false)

        return NotificationViewHolder(binding)

    }

    override fun onBindViewHolder(holder: NotificationViewHolder, position: Int) {
        holder.bind(context, currentList[position])

    }

}

private class BranchesDiffCallback : DiffUtil.ItemCallback<NotificationModelItem
        >() {

    override fun areItemsTheSame(
        oldItem: NotificationModelItem, newItem: NotificationModelItem
    ) =
        oldItem.id == newItem.id

    @SuppressLint("DiffUtilEquals")
    override fun areContentsTheSame(
        oldItem: NotificationModelItem, newItem: NotificationModelItem
    ) =
        oldItem == newItem
}


class NotificationViewHolder(
    val binding: NotificationAdapterBinding
) : RecyclerView.ViewHolder(binding.root) {


    fun bind(context: Context?, data: NotificationModelItem) {

        binding.listener = ClickHandler()
        binding.data = data
        binding.context = context as MainActivity?
    }


}
