package com.codes_roots.imakeapp.presentaion.paymentfragment.mvi

import androidx.lifecycle.MutableLiveData
import androidx.lifecycle.viewModelScope
import com.codes_roots.imakeapp.presentaion.mainactivity.BaseViewModel
import com.codes_roots.imakeapp.repository.cart.CartDataRepo
import com.codes_roots.imakeapp.repository.cart.CartRemoteDataSource
import kotlinx.coroutines.*
import kotlinx.coroutines.channels.Channel
import kotlinx.coroutines.flow.MutableStateFlow
import kotlinx.coroutines.flow.collect
import kotlinx.coroutines.flow.receiveAsFlow
import javax.inject.Inject


class CheckoutViewModel @Inject constructor(
    private val DateRepoCompnay: CartDataRepo,
    private val Datasources:CartRemoteDataSource,
) : BaseViewModel<CheckOutViewState>() {

    val intents: Channel<CheckoutIntents> = Channel<CheckoutIntents>(Channel.UNLIMITED)

    protected val uiState: MutableStateFlow<CheckOutViewState?> = MutableStateFlow(CheckOutViewState())

    val state: MutableStateFlow<CheckOutViewState?> get() = uiState

    private var job: Job? = null
    var InActiveView = MutableLiveData<Int>()



    val errorMessage = MutableLiveData<String>()
    val loading = MutableLiveData<Boolean>()

    private val viewStateMapper: suspend (CheckoutIntents)

    -> CheckOutViewState = { mapIntentToViewState(it, DateRepoCompnay) }

    val coroutineExceptionHandler = CoroutineExceptionHandler { _, throwable ->
        throwable.printStackTrace()
    }

    init {
        getIntent()
        InActiveView = MutableLiveData()

        // لازم ابعت viewstate كامل واتحكم بكل option حسب المطلوب وارساله مرة اخري واستقباله هنا او في ال view

      //  uiState.value = CheckOutViewState().copy(progress = true)

        // launchNextViewStateJob(intents.value)
    }

    fun getIntent() {
        job = viewModelScope.launch() {
            intents.receiveAsFlow().collect {
                uiState.value = (viewStateMapper(it))
            }
        }
    }


    override fun onCleared() {
        super.onCleared()
        job!!.cancel()
    }

    private fun onError(message: String) {
        errorMessage.value = message
        loading.value = false
    }

}




