package com.codes_roots.imakeapp.presentaion.ratefragment

import android.os.Bundle
import android.view.LayoutInflater
import android.view.View
import android.view.ViewGroup
import androidx.databinding.DataBindingUtil
import androidx.fragment.app.Fragment
import androidx.fragment.app.FragmentFactory
import androidx.fragment.app.viewModels
import androidx.lifecycle.ViewModelProvider
import com.codes_roots.imakeapp.R
import com.codes_roots.imakeapp.databinding.AddRateFragmentBinding
import com.codes_roots.imakeapp.helper.BaseApplication
import com.codes_roots.imakeapp.helper.Error_MotionToast
import com.codes_roots.imakeapp.helper.PreferenceHelper
import com.codes_roots.imakeapp.helper.SUCCESS_MotionToast
import com.codes_roots.imakeapp.presentaion.ClickHandler
import com.codes_roots.imakeapp.presentaion.homefragment.viewmodel.MainViewModel
import com.codes_roots.imakeapp.presentaion.mainactivity.MainActivity
import com.codes_roots.imakeapp.presentaion.ratefragment.viewmodel.RateViewModel
import com.satafood.core.entities.myorders.MyOrderModelItem
import com.satafood.core.entities.rate.RateModel
import com.satafood.core.entities.restaurantdetails.MenuCategoriesItem
import javax.inject.Inject

class RateFragment @Inject constructor
    (var Item: MyOrderModelItem, var fragmentFactory : FragmentFactory): Fragment() {

    @Inject
    lateinit var Pref: PreferenceHelper

    @Inject
    lateinit var viewModelFactory: ViewModelProvider.Factory

    private val mainViewModel by viewModels<MainViewModel> { viewModelFactory }

    val viewModel by  viewModels<RateViewModel> { viewModelFactory }

    lateinit var view: AddRateFragmentBinding

    var data: MenuCategoriesItem? = null

    override fun onCreate(savedInstanceState: Bundle?) {
        super.onCreate(savedInstanceState)
        if (savedInstanceState == null) {
         BaseApplication.appComponent.inject(this)
        }
    }
    override fun onCreateView(inflater: LayoutInflater, container: ViewGroup?,
                              savedInstanceState: Bundle?): View? {
        view = DataBindingUtil.inflate(inflater,
            R.layout.add_rate_fragment, container, false)

        view.listener = ClickHandler()
        view.context = context as MainActivity

        view.data = Item

       view.sendRate.setOnClickListener {
           rateRequest()
       }



         viewModel.RateLD?.observe(requireActivity(),{
             if (it !=null){
                 SUCCESS_MotionToast("Thank You For Your Rating",requireActivity())
                 ClickHandler().switchToActivity(requireContext(),MainActivity())


             }else{
                 Error_MotionToast("Try Again",requireActivity())
             }
         })







        return view.root
    }

    fun rateRequest() {
        val rateInfo = RateModel(
            comment = view.comment.text.toString(),
            order_id = Item.order_details!![0].id,
            rate = view.ratingBar.rating.toString(),
            vendor_id = Item.restaurantsId,
            user_id = Pref.UserId
        )

        viewModel.rateOrder(rateInfo)
    }
}





