package com.codes_roots.imakeapp.presentaion.ratefragment.viewmodel

import androidx.lifecycle.MutableLiveData
import androidx.lifecycle.ViewModel
import com.codes_roots.imakeapp.helper.PreferenceHelper
import com.codes_roots.imakeapp.repository.retaurantdetails.RemoteDataSource
import com.satafood.core.entities.rate.RateModel
import io.reactivex.disposables.CompositeDisposable
import kotlinx.coroutines.*
import javax.inject.Inject

class RateViewModel @Inject constructor(private val Datasources: RemoteDataSource,
) : ViewModel() {

    @Inject
    lateinit var Pref: PreferenceHelper
    private var job: Job? = null
    var mCompositeDisposable = CompositeDisposable()

    var rateJob: Job? = null
    var RateLD: MutableLiveData<RateModel>? = null

    val errorMessage = MutableLiveData<String>()
    val loading = MutableLiveData<Boolean>()


    init {
        RateLD = MutableLiveData()
    }




    //addUsersAddress
    fun rateOrder(rateModel: RateModel?) {
        kotlin.runCatching {
        job = CoroutineScope(Dispatchers.IO).launch {
            val response = Datasources.rate(rateModel!!)
            withContext(Dispatchers.Main) {
                if (response.isSuccessful) {
                    RateLD?.postValue(response.body())
                } else {
                    onError("Error : ${response.message()} ")
                }
            }
        }
        }.getOrElse { throw  it }
    }

    private fun onError(message: String) {
        errorMessage.value = message
        loading.value = false
    }

    override fun onCleared() {
        super.onCleared()
        mCompositeDisposable.dispose()
        mCompositeDisposable.clear()
        rateJob?.cancel()
    }
}