package com.codes_roots.imakeapp.presentaion.register.forgetpassword

import android.os.Bundle
import android.view.LayoutInflater
import android.view.View
import android.view.ViewGroup
import android.widget.Toast
import androidx.databinding.DataBindingUtil
import androidx.fragment.app.Fragment
import androidx.fragment.app.viewModels
import androidx.lifecycle.Observer
import androidx.lifecycle.ViewModelProvider
import com.codes_roots.imakeapp.R
import com.codes_roots.imakeapp.databinding.ForgetPasswordFragmentBinding
import com.codes_roots.imakeapp.helper.*
import com.codes_roots.imakeapp.presentaion.homefragment.viewmodel.MainViewModel
import com.codes_roots.imakeapp.presentaion.register.viewmodel.AuthViewModel
import com.satafood.core.entities.login.ForgetPasswordModel
import javax.inject.Inject


class ForgetPasswordFragment: Fragment() {
    @Inject
    lateinit var viewModelFactory: ViewModelProvider.Factory
    val viewModel by viewModels<AuthViewModel> { viewModelFactory }
    private val homeViewModel by viewModels<MainViewModel> { viewModelFactory }
    var firebaseToken : String ? = ""
    @Inject
    lateinit var Pref: PreferenceHelper
    lateinit var view: ForgetPasswordFragmentBinding
    override fun onCreate(savedInstanceState: Bundle?) {
        super.onCreate(savedInstanceState)
        if (savedInstanceState == null) {
            BaseApplication.appComponent.inject(this)
        }
    }
    override fun onCreateView(inflater: LayoutInflater, container: ViewGroup?, savedInstanceState: Bundle?): View{
        view = DataBindingUtil.inflate(inflater,
            R.layout.forget_password_fragment, container, false)


        view.login.setOnClickListener {
            resetPasswordRequest()
         }


        viewModel.forgetPasswordLD?.observe(requireActivity() , Observer {
            if (it != null){
                SUCCESS_MotionToast(it.msg.toString(),requireActivity())
                requireActivity().onBackPressed()
            }else{
                Error_MotionToast(context!!.getString(R.string.errorOccurred),requireActivity())
            }
        })

        viewModel.errorMessage.observe(requireActivity(), Observer {
            Toast.makeText(context , it, Toast.LENGTH_SHORT).show()
        })
   return view.root
    }




    fun resetPasswordRequest() {
        val loginInfo = ForgetPasswordModel(
            email = view.email.text.toString())
     viewModel.forgetPassword(loginInfo)
    }
}