package com.codes_roots.imakeapp.presentaion.register.otp_fragment

import android.app.Activity
import android.app.Dialog
import android.content.Intent
import android.graphics.Color
import android.graphics.drawable.ColorDrawable
import android.os.Bundle
import android.view.LayoutInflater
import android.view.View
import android.view.ViewGroup
import android.widget.Toast
import androidx.databinding.DataBindingUtil
import androidx.fragment.app.Fragment
import androidx.fragment.app.viewModels
import androidx.lifecycle.Observer
import androidx.lifecycle.ViewModelProvider
import com.google.firebase.auth.FirebaseAuth
import com.google.firebase.auth.PhoneAuthProvider
import com.codes_roots.imakeapp.R
import com.codes_roots.imakeapp.databinding.VerificationEmailFragmentBinding
import com.codes_roots.imakeapp.helper.*
import com.codes_roots.imakeapp.presentaion.register.RegisterActivity
import com.codes_roots.imakeapp.presentaion.register.viewmodel.AuthViewModel
import com.satafood.core.entities.login.LoginModel
import com.satafood.core.entities.login.User
import kotlinx.android.synthetic.main.custom_layout_dialog.*
import javax.inject.Inject


class EmailVerificationFragment : Fragment() {

    @Inject
    lateinit var viewModelFactory: ViewModelProvider.Factory

    val viewModel by viewModels<AuthViewModel> { viewModelFactory }

    @Inject
    lateinit var preferenceHelper: PreferenceHelper
    var callback: PhoneAuthProvider.OnVerificationStateChangedCallbacks? = null
    var token: PhoneAuthProvider.ForceResendingToken? = null
    private var verificationCode: String? = null
    private var mAuth: FirebaseAuth? = null
    var data: User? = null

    lateinit var view: VerificationEmailFragmentBinding
    override fun onCreate(savedInstanceState: Bundle?) {
        super.onCreate(savedInstanceState)
        if (savedInstanceState == null) {
            BaseApplication.appComponent.inject(this)
        }


    }

    override fun onCreateView(
        inflater: LayoutInflater,
        container: ViewGroup?,
        savedInstanceState: Bundle?
    ): View{

        view = DataBindingUtil.inflate(
            inflater,
            R.layout.verification_email_fragment, container, false
        )
        arguments?.let {
            data = it.getSerializable("data") as User?
        }

        mAuth = FirebaseAuth.getInstance()

        getVerificationCode()

        view.sendAgain.setOnClickListener {
            view.register.isEnabled = true
            it.isEnabled = false
            view.pinView.text!!.clear()
            getVerificationCode()
        }

        view.register.setOnClickListener {

            verificationCode = view.pinView.text.toString()
            if (verificationCode.isNullOrEmpty()) {
                WARN_MotionToast("enter otp first", requireActivity())
            } else {
                viewModel.checkVerifyEmail(LoginModel(email_code = verificationCode))
                it.isEnabled = false
            }
        }

        viewModel.errorMessage.observe(requireActivity()) {

        Error_MotionToast(it, context as Activity)


        }
        viewModel.otpLD?.observe(requireActivity(), Observer {
            viewModel.processVisibility.value = true
            if (it.status == null) {
                Toast.makeText(context, it.message, Toast.LENGTH_SHORT).show()
                viewModel.processVisibility.value = false
            } else {
                viewModel.processVisibility.value = true
                val dialog = Dialog(activity!!, android.R.style.Theme_Holo_Dialog_NoActionBar)
                dialog.setContentView(R.layout.win_layout_dialog)
                dialog.window?.attributes?.windowAnimations = R.style.animationdialog
                dialog.window?.setBackgroundDrawable(ColorDrawable(Color.TRANSPARENT))
                dialog.show()
                dialog.register.setOnClickListener {
                    dialog.dismiss()
                    (activity as RegisterActivity).finish()
                    val intent = Intent(requireActivity() , RegisterActivity::class.java)
                    (context as RegisterActivity).startActivity(intent)
                }

                dialog.win_image.setOnClickListener {
                    dialog.dismiss()
                    (activity as RegisterActivity).finish()
                    val intent = Intent(requireActivity() , RegisterActivity::class.java)
                    (context as RegisterActivity).startActivity(intent)
                }
                viewModel.processVisibility.value = false

            }
        })

        viewModel.otpLD!!.observe(requireActivity()) {
            if (it.status != null) {
           //     fragmentManager?.popBackStack()
                viewModel.register(data)
            }
        }
        return view.root
    }


    private fun getVerificationCode() {
        val data = User(email =  preferenceHelper.email)
        viewModel.checkAgainVerifyEmail(data)
        SUCCESS_MotionToast("check your email", requireActivity())
    }


}

