package com.codes_roots.imakeapp.presentaion.register.otp_fragment

import android.app.Dialog
import android.graphics.Color
import com.codes_roots.imakeapp.R
import android.graphics.drawable.ColorDrawable
import android.os.Bundle
import android.util.Log
import android.view.LayoutInflater
import android.view.View
import android.view.ViewGroup
import android.widget.Toast
import androidx.core.view.isVisible
import androidx.databinding.DataBindingUtil
import androidx.fragment.app.Fragment
import androidx.fragment.app.viewModels
import androidx.lifecycle.Observer
import androidx.lifecycle.ViewModelProvider
import com.google.firebase.FirebaseException
import   com.google.firebase.auth.*
import com.codes_roots.imakeapp.databinding.VerificationMobileFragmentBinding
import com.codes_roots.imakeapp.helper.*
import com.codes_roots.imakeapp.presentaion.mainactivity.MainActivity
import com.codes_roots.imakeapp.presentaion.register.RegisterActivity
import com.codes_roots.imakeapp.presentaion.register.viewmodel.AuthViewModel
import com.satafood.core.entities.login.LoginModel
import com.satafood.core.entities.login.User
import kotlinx.android.synthetic.main.custom_layout_dialog.*
import java.util.concurrent.TimeUnit
import javax.inject.Inject


class MobileVerificationFragment: Fragment() {

    private var position: Int = 0

    @Inject
    lateinit var viewModelFactory: ViewModelProvider.Factory

    val viewModel by viewModels<AuthViewModel> { viewModelFactory }
    var data: User? = null

    @Inject
    lateinit var Pref: PreferenceHelper
    var firebaseAuth: FirebaseAuth? = null
    var callback: PhoneAuthProvider.OnVerificationStateChangedCallbacks? = null
    var token: PhoneAuthProvider.ForceResendingToken? = null
    var verificationCode : String  ?=null
    private var mAuth: FirebaseAuth? = null
    private var verificationId: String? = null

    lateinit var view: VerificationMobileFragmentBinding

    override fun onCreate(savedInstanceState: Bundle?) {
        super.onCreate(savedInstanceState)
        if (savedInstanceState == null) {
            BaseApplication.appComponent.inject(this)
        }
        arguments?.let {
            position = it.getInt("fromPaymentFragment", 0)
        }
    }
    override fun onCreateView(inflater: LayoutInflater, container: ViewGroup?, savedInstanceState: Bundle?): View? {

        view = DataBindingUtil.inflate(inflater,
           R.layout.verification_mobile_fragment, container, false)

        mAuth = FirebaseAuth.getInstance()

        arguments?.let {
            data = it.getSerializable("data") as User?
        }
        getVerificationCode()

        view.sendAgain.setOnClickListener {
            it.isEnabled = false
            view.register.isEnabled = true
            view.pinView.text!!.clear()
            getVerificationCode()
        }
        view.verifyByEmail.setOnClickListener {
            switchToVerificationFragmentWithData()
        }
        view.register.setOnClickListener {
            verificationCode = view.pinView.text.toString()
            if (verificationCode.isNullOrEmpty()){
                WARN_MotionToast("enter otp first",requireActivity())
            }else{
                verifyCode(verificationCode!!)
            }
        }
        viewModel.authLD?.observe(requireActivity(), Observer {
            SUCCESS_MotionToast("تم التفعيل بنجاح", requireActivity())
        })

        return view.root
    }


    private val callbacks = object : PhoneAuthProvider.OnVerificationStateChangedCallbacks() {
        override fun onVerificationCompleted(phoneAuthCredential: PhoneAuthCredential) {
            addPhoneNumber(phoneAuthCredential)
            //  SUCCESS_MotionToast("success", requireActivity())
            view.progress.isVisible =false
        }

        override fun onVerificationFailed(exception: FirebaseException) {
            try {
                Log.d("phone", "$exception")
                Error_MotionToast("$exception", context as RegisterActivity)
//                view.register.isEnabled = false
                view.sendAgain.isEnabled = true
                //   switchToVerificationFragmentWithData()
            }catch (e:Exception){}

        }
        override fun onCodeSent(
            s: String,
            token: PhoneAuthProvider.ForceResendingToken,
        ){
            super.onCodeSent(s, token)
            verificationId = s
        }
    }


    private fun addPhoneNumber(phoneAuthCredential: PhoneAuthCredential) {
        FirebaseAuth.getInstance().currentUser?.updatePhoneNumber(phoneAuthCredential)
            ?.addOnCompleteListener { task ->
                if (task.isSuccessful) {
                    Log.d("Phone", "task successful")
                } else {
                    Log.d("Phone", "${task.exception}")
                }
            }
    }
    // below method is use to verify code from Firebase.
    private fun verifyCode(code: String) {
        val credential : PhoneAuthCredential = PhoneAuthProvider.getCredential(
            verificationId.toString(), code)
        signInWithPhoneAuthCredential(credential)

    }

    private fun signInWithPhoneAuthCredential(credential: PhoneAuthCredential) {
        mAuth!!.signInWithCredential(credential)
            .addOnCompleteListener(requireActivity()) { task ->
                if (task.isSuccessful) {
                    try {
                        val data= LoginModel(active = 1)
                        viewModel.activeUserAccount(Pref.UserId,data)
                        val dialog = Dialog(requireActivity(), android.R.style.Theme_Holo_Dialog_NoActionBar)
                        dialog.setContentView(R.layout.win_layout_dialog)
                        setImageResource( dialog.win_image, (context as MainActivity).Pref.appLogo)
                        dialog.window?.attributes?.windowAnimations = R.style.animationdialog
                        dialog.window?.setBackgroundDrawable(ColorDrawable(Color.TRANSPARENT))
                        dialog.show()
                        dialog.register.setOnClickListener {
                            dialog.dismiss()
                            if (position == 1) {
                                fragmentManager?.popBackStack()
                            }else {
                                requireActivity().setResult(10000)
                                requireActivity().finish()
                            }
                        }
                        dialog.win_image.setOnClickListener {
                            dialog.dismiss()
                            if (position == 1) {
                                fragmentManager?.popBackStack()
                            }else {
                                requireActivity().setResult(10000)
                                requireActivity().finish()
                            }

                        }
                    }catch (e:Exception){

                        Toast.makeText(requireContext(),"يوجد خطأ", Toast.LENGTH_SHORT).show()
                    }
                } else {
                    // Sign in failed, display a message and update the UI
                    if (task.exception is FirebaseAuthInvalidCredentialsException) {
                        // The verification code entered was invalid
                        Toast.makeText(requireContext(),task.exception!!.message, Toast.LENGTH_SHORT).show()
                        Log.d("dataViewModel", viewModel.data.toString())

                    }
                }
            }
    }

    fun getVerificationCode(){
        val mobile = Pref.countryCode+Pref.userPhone
        PhoneAuthProvider.getInstance().verifyPhoneNumber(
            mobile, // Phone number to verify
            60, // Timeout duration
            TimeUnit.SECONDS, // Unit of timeout
            requireActivity(), // Activity (for callback binding)
            callbacks
        )
    }
    fun switchToVerificationFragmentWithData(){
        val fragment = EmailVerificationFragment()
        val bundle = Bundle()
        bundle.putSerializable("data",data)
        fragment.arguments = bundle
        fragmentManager?.beginTransaction()
            ?.setCustomAnimations(
                  R.anim.slide_right,
                  R.anim.exit_right_left ,   R.anim.slide_left,
                  R.anim.exit_left_right )
            ?.replace(  R.id.main_frame, fragment)?.commit()
    }
}





