package com.codes_roots.imakeapp.presentaion.register.registerfragment


import android.os.Bundle
import android.util.Config
import android.util.Log
import android.view.LayoutInflater
import android.view.View
import android.view.ViewGroup
import android.webkit.WebSettings
import android.webkit.WebView
import android.webkit.WebViewClient
import android.widget.ProgressBar
import android.widget.Toast
import androidx.core.view.isVisible
import androidx.databinding.DataBindingUtil

import androidx.fragment.app.Fragment
import androidx.fragment.app.viewModels
import androidx.lifecycle.Observer
import androidx.lifecycle.ViewModelProvider
import com.codes_roots.imakeapp.BuildConfig
import com.codes_roots.imakeapp.R
import com.codes_roots.imakeapp.databinding.RegisterFragment2Binding
import com.codes_roots.imakeapp.databinding.RegisterFragmentBinding
import com.codes_roots.imakeapp.helper.*
import com.codes_roots.imakeapp.presentaion.register.RegisterActivity
import com.codes_roots.imakeapp.presentaion.register.otp_fragment.MobileVerificationFragment
import com.codes_roots.imakeapp.presentaion.register.viewmodel.AuthViewModel
import com.satafood.core.entities.login.User
import kotlinx.android.synthetic.main.web_view.*
import javax.inject.Inject


class RegisterFragment : Fragment() {

    @Inject
    lateinit var viewModelFactory: ViewModelProvider.Factory

    val viewModel by viewModels<AuthViewModel> { viewModelFactory }

    @Inject
    lateinit var Pref: PreferenceHelper

    lateinit var view: RegisterFragment2Binding

    val progressBar: ProgressBar? = null


    override fun onCreate(savedInstanceState: Bundle?) {
        super.onCreate(savedInstanceState)
        if (savedInstanceState == null) {
            BaseApplication.appComponent.inject(this)

        }
    }
    override fun onCreateView(
        inflater: LayoutInflater,
        container: ViewGroup?,
        savedInstanceState: Bundle?
    ): View {

        view = DataBindingUtil.inflate(
            inflater,
            R.layout.register_fragment2, container, false
        )

        view.register.setOnClickListener {
            Log.d("countryCode", view.ccp.fullNumber.toString()+ view.mobile.text.toString())
            if (!FormValidationRegister2().submitForm(view, requireContext(),this)){
                FormValidationRegister2().invalidForm(view, requireContext())
            }
            else{
                getVerificationCode()
            }
        }

        viewModel.processVisibility.observe(requireActivity()) {
            view.progress.isVisible = it
        }

        viewModel.authLD?.observe(requireActivity(), Observer {
            viewModel.processVisibility.value = true
            if (it.token == null) {
                Toast.makeText(context, it.message, Toast.LENGTH_SHORT).show()
                viewModel.processVisibility.value = false
            } else {
                viewModel.processVisibility.value = true
                Pref.userName = (it.user!!.username)
                Pref.token = (it.token)
                Pref.UserId  =  it.user?.id!!
                Pref.code = it.user!!.code
                Pref.email = it.user!!.email
                viewModel.processVisibility.value = false
              //  switchToVerificationFragmentWithData()
                (context as RegisterActivity).setResult(10000)
                (context as RegisterActivity).finish()
            }
        })


        viewModel.errorMessage.observe(requireActivity(), Observer {
            Toast.makeText(context, it, Toast.LENGTH_SHORT).show()
            Log.d("errorMessage", it)

        })

        return view.root
    }

    private fun switchToVerificationFragmentWithData(){
        val fragment = MobileVerificationFragment()
        (context as RegisterActivity).supportFragmentManager.beginTransaction()
            .setCustomAnimations(R.anim.slide_right,R.anim.exit_right_left , R.anim.slide_left,R.anim.exit_left_right )
            .replace(R.id.main_frame, fragment).addToBackStack(null).commit()
    }

    private fun getVerificationCode() {
        val registerInfo = User(
    //        email = view.email.text.toString(),
            user_group_id = 2,
            mobile = view.mobile.text.toString(),
            username = view.username.text.toString(),
            password = view.password.text.toString(),
            code = view.code.text.toString(),
            vendor_id = BuildConfig.VendorID.toInt()
        )
        viewModel.register(registerInfo)
    }
}