package com.codes_roots.imakeapp.presentaion.reviews_fragment


import android.annotation.SuppressLint
import android.view.LayoutInflater
import android.view.ViewGroup
import androidx.databinding.DataBindingUtil
import androidx.recyclerview.widget.DiffUtil
import androidx.recyclerview.widget.ListAdapter
import androidx.recyclerview.widget.RecyclerView
import com.codes_roots.imakeapp.R
import com.codes_roots.imakeapp.databinding.ReviewsItemBinding
import com.codes_roots.imakeapp.presentaion.vendordetailsfragment.viewmodel.RestaurantDetailsViewModel
import com.satafood.core.entities.restaurantdetails.Rates
import com.satafood.core.entities.reviews.Rate

class ReviewsAdapter :
    ListAdapter<Rate,  ViewHolder>( DiffCallback()){

    override fun onCreateViewHolder(p0: ViewGroup, p1: Int):  ViewHolder {

        val binding: ReviewsItemBinding = DataBindingUtil.inflate(
            LayoutInflater.from(p0.context),
            R.layout.reviews_item, p0, false
        )
        return  ViewHolder(binding)

    }



    override fun onBindViewHolder(holder:  ViewHolder, position: Int) {
        val review = currentList[position]
         holder.binding.reviewDate.text = review.created?.substring(0,10)
        holder.bind( currentList[position])

    }

}


private  class  DiffCallback : DiffUtil.ItemCallback<Rate>() {
    override fun areItemsTheSame(oldItem: Rate, newItem: Rate) =
        oldItem.id == newItem.id

    @SuppressLint("DiffUtilEquals")
    override fun areContentsTheSame(oldItem: Rate, newItem: Rate) =
        oldItem == newItem
}



class  ViewHolder(
    val binding: ReviewsItemBinding,
) : RecyclerView.ViewHolder(binding.root) {
    fun bind(data: Rate) {
        binding.data = data
    }


}

