package com.codes_roots.imakeapp.presentaion.search_fragment.adapter

import android.annotation.SuppressLint
import android.content.Context
import android.view.LayoutInflater
import android.view.ViewGroup
import androidx.databinding.DataBindingUtil
import androidx.recyclerview.widget.DiffUtil
import androidx.recyclerview.widget.ListAdapter
import androidx.recyclerview.widget.RecyclerView
import com.codes_roots.imakeapp.R
import com.codes_roots.imakeapp.databinding.SearchItemsAdapterBinding
import com.codes_roots.imakeapp.presentaion.ClickHandler
import com.codes_roots.imakeapp.presentaion.mainactivity.MainActivity
import com.satafood.core.mapper.homepage.MostSellItemUseCase
import com.satafood.core.mapper.search_model_mapper.ItemResultMapper


class Items_Adapter(val context: Context,private val onItemClick: (ItemResultMapper) -> Unit) :
    ListAdapter<ItemResultMapper, Items_Adapter.CustomViewHolder>(ItemDiffCallback()) {

    override fun onCreateViewHolder(p0: ViewGroup, p1: Int): CustomViewHolder {
        val binding: SearchItemsAdapterBinding = DataBindingUtil.inflate(
            LayoutInflater.from(p0.context),
            R.layout.search_items_adapter, p0, false
        )
        return CustomViewHolder(binding){
            onItemClick(it)

        }
    }

    override fun onBindViewHolder(holder: CustomViewHolder, position: Int){

        holder.bind(context, currentList[position])

    }

    inner class CustomViewHolder(
        val binding: SearchItemsAdapterBinding,  private val onItemClick: (ItemResultMapper) -> Unit,
    ) : RecyclerView.ViewHolder(binding.root) {

        init {
            binding.root.setOnClickListener {
                onItemClick(currentList[adapterPosition])
            }
        }
        fun bind(context: Context?, data: ItemResultMapper) {

            binding.listener = ClickHandler()
            binding.data = data
            binding.context = context as MainActivity?

        }


    }
}

class ItemDiffCallback : DiffUtil.ItemCallback<ItemResultMapper>() {

    override fun areItemsTheSame(oldItem: ItemResultMapper, newItem: ItemResultMapper) =
        oldItem.id == newItem.id

    @SuppressLint("DiffUtilEquals")
    override fun areContentsTheSame(oldItem: ItemResultMapper, newItem: ItemResultMapper) =
        oldItem == newItem
}


