package com.codes_roots.imakeapp.presentaion.search_fragment.adapter

import android.annotation.SuppressLint
import android.content.Context
import android.view.LayoutInflater
import android.view.ViewGroup
import androidx.databinding.DataBindingUtil
import androidx.recyclerview.widget.DiffUtil
import androidx.recyclerview.widget.ListAdapter
import androidx.recyclerview.widget.RecyclerView
import com.codes_roots.imakeapp.R
import com.codes_roots.imakeapp.databinding.SearchStoresAdapterBinding
import com.codes_roots.imakeapp.presentaion.ClickHandler
import com.codes_roots.imakeapp.presentaion.mainactivity.MainActivity
import com.satafood.core.mapper.search_model_mapper.StoresResultMapper


class StoresAdapter(val context: Context) : ListAdapter<StoresResultMapper, StoreViewHolder>(
   StoressDiffCallback())  {

    override fun onCreateViewHolder(p0: ViewGroup, p1: Int): StoreViewHolder {
        val binding: SearchStoresAdapterBinding = DataBindingUtil.inflate(
            LayoutInflater.from(p0.context),
            R.layout.search_stores_adapter, p0, false
        )
        return StoreViewHolder(binding)
    }

    override fun onBindViewHolder(holder: StoreViewHolder, position: Int){

        holder.bind(context,currentList[position])
        holder.binding.description.apply {
            isSelected = true
            text = ""
            if (currentList[position].CuisinesList?.isNotEmpty() == true)
                currentList[position].CuisinesList?.map { cuisine -> holder.binding.description.append(cuisine.name + ",") }
            else
                text = currentList[position].name
        }
    }

    }

    class StoressDiffCallback : DiffUtil.ItemCallback<StoresResultMapper>() {

    override fun areItemsTheSame(oldItem: StoresResultMapper, newItem: StoresResultMapper) =
        oldItem.id == newItem.id

    @SuppressLint("DiffUtilEquals")
    override fun areContentsTheSame(oldItem: StoresResultMapper, newItem: StoresResultMapper) =
        oldItem == newItem
}


class StoreViewHolder(
    val binding: SearchStoresAdapterBinding
) : RecyclerView.ViewHolder(binding.root) {


    fun bind(context: Context?, data: StoresResultMapper) {

        binding.listener = ClickHandler()
        binding.data = data
        binding.context = context as MainActivity?

    }


}
