package com.codes_roots.imakeapp.presentaion.sortfragment

import android.os.Bundle
import android.view.LayoutInflater
import android.view.View
import android.view.ViewGroup
import androidx.databinding.DataBindingUtil
import com.codes_roots.imakeapp.R
import com.codes_roots.imakeapp.databinding.SortFragmentBinding
import com.codes_roots.imakeapp.helper.BaseApplication
import com.codes_roots.imakeapp.presentaion.ClickHandler
import com.codes_roots.imakeapp.presentaion.mainactivity.MainActivity
import com.codes_roots.imakeapp.presentaion.stores_fragment.mvi.RestaurantsListIntent
import com.codes_roots.imakeapp.presentaion.stores_fragment.viewmodel.RestaurantsListViewModel
import com.google.android.material.bottomsheet.BottomSheetDialogFragment
import com.codes_roots.imakeapp.helper.WARN_MotionToast
import javax.inject.Inject

class SortFragment @Inject constructor(var viewmodel: RestaurantsListViewModel) :
    BottomSheetDialogFragment() {

    companion object {
        const val TAG = "TownBottomSheetDialogFragment"
    }

    lateinit var sortListAdapter: Sort_List_Adapter

    lateinit var view: SortFragmentBinding
    var SelectedSortOption = 0
    override fun onCreate(savedInstanceState: Bundle?) {
        super.onCreate(savedInstanceState)
        BaseApplication.appComponent.inject(this)
    }

    override fun onCreateView(
        inflater: LayoutInflater, container: ViewGroup?,
        savedInstanceState: Bundle?,
    ): View? {
        view = DataBindingUtil.inflate(inflater,
            R.layout.sort_fragment, container, false)
        view.listener = ClickHandler()
        view.context = context as MainActivity
        view.ButtonClick.setOnClickListener {
            var viewstate = viewmodel.state.value
            if (viewstate?.BranchesUseCaseData != null) {
                if (SelectedSortOption == 0) {
                    viewmodel.intents.trySend(RestaurantsListIntent.SortByName(viewstate?.copy(
                        filterText = getString(R.string.SortName))))
                } else if (SelectedSortOption == 1) {
                    viewmodel.intents.trySend(RestaurantsListIntent.SortByDeliveryTime(viewstate?.copy(
                        filterText = getString(R.string.DeliveryTime))))
                } else if (SelectedSortOption == 2) {
                    viewmodel.intents.trySend(RestaurantsListIntent.SortByDeliveryCost(viewstate?.copy(
                        filterText = getString(R.string.DeliveryCost))))
                } else if (SelectedSortOption == 3) {
                    viewmodel.intents.trySend(RestaurantsListIntent.SortByDeliveryRating(viewstate?.copy(
                        filterText = getString(R.string.rate))))
                }
            } else {
                WARN_MotionToast(requireActivity().getString(R.string.noResturant),
                    requireActivity())
            }
            this.dismiss()

        }

        view.dismiss.setOnClickListener {
            this.dismiss()
        }
        val data = arrayListOf(getString(R.string.SortName),
            getString(R.string.DeliveryTime),
            getString(R.string.DeliveryCost),
            getString(R.string.rate))

        sortListAdapter = Sort_List_Adapter(viewmodel, this, data)

        view.sortRecycle.apply { adapter = sortListAdapter }


        return view.root
    }


}