package com.codes_roots.imakeapp.presentaion.stores_fragment

import android.annotation.SuppressLint
import android.app.Activity
import android.app.Dialog
import android.content.ActivityNotFoundException
import android.content.Intent
import android.graphics.Color
import android.graphics.drawable.ColorDrawable
import android.os.Bundle
import android.speech.RecognizerIntent
import android.util.Log
import android.view.*
import android.view.View.GONE
import android.widget.Toast
import androidx.appcompat.content.res.AppCompatResources
import androidx.constraintlayout.widget.ConstraintLayout
import androidx.core.view.isVisible
import androidx.core.widget.doOnTextChanged
import androidx.databinding.DataBindingUtil
import androidx.fragment.app.Fragment
import androidx.fragment.app.FragmentFactory
import androidx.fragment.app.viewModels
import androidx.lifecycle.ViewModelProvider
import androidx.lifecycle.lifecycleScope
import androidx.recyclerview.widget.LinearLayoutManager
import androidx.recyclerview.widget.RecyclerView
import com.codes_roots.imakeapp.R
import com.codes_roots.imakeapp.databinding.SideMenuBinding
import com.codes_roots.imakeapp.databinding.StoresFragmentBinding
import com.codes_roots.imakeapp.helper.*
import com.codes_roots.imakeapp.presentaion.ClickHandler
import com.codes_roots.imakeapp.presentaion.choose_language.LanguageActivity
import com.codes_roots.imakeapp.presentaion.homefragment.HomeViewModel
import com.codes_roots.imakeapp.presentaion.homefragment.adapters.SliderAdapter
import com.codes_roots.imakeapp.presentaion.homefragment.viewmodel.UserError
import com.codes_roots.imakeapp.presentaion.mainactivity.MainActivity
import com.codes_roots.imakeapp.presentaion.menufragment.adapter.StaticPagesAdapter
import com.codes_roots.imakeapp.presentaion.menufragment.viewmodel.StaticPagesViewModel
import com.codes_roots.imakeapp.presentaion.mywallet.mvi.HomeIntent
import com.codes_roots.imakeapp.presentaion.stores_fragment.adapter.BranchesAdapter
import com.codes_roots.imakeapp.presentaion.stores_fragment.adapter.Cusines_Adapter
import com.codes_roots.imakeapp.presentaion.stores_fragment.mvi.RestaurantsListIntent
import com.codes_roots.imakeapp.presentaion.stores_fragment.viewmodel.RestaurantsListViewModel
import com.codes_roots.imakeapp.presentaion.vendordetailsfragment.viewmodel.RestaurantDetailsViewModel
import com.satafood.core.base.DataState
import com.satafood.core.entities.google.GoogleModel
import com.satafood.core.entities.google.SliderModel
import kotlinx.android.synthetic.main.stores_fragment.*
import kotlinx.coroutines.flow.collect
import kotlinx.coroutines.launch
import net.yslibrary.android.keyboardvisibilityevent.KeyboardVisibilityEvent.setEventListener
import net.yslibrary.android.keyboardvisibilityevent.KeyboardVisibilityEventListener
import java.util.*
import javax.inject.Inject


open class StoresFragment @Inject constructor(
    private val fragmentFactory: FragmentFactory,
    var Pref: PreferenceHelper,
) :
    Fragment() {

    private var MorePage: Boolean = true
    private var curremtlang ///true if arabic
            = false

    @Inject
    lateinit var viewModelFactory: ViewModelProvider.Factory

    private val REQUEST_CODE_STT = 102


    lateinit var view: StoresFragmentBinding

    private val homeViewModel by viewModels<HomeViewModel> { viewModelFactory }

    val viewModelRestaurants by viewModels<RestaurantDetailsViewModel> { viewModelFactory }

    lateinit var CusinesAdapter: Cusines_Adapter

    lateinit var BranchesAdapter: BranchesAdapter

    internal var page = 0

    var cat_id: Int? = null

    var sectionName: String? = null

    var checkKey: String? = null

    lateinit var staticPagesAdapter: StaticPagesAdapter

    val viewModel by viewModels<RestaurantsListViewModel> { viewModelFactory }

    val menuViewModel by viewModels<StaticPagesViewModel> { viewModelFactory }

    override fun onCreate(savedInstanceState: Bundle?) {
        childFragmentManager.fragmentFactory = fragmentFactory
        super.onCreate(savedInstanceState)
        if (savedInstanceState == null) {
            BaseApplication.appComponent.inject(this)

        }
        ClickHandler().bottomNavItemSelected(requireContext(), R.id.home, false)
        cat_id = requireArguments().getInt("CatId")

    }


    fun CuisinesRecycleView() {
        CusinesAdapter = Cusines_Adapter(viewModel, requireContext() , this)
        view.cuisinesRecycleView.apply {
            adapter = CusinesAdapter
            isNestedScrollingEnabled = false
            setHasFixedSize(true)
        }
    }

    fun BranchesRecycleView() {
        BranchesAdapter = BranchesAdapter(viewModel, requireContext(), this)
        view.menuRecycleView.apply {
            if (MorePage) {
                addOnScrollListener(object : RecyclerView.OnScrollListener() {
                    override fun onScrolled(recyclerView: RecyclerView, dx: Int, dy: Int) {
                        super.onScrolled(recyclerView, dx, dy)
                        if (MorePage) {
                            val lastVisibleItem =
                                (Objects.requireNonNull(recyclerView.layoutManager) as LinearLayoutManager).findLastCompletelyVisibleItemPosition()
                            Log.e("Position", lastVisibleItem.toString())
                            if (lastVisibleItem == BranchesAdapter.itemCount - 3 && BranchesAdapter.itemCount >= 9 && lastVisibleItem != viewModel.pagingData?.size) {
                                val googleInfo =
                                    GoogleModel(
                                        google_id = Pref.googleID,
                                        CatId = cat_id.toString(),
                                        area_id = (context as MainActivity).Pref.areaId
                                    )

                                val sliderModel =
                                    SliderModel(catId = cat_id.toString(), googleId = Pref.googleID)
                                page++
                                viewModel.intents.trySend(
                                    RestaurantsListIntent
                                        .LoadDataByGoogleID(
                                            viewModel.state.value!!.copy(Progress = true),
                                            googleInfo,
                                            cat_id,
                                            sliderModel, page
                                        )
                                )

//                       view.progress.isVisible = true

                            }
                        }
                    }

                })
            } else {

            }
            layoutManager = LinearLayoutManager(context) // default orientation is vertical
            adapter = BranchesAdapter;
            setHasFixedSize(true)
        }

    }


    @SuppressLint("ClickableViewAccessibility")
    override fun onCreateView(
        inflater: LayoutInflater,
        container: ViewGroup?,
        savedInstanceState: Bundle?,
    ): View? {
        val view: StoresFragmentBinding = DataBindingUtil.inflate(
            inflater,
            R.layout.stores_fragment, container, false
        )

        this.view = view
        CuisinesRecycleView()

        view.top.context = context as MainActivity
        view.top.listener = ClickHandler()
        view.listener = ClickHandler()
        view.context = context as MainActivity
        view.viewModel = viewModel
        view.top.viewModel = viewModel

        view.top.cartSize.text = Pref.retriveCartItemsValue().size.toString()

        sectionName = if (!requireArguments().getString("sectionName").isNullOrEmpty())
            requireArguments().getString("sectionName")
        else
            requireArguments().getString("title")

        checkKey = requireArguments().getString("checkKey")
        val googleInfo =
            GoogleModel(google_id = Pref.googleID, CatId = cat_id.toString(), area_id = (context as MainActivity).Pref.areaId)

        val sectionInfo = GoogleModel(googleId = Pref.googleID)



        when (checkKey) {
            "discountSection" -> {
                viewModel.intents.trySend(
                    RestaurantsListIntent.LoadVendorOffersData
                        (viewModel.state.value!!, sectionInfo)
                )
            }
            "secondSection" -> {
                viewModel.intents.trySend(
                    RestaurantsListIntent.LoadNewOfferData
                        (viewModel.state.value!!, sectionInfo)
                )
            }
            "thirdSection" -> {
                viewModel.intents.trySend(
                    RestaurantsListIntent.LoadMostOrderedBranchData
                        (viewModel.state.value!!, sectionInfo)
                )

            }
            "fourthSection" -> {
                viewModel.intents.trySend(
                    RestaurantsListIntent.LoadMostOrderedBranchData
                        (viewModel.state.value!!, sectionInfo)
                )
            }
            "nearest" -> {
                viewModel.intents.trySend(
                    RestaurantsListIntent.LoadNearestBranchesData
                        (viewModel.state.value!!, sectionInfo)
                )
            }
            "freeDelivery" -> {
                viewModel.intents.trySend(
                    RestaurantsListIntent.LoadFreeDliveryBranchesData
                        (viewModel.state.value!!, sectionInfo)
                )

            }
            else -> {

                view.cuisinesRecycleView.isVisible = true
                view.shimmerViewRounded.isVisible = true
                view.shimmerView.isVisible = true

                val sliderModel = SliderModel(catId = cat_id.toString(), googleId = Pref.googleID)

                viewModel.intents.trySend(
                    RestaurantsListIntent
                        .GetSliderData(
                            viewModel.state.value!!, googleInfo,
                            cat_id, sliderModel
                        )
                )



                viewModel.intents.trySend(
                    RestaurantsListIntent.LoadingCuisines(
                        viewModel.state.value!!,
                        googleInfo,
                        cat_id
                    )
                )
                if (viewModel.state.subscriptionCount.value == 0) {
                    if (page != 1){
                        viewModel.intents.trySend(
                            RestaurantsListIntent
                                .LoadDataByGoogleID(
                                    viewModel.state.value!!,
                                    googleInfo,
                                    cat_id,
                                    sliderModel, 1
                                )

                        )
                    }else{
                        viewModel.intents.trySend(
                            RestaurantsListIntent
                                .LoadDataByGoogleID(
                                    viewModel.state.value!!,
                                    googleInfo,
                                    cat_id,
                                    sliderModel, page+1
                                )

                        )
                    }


                } else {
                    if (page != 1) {
                        viewModel.intents.trySend(
                            RestaurantsListIntent
                                .LoadDataByGoogleID(
                                    viewModel.state.value!!,
                                    googleInfo,
                                    cat_id,
                                    sliderModel, 1
                                )

                        )
                    } else {
                        viewModel.intents.trySend(
                            RestaurantsListIntent
                                .LoadDataByGoogleID(
                                    viewModel.state.value!!,
                                    googleInfo,
                                    cat_id,
                                    sliderModel, page + 1
                                )

                        )
                    }

                }
            }
        }
        view.title.text = sectionName

        view.cardCouponApplied.setOnClickListener {
            view.progressBar.isVisible = true
            view.cardCouponApplied.isVisible = false
            viewModel.pagingData.clear()
            val sliderModel = SliderModel(catId = cat_id.toString(), googleId = Pref.googleID)
            viewModel.intents.trySend(
                RestaurantsListIntent
                    .LoadDataByGoogleID(
                        viewModel.state.value!!.copy(FilterdBranchesData = null, filterText = null, isFilter = false),
                        googleInfo,
                        cat_id,
                        sliderModel, 1
                    )
            )
        }
        view.top.menuIcon.setOnClickListener {
            setUpViews()
        }

        //start shimmer loading
        view.shimmerView.startShimmerAnimation()
        view.shimmerViewRounded.startShimmerAnimation()

        //  view.searchBar.setError("assad")
        view.searchBar.doOnTextChanged { text, start, before, count ->
//            viewModel.intents.trySend(
//                RestaurantsListIntent.SearchByName(
//                    viewModel.state.value,
//                    text.toString()
//                )
//            )
        }
        view.microphone.setOnClickListener {
            val sttIntent = Intent(RecognizerIntent.ACTION_RECOGNIZE_SPEECH)
            sttIntent.putExtra(
                RecognizerIntent.EXTRA_LANGUAGE_MODEL,
                RecognizerIntent.LANGUAGE_MODEL_FREE_FORM
            )
            Log.i("lang", "onCreateView: " + Locale.getDefault().toString())
            sttIntent.putExtra(RecognizerIntent.EXTRA_LANGUAGE, (context as MainActivity).Pref.lang)
            sttIntent.putExtra(RecognizerIntent.EXTRA_PROMPT, "Speak now!")

            try {
                startActivityForResult(sttIntent, REQUEST_CODE_STT)
            } catch (e: ActivityNotFoundException) {
                e.printStackTrace()
                Toast.makeText(
                    requireContext(),
                    "Your device does not support STT.",
                    Toast.LENGTH_LONG
                ).show()
            }
        }
        setEventListener(requireActivity(),
            KeyboardVisibilityEventListener { view ->
                if (view) cuisines_layout?.visibility = GONE
                else cuisines_layout?.visibility = View.VISIBLE
            })


        BranchesRecycleView()

        if (viewModel.state.subscriptionCount.value == 0) {
            page = 1
            getAllData()

        } // check if collect already subscribed
        return view.root

    }

    fun getAllData() {
        Log.i("isactorve", viewModel.state.subscriptionCount.value.toString())
        lifecycleScope.launchWhenStarted {
            viewModel.state.collect { it ->
                view.top.locationName.text = Pref.userLocation
                if (it != null) {
                    try {
                        if (it.Errors != null) {
                            it.Errors.let {
                                when (it) {
                                    is UserError.InvalidId -> "Invalid id"
                                    is UserError.NetworkError -> it.throwable.message
                                    UserError.ServerError -> "Server error"
                                    UserError.Unexpected -> "Unexpected error"
                                    is UserError.UserNotFound -> "User not found"
                                    UserError.ValidationFailed -> "Validation failed"
                                    else -> {}
                                }
                            }
                            viewModel.intents.send(RestaurantsListIntent.DisplayErrors(it))
                        } else {
                            if (!it.sliderData.isNullOrEmpty()) {
                                val pagerPadding = 16
                                view.pager.setPageMargin(20);
                                view.pager.clipToPadding = false
                                view.pager.setPadding(pagerPadding, 0, pagerPadding, 0)
                                if (!it.sliderData.get(0).AdsSpacesprice.isNullOrEmpty()) {
                                    view.pager.isVisible = true
                                    // view.indicator.isVisible = true
                                    it.sliderData[0].AdsSpacesprice!!.let {
                                        SliderAdapter(requireContext(), it) {
                                            lifecycleScope.launch {
                                                homeViewModel.intentChannel.send(
                                                    HomeIntent.GetItemDetails(
                                                        id
                                                    )
                                                )
                                            }
                                        }.also {
                                            view.pager.adapter = it
                                            //   view.indicator.setViewPager(view.pager)
                                        }
                                    }
                                } else {

                                    view.pager.isVisible = false
                                }
                            }

                            if (!it.cuisinesData?.cuisinesList.isNullOrEmpty()) {
                                CusinesAdapter.submitList(it.cuisinesData!!.cuisinesList)
                            }

                            if (it.BranchesData?.branchesList != null) {
                                if (!viewModel.state.value?.filterText.isNullOrEmpty()){
                                    view.cardCouponApplied.isVisible = true
                                    view.cancelFilter.text = viewModel.state.value?.filterText
                                }
                                if (it.BranchesData.branchesList!!.isNotEmpty()) {
                                    if (it.isFilter == true) {
                                        MorePage = false
                                        viewModel.pagingData.clear()
                                        viewModel.pagingData.addAll(it.BranchesData.branchesList!!)
                                        it.BranchesUseCaseData = viewModel.pagingData
                                        BranchesAdapter.submitList(viewModel.pagingData)
                                        view.progressBar.isVisible = false
                                    } else if (it.isLocationChanged == true){

                                        viewModel.pagingData.clear()
                                        viewModel.pagingData.addAll(it.BranchesData.branchesList!!)
                                        it.BranchesUseCaseData = viewModel.pagingData
                                        BranchesAdapter.submitList(viewModel.pagingData)
                                        view.progressBar.isVisible = false
                                    }

                                    else {
                                        view.listSize = it.BranchesData.branchesList!!.size
                                        MorePage = true
                                        viewModel.pagingData.addAll(it.BranchesData.branchesList!!)
                                        it.BranchesUseCaseData = viewModel.pagingData
                                        BranchesAdapter.submitList(viewModel.pagingData)
                                        view.progressBar.isVisible = false
                                    }
                                }else{
                                    MorePage = false
                                }
                            } else {
                                MorePage = false
                                BranchesAdapter.submitList(it.FilterdBranchesData?.branchesList)
                                view.progressBar.isVisible = false
                            }
                            BranchesAdapter.notifyDataSetChanged()
                            //////// Slider viewPager
                            stopShimmer()
                        }
                    } catch (e: Exception) {
                        WARN_MotionToast(e.message!!, context as MainActivity)
                    }
                }
            }
        }


        lifecycleScope.launchWhenCreated {
            homeViewModel.itemDetails.observe(viewLifecycleOwner) {
                when (it!!.status) {
                    DataState.Status.LOADING -> {
                        view.progressBar.isVisible = true
                    }
                    DataState.Status.SUCCESS -> {
                        view.progressBar.isVisible = false
                        if (!it.data.isNullOrEmpty())
                            it.data?.first()?.let { it1 ->
                                ClickHandler().openItemDetailsFragment(
                                    requireContext(),
                                    it1,
                                    it1.menu_categories!!.restaurant_id!!, viewModelRestaurants,0
                                )

                            }
                        else
                            Error_MotionToast(
                                "no data for this vendor",
                                requireActivity()
                            )
                    }
                    DataState.Status.ERROR -> {
                        Error_MotionToast(it.error?.throwableMessage.toString(), requireActivity())
                    }
                }
            }
        }
    }

    fun stopShimmer() {
        view.noOrderFoundLayout.isVisible = false
        view.progress.isVisible = false
        view.shimmerViewRounded.isVisible = false
        view.shimmerView.isVisible = false
        view.shimmerView.stopShimmerAnimation()
        view.shimmerViewRounded.stopShimmerAnimation()
    }


    override fun onActivityResult(requestCode: Int, resultCode: Int, data: Intent?) {
        super.onActivityResult(requestCode, resultCode, data)
        when (requestCode) {
            REQUEST_CODE_STT -> {
                if (resultCode == Activity.RESULT_OK && data != null) {
                    val result = data.getStringArrayListExtra(RecognizerIntent.EXTRA_RESULTS)
                    result?.let {
                        val recognizedText = it[0]
                        view.searchBar.setText(recognizedText)
//                        viewModel.intents.trySend(
//                            RestaurantsListIntent.SearchByName(viewModel.state.value!!,
//                                recognizedText.toString()))


                    }
                }
            }
            1000 ->
                if (data != null) {
                    view.top.locationName.text = Pref.userLocation

                }
        }
    }

    private fun setUpViews() {
        val dialog = Dialog(requireContext())
        dialog.requestWindowFeature(Window.FEATURE_NO_TITLE)
        val binding: SideMenuBinding = SideMenuBinding.inflate(LayoutInflater.from(context))
        dialog.setContentView(binding.root)

        binding.click = ClickHandler()
        binding.context = context as MainActivity
        binding.pref = (context as MainActivity).Pref

        if (PreferenceHelper(requireContext()).UserId > 0)
            binding.loginLayout.visibility = View.GONE
        else {
            binding.logoutLayout.visibility = View.GONE;
        }
        myOrderRecycleView(binding)
        getMenuData()
        binding.dialog = dialog
        binding.langLayout.setOnClickListener {
            //changeAppLanguage()
            Pref.langChosen = false
            ClickHandler().switchToActivity(requireContext(), LanguageActivity())
        }

        val width: Int = (this.resources.getDisplayMetrics().widthPixels * 0.80).toInt()

        dialog.show()
        dialog.window?.apply {
            setLayout(width, ViewGroup.LayoutParams.MATCH_PARENT)
            setBackgroundDrawable(object : ColorDrawable(Color.TRANSPARENT) {})

            // attributes?.windowAnimations = R.style.DialogAnimation

        }

        // to change background when language change to arabic
        if (Pref.lang!!.contains("ar")) {
            dialog.findViewById<ConstraintLayout>(R.id.bg_view).background =
                AppCompatResources.getDrawable(requireContext(), R.drawable.menu_right)
            dialog.window?.setGravity(Gravity.END)
            dialog.window?.attributes?.windowAnimations = R.style.DialogAnimation

        } else {
            dialog.findViewById<ConstraintLayout>(R.id.bg_view).background =
                AppCompatResources.getDrawable(requireContext(), R.drawable.menu_left)
            dialog.window?.setGravity(Gravity.START)
        }


        // to setup menu recyclerView

//        dialog.findViewById<RecyclerView>(R.id.pagesRecycle).apply {
//        favoriteAdapter = MyOrdersAdapter(this@MainActivity,list)
//        adapter = favoriteAdapter
//        layoutManager = LinearLayoutManager(this@MainActivity, LinearLayoutManager.VERTICAL, false)
//        }

    }

    fun getMenuData() {
        lifecycleScope.launchWhenStarted {
            menuViewModel.state.collect {
                if (it != null) {
                    if (it.error != null) {
                        it.error?.let { userError ->
                            when (userError) {
                                is UserError.InvalidId -> "Invalid id"
                                is UserError.NetworkError -> userError.throwable.message
                                UserError.ServerError -> "Server error"
                                UserError.Unexpected -> "Unexpected error"
                                is UserError.UserNotFound -> "User not found"
                                UserError.ValidationFailed -> "Validation failed"
                                else -> {}
                            }
                        }
                        menuViewModel.intents.trySend(
                            com.codes_roots.imakeapp.presentaion.menufragment.mvi.MainIntent.ErrorDisplayed(
                                it
                            )
                        )
                    } else {

                        if (it.progress == true) {
                            menuViewModel.intents.send(
                                com.codes_roots.imakeapp.presentaion.menufragment.mvi.MainIntent.Initialize(
                                    it
                                )
                            )
                        } else {

                            if (it.data?.isNotEmpty() == true)
                            ///newOffersAdapter
                                staticPagesAdapter.submitList(it.data!!)


                        }
                    }
                }

            }
        }
    }

    private fun changeAppLanguage() {
        val i = Intent(activity, LanguageActivity::class.java)
        startActivity(i)
    }


    fun myOrderRecycleView(binding: SideMenuBinding) {
        staticPagesAdapter = StaticPagesAdapter(requireContext())
        binding.pagesRecycle.apply {
            layoutManager = LinearLayoutManager(
                context
            )
            adapter = staticPagesAdapter;
            isNestedScrollingEnabled = true
            setHasFixedSize(true)
        }
    }

}
