package com.codes_roots.imakeapp.presentaion.stores_fragment.adapter

import android.annotation.SuppressLint
import android.content.Context
import android.graphics.Color
import android.view.LayoutInflater
import android.view.ViewGroup
import androidx.core.content.ContextCompat
import androidx.core.view.isVisible
import androidx.databinding.DataBindingUtil
import androidx.recyclerview.widget.DiffUtil
import androidx.recyclerview.widget.ListAdapter
import androidx.recyclerview.widget.RecyclerView
import com.codes_roots.imakeapp.R
import com.codes_roots.imakeapp.databinding.StoresCategoryAdapterBinding
import com.codes_roots.imakeapp.presentaion.ClickHandler
import com.codes_roots.imakeapp.presentaion.mainactivity.MainActivity
import com.codes_roots.imakeapp.presentaion.stores_fragment.StoresFragment
import com.codes_roots.imakeapp.presentaion.stores_fragment.mvi.RestaurantsListIntent
import com.codes_roots.imakeapp.presentaion.stores_fragment.viewmodel.RestaurantsListViewModel
import com.satafood.core.entities.google.GoogleModel
import com.satafood.core.mapper.restaurantslist.CuisinesData
import java.util.*
import kotlin.collections.ArrayList


class Cusines_Adapter(var viewModel: RestaurantsListViewModel, var context: Context?,var fragment: StoresFragment?)
    : ListAdapter<CuisinesData, CustomViewHolder>(CuisinesDiffCallback()) {
    var row_index: Int? = null



    override fun onBindViewHolder(holder: CustomViewHolder, position: Int) {
        holder.bind(context, currentList[position])
        context as MainActivity
        holder.binding.card.setOnClickListener {

            row_index = position
            fragment?.viewModel!!.pagingData.clear()
            fragment?.view?.cardCouponApplied?.isVisible = true
            fragment?.view?.progressBar?.isVisible = true
            fragment?.view?.cancelFilter?.text = currentList[position].name
            val googleInfo =
                GoogleModel(google_id = (context as MainActivity).Pref.googleID, CatId =  fragment!!.cat_id.toString(), area_id = (context as MainActivity).Pref.areaId, CuisinesId = currentList[position].id)

            val viewState = viewModel.state.value
            viewModel.intents.trySend(RestaurantsListIntent.LoadDataByCatId(viewState!!.copy(BranchesData = null),
                googleInfo,1
            )
            )
            notifyDataSetChanged()
        }


        if (row_index == position)
        { holder.binding.mView.setBackgroundDrawable(ContextCompat
            .getDrawable(context!!,R.color.light_yellow))
        } else {
            holder.binding.mView.setBackgroundDrawable(ContextCompat
                .getDrawable(context!!, android.R.color.white))
        }
    }
    override fun onCreateViewHolder(p0: ViewGroup, p1: Int): CustomViewHolder {
        val binding: StoresCategoryAdapterBinding = DataBindingUtil.inflate(
            LayoutInflater.from(p0.context),
            R.layout.stores_category_adapter, p0, false
        )
        val colors = ArrayList<String>()
        colors.add("#dfedff")
        colors.add("#f6e8ff")
        colors.add("#ffe4ea")
        colors.add("#fff3d4")

        val r = Random()
        val i1: Int = r.nextInt(4 - 0) + 0

        binding.card.setCardBackgroundColor(Color.parseColor(colors[i1]))

        return CustomViewHolder(binding)
    }


}

private  class CuisinesDiffCallback : DiffUtil.ItemCallback<CuisinesData>() {

    override fun areItemsTheSame(oldItem: CuisinesData, newItem: CuisinesData) =
        oldItem.id == newItem.id

    @SuppressLint("DiffUtilEquals")
    override fun areContentsTheSame(oldItem: CuisinesData, newItem: CuisinesData) =
        oldItem.hashCode() == newItem.hashCode()
}

class CustomViewHolder(
    val binding: StoresCategoryAdapterBinding
) : RecyclerView.ViewHolder(binding.root) {


    fun bind(context: Context?, data: CuisinesData) {

        binding.listener = ClickHandler()
        binding.data = data
        binding.context = context as MainActivity?
    }


}
