package com.codes_roots.imakeapp.presentaion.stores_fragment.adapter

import android.annotation.SuppressLint
import android.content.Context
import android.view.LayoutInflater
import android.view.View
import android.view.ViewGroup
import androidx.core.view.isVisible
import androidx.databinding.DataBindingUtil
import androidx.recyclerview.widget.DiffUtil
import androidx.recyclerview.widget.ListAdapter
import androidx.recyclerview.widget.RecyclerView
import com.codes_roots.imakeapp.R
import com.codes_roots.imakeapp.databinding.StoresAdapterBinding
import com.codes_roots.imakeapp.presentaion.ClickHandler
import com.codes_roots.imakeapp.presentaion.mainactivity.MainActivity
import com.codes_roots.imakeapp.presentaion.stores_fragment.StoresFragment
import com.codes_roots.imakeapp.presentaion.stores_fragment.mvi.RestaurantsListIntent
import com.codes_roots.imakeapp.presentaion.stores_fragment.viewmodel.RestaurantsListViewModel
import com.satafood.core.mapper.restaurantslist.BranchesDataUseCase

class BranchesAdapter(
    var viewModel: RestaurantsListViewModel, var context: Context?, var fragment: StoresFragment?,
) :

    ListAdapter<BranchesDataUseCase, BranchesViewHolder>(BranchesDiffCallback()) {

    private val ITEM_TYPE_Vendor = 0
    private val ITEM_TYPE_BANNER_AD = 1

    override fun getItemViewType(position: Int): Int {
        return if (position == 0 || position == 5) {

            ITEM_TYPE_BANNER_AD

        } else {

            ITEM_TYPE_Vendor
        }
    }

    override fun onCreateViewHolder(p0: ViewGroup, p1: Int): BranchesViewHolder {

        val binding: StoresAdapterBinding = DataBindingUtil.inflate(
            LayoutInflater.from(p0.context),
            R.layout.stores_adapter, p0, false
        )


        //      ShapeAppearanceModel(context!!, binding.appCompatImageView)

        return BranchesViewHolder(binding)

    }


    override fun onBindViewHolder(holder: BranchesViewHolder, position: Int) {
        holder.bind(context, currentList[position], fragment = fragment!!)

        if (currentList[position].description != null) {
            if (currentList[position].description != "false") {

                holder.binding.offerView.visibility = View.VISIBLE

            } else {
                holder.binding.offerView.isVisible = false
            }

        } else {
            holder.binding.offerView.isVisible = false
        }

//        if (position == 3) {
//            holder.binding.pager.isVisible = true
//            holder.binding.indicator.isVisible = true
//            //////// Slider viewPager
//            try {
//                val adsSliderData = viewModel.state.value!!.sliderData?.get(1)!!.AdsSpacesprice!!
//                if (adsSliderData.isNotEmpty()) {
//                    adsSliderData.let {
//                        BranchesSliderAdapter(context!!, it) { id ->
//                        }
//                    }.also {
//                        holder.binding.pager.adapter = it
//                        holder.binding.indicator.setViewPager(holder.binding.pager)
//
//                    }
//                } else {
//
//                    holder.binding.pager.isVisible = false
//                }
//            } catch (e: Exception) {
//            }
//        }

        holder.binding.offers.apply {
            isSelected = true
            if (text == ""){
            currentList[position].CuisinesList?.map { cuisine ->
                holder.binding.offers.append(cuisine.name + " - ")
            }
            }
        }


    }

}


private class BranchesDiffCallback : DiffUtil.ItemCallback<BranchesDataUseCase>() {

    override fun areItemsTheSame(oldItem: BranchesDataUseCase, newItem: BranchesDataUseCase) =
        oldItem.id == newItem.id

    @SuppressLint("DiffUtilEquals")
    override fun areContentsTheSame(oldItem: BranchesDataUseCase, newItem: BranchesDataUseCase) =
        oldItem == newItem
}


class BranchesViewHolder(
    val binding: StoresAdapterBinding,
) : RecyclerView.ViewHolder(binding.root) {


    fun bind(context: Context?, data: BranchesDataUseCase, fragment: StoresFragment) {
        binding.listener = ClickHandler()
        binding.data = data
        binding.context = context as MainActivity?
        binding.fragment = fragment
    }

}





