package com.codes_roots.imakeapp.presentaion.stores_fragment.viewmodel

import androidx.lifecycle.viewModelScope
import com.codes_roots.imakeapp.presentaion.homefragment.viewmodel.MainViewState
import com.codes_roots.imakeapp.presentaion.mainactivity.BaseViewModel
import com.codes_roots.imakeapp.presentaion.stores_fragment.mvi.RestaurantsListIntent
import com.codes_roots.imakeapp.presentaion.stores_fragment.mvi.RestaurantsListViewStateIntent
import com.codes_roots.imakeapp.presentaion.stores_fragment.mvi.mapResIntentToViewState
import com.codes_roots.imakeapp.repository.RestaurantsList.StoresListDataRepo
import com.satafood.core.mapper.restaurantslist.BranchesDataUseCase
import kotlinx.coroutines.Job
import kotlinx.coroutines.channels.Channel
import kotlinx.coroutines.flow.MutableStateFlow
import kotlinx.coroutines.flow.collect
import kotlinx.coroutines.flow.receiveAsFlow
import kotlinx.coroutines.launch
import javax.inject.Inject

open class RestaurantsListViewModel @Inject constructor(val repository: StoresListDataRepo) :
    BaseViewModel<MainViewState>() {

    val intents: Channel<RestaurantsListIntent> = Channel(Channel.UNLIMITED)

    protected val _viewState: MutableStateFlow<RestaurantsListViewStateIntent?> =

        MutableStateFlow(RestaurantsListViewStateIntent())

    val state: MutableStateFlow<RestaurantsListViewStateIntent?> get() = _viewState


    private var job: Job? = null
    var pagingData  = ArrayList<BranchesDataUseCase>()
    init {

        _viewState.value = RestaurantsListViewStateIntent().copy(Progress = true)

        getIntent()
    }

    fun getIntent() {
        job = viewModelScope.launch() {
            intents.receiveAsFlow().collect {
                _viewState.value = (mapResIntentToViewState(it, repository))
            }
        }
    }

    override fun onCleared() {

        super.onCleared()
        job!!.cancel()

    }

}