package com.codes_roots.imakeapp.presentaion.support

import android.content.Context
import android.view.LayoutInflater
import android.view.ViewGroup
import androidx.recyclerview.widget.AsyncListDiffer
import androidx.recyclerview.widget.DiffUtil
import androidx.recyclerview.widget.LinearLayoutManager
import androidx.recyclerview.widget.RecyclerView
import com.codes_roots.imakeapp.databinding.QueryItemBinding
import com.codes_roots.imakeapp.presentaion.ClickHandler
import com.codes_roots.imakeapp.presentaion.contactus.ContactUsFragment
import com.satafood.core.entities.support.questionsItem

class CommonQuestionsAdapter (val context: Context): RecyclerView.Adapter<CommonQuestionsAdapter.ViewHolder>() {

    inner class ViewHolder(val binding: QueryItemBinding) : RecyclerView.ViewHolder(binding.root)

    private val diffCallback = object : DiffUtil.ItemCallback<questionsItem>(){
        override fun areItemsTheSame(oldItem: questionsItem, newItem: questionsItem): Boolean {
            return oldItem.id == newItem.id
        }

        override fun areContentsTheSame(oldItem: questionsItem, newItem: questionsItem): Boolean {
            return oldItem == newItem
        }
    }



    private val differ = AsyncListDiffer(this, diffCallback)

    var questions : MutableList<questionsItem>
        get() = differ.currentList
        set(value) { differ.submitList(value)}


    override fun onCreateViewHolder(parent: ViewGroup, viewType: Int): ViewHolder {
        return ViewHolder(
            QueryItemBinding.inflate(
            LayoutInflater.from(parent.context),
            parent,
            false
        ))
    }

    override fun onBindViewHolder(holder: ViewHolder, position: Int) {
        holder.binding.apply {
            val questionn = questions[position]
            question.text = questionn.questions
            message.text = questionn.answer
            val secondAdapter = SubmenuAdapter(context)
            rvSubQueries.adapter = secondAdapter
            rvSubQueries.layoutManager = LinearLayoutManager(context, LinearLayoutManager.VERTICAL, false)
            secondAdapter.questions = questionn.submenu
            no.setOnClickListener {
                ClickHandler().SwitchBetweenFragments(context, ContactUsFragment())
            }
            questionView.setOnClickListener {
                if (questionn.submenu.isEmpty()){
                    expand = expand != true
                }
                else{
                    expandBoth = expandBoth != true
                }
                arrow = arrow != true

            }

        }
    }

    override fun getItemCount() = questions.size

}