package com.codes_roots.imakeapp.presentaion.support

import android.content.Context
import android.util.Log
import android.view.LayoutInflater
import android.view.ViewGroup
import androidx.recyclerview.widget.DiffUtil
import androidx.recyclerview.widget.ListAdapter
import androidx.recyclerview.widget.RecyclerView
import com.codes_roots.imakeapp.databinding.RowItemSupportQueryBinding
import com.codes_roots.imakeapp.helper.VerticalMarginItemDecoration
import com.codes_roots.imakeapp.helper.dpToPx
import com.codes_roots.imakeapp.presentaion.ClickHandler
import com.codes_roots.imakeapp.presentaion.mainactivity.MainActivity
import com.satafood.core.entities.support.Query

class QueriesAdapter(var viewModel: SupportViewModel, private val onItemClick: (Query) -> Unit, var context: Context?) :

    ListAdapter<Query, QueriesAdapter.QueriesViewHolder>(Companion) {
    companion object : DiffUtil.ItemCallback<Query>() {
        override fun areItemsTheSame(oldItem: Query, newItem: Query): Boolean {
            return oldItem.id == newItem.id
        }

        override fun areContentsTheSame(oldItem: Query, newItem: Query): Boolean {
            return oldItem.hashCode() == newItem.hashCode()
        }
    }


    override fun onCreateViewHolder(parent: ViewGroup, viewType: Int): QueriesViewHolder {
        var binding =
            RowItemSupportQueryBinding.inflate(LayoutInflater.from(parent.context), parent, false)
        return QueriesViewHolder(binding) {
            onItemClick(it)
        }
    }

    override fun onBindViewHolder(holder: QueriesViewHolder, position: Int) {
        val item = currentList[position]
        holder.bind(currentList[position])
       holder.itemBinding.mainLayout.setOnClickListener {
           Log.d("TAG", "currentList : ${currentList[position].submenu.isNullOrEmpty()}" )
           if(currentList[position].submenu.isNullOrEmpty())
           //  onItemClick(currentList[adapterPosition])
               ClickHandler().openAnswerFragment(context as MainActivity,position,currentList[position])

           else {
               val expand = holder.itemBinding.expand!!
               holder.itemBinding.expand = !expand
               Log.d("TAG", "adapter: $expand")

           }
       }
        item?.let {
            holder.bind(it)


        }

    }

    inner class QueriesViewHolder(
         var itemBinding: RowItemSupportQueryBinding,
        onItemClick: (Query) -> Unit
    ) : RecyclerView.ViewHolder(itemBinding.root) {

        init {
//            itemBinding.layoutContainer.setOnClickListener {
//                Log.d("TAG", "currentList : ${currentList[adapterPosition].submenu.isNullOrEmpty()}" )
//                if(currentList[adapterPosition].submenu.isNullOrEmpty())
//                //  onItemClick(currentList[adapterPosition])
//               ClickHandler().openAnswerFragment(context as MainActivity,0,viewModel)
//
//                else {
//                    val expand = itemBinding.expand!!
//                    itemBinding.expand = !expand
//                    Log.d("TAG", "adapter: $expand")
//
//                }
//            }
        }

        fun bind(item: Query) {
            item.apply {
                itemBinding.tvQuery.text = questions
                itemBinding.expand = false
                setupSubQueriesAdapter(adapterPosition, this)
            }
        }

        private fun setupSubQueriesAdapter(position: Int, item: Query) {
            val subQueriesAdapter = QueriesAdapter(viewModel,onItemClick,context)
            itemBinding.rvSubQueries.apply {
                adapter = subQueriesAdapter
                addItemDecoration(
                    VerticalMarginItemDecoration(
                        dpToPx(10f, context)
                    )
                )
            }
            subQueriesAdapter.submitList(item.submenu)
        }
    }

}