package com.codes_roots.imakeapp.presentaion.support

import android.content.Context
import android.view.LayoutInflater
import android.view.ViewGroup
import androidx.recyclerview.widget.AsyncListDiffer
import androidx.recyclerview.widget.DiffUtil
import androidx.recyclerview.widget.RecyclerView

import com.codes_roots.imakeapp.databinding.QueryItemBinding
import com.codes_roots.imakeapp.presentaion.ClickHandler
import com.codes_roots.imakeapp.presentaion.contactus.ContactUsFragment
import com.satafood.core.entities.support.Submenu

class SubmenuAdapter(val context: Context) : RecyclerView.Adapter<SubmenuAdapter.ViewHolder>() {

    inner class ViewHolder(val binding: QueryItemBinding) : RecyclerView.ViewHolder(binding.root)

    private val diffCallback = object : DiffUtil.ItemCallback<Submenu>() {
        override fun areItemsTheSame(oldItem: Submenu, newItem: Submenu): Boolean {
            return oldItem.id == newItem.id
        }

        override fun areContentsTheSame(oldItem: Submenu, newItem: Submenu): Boolean {
            return oldItem == newItem
        }
    }

    private val differ = AsyncListDiffer(this, diffCallback)

    var questions: List<Submenu>
        get() = differ.currentList
        set(value) {
            differ.submitList(value)
        }

    override fun onCreateViewHolder(parent: ViewGroup, viewType: Int): ViewHolder {
        return ViewHolder(
            QueryItemBinding.inflate(
                LayoutInflater.from(parent.context),
                parent,
                false
            )
        )
    }

    override fun onBindViewHolder(holder: ViewHolder, position: Int) {
        holder.binding.apply {
            val questionn = questions[position]
            question.text = questionn.questions
            message.text = questionn.answer

            no.setOnClickListener {
                ClickHandler().SwitchBetweenFragments(context, ContactUsFragment())
            }

            questionView.setOnClickListener {
                expand = expand != true
                arrow = arrow != true

            }
        }
    }


    override fun getItemCount() = questions.size

}