package com.codes_roots.imakeapp.presentaion.support.answerfragment

import android.os.Bundle
import android.view.LayoutInflater
import android.view.View
import android.view.ViewGroup
import androidx.databinding.DataBindingUtil
import androidx.fragment.app.Fragment
import androidx.fragment.app.viewModels
import androidx.lifecycle.ViewModelProvider
import com.codes_roots.imakeapp.R
import com.codes_roots.imakeapp.databinding.ComplaintsFragmentBinding
import com.codes_roots.imakeapp.helper.BaseApplication
import com.codes_roots.imakeapp.helper.PreferenceHelper
import com.codes_roots.imakeapp.helper.SUCCESS_MotionToast
import com.codes_roots.imakeapp.presentaion.ClickHandler
import com.codes_roots.imakeapp.presentaion.menufragment.MenuFragment
import com.codes_roots.imakeapp.presentaion.myorderDetails.adapter.OrdersDetailsAdapter
import com.codes_roots.imakeapp.presentaion.support.SupportViewModel
import com.satafood.core.entities.support.Complaints
import com.satafood.core.entities.support.Query
import javax.inject.Inject

class ComplaintsFragment @Inject constructor() : Fragment() {

    @Inject
    lateinit var viewModelFactory: ViewModelProvider.Factory

    @Inject
    lateinit var Pref: PreferenceHelper
    val viewModel by viewModels<SupportViewModel> { viewModelFactory }
    var data: Query? = null

    lateinit var myOrdersAdapter: OrdersDetailsAdapter

    var position = 0

    override fun onCreate(savedInstanceState: Bundle?) {
        BaseApplication.appComponent.inject(this)

        super.onCreate(savedInstanceState)

    }

    private lateinit var view: ComplaintsFragmentBinding


    override fun onCreateView(
        inflater: LayoutInflater,
        container: ViewGroup?,
        savedInstanceState: Bundle?
    ): View? {

        view = DataBindingUtil.inflate(
            inflater, R.layout.complaints_fragment, container, false
        )
        arguments?.let {
            position = it.getInt("position", 0)
            data = it.getSerializable("data") as Query?
        }

        view.data = data
        view.backBtn.setOnClickListener { requireActivity().onBackPressed() }


     view.yes.setOnClickListener {
         val data = Complaints(
             user_id = null,
             title = view.msgTitle.text.toString(),
             message = view.message.text.toString()
         )
         viewModel.addComplaints(data)
         view.loading= true
     }
        viewModel.compalaintsLD.observe(requireActivity(), {
            if (it != null){
                ClickHandler().SwitchBetweenFragments(requireContext(), MenuFragment())
                view.loading = false
                SUCCESS_MotionToast(requireActivity().getString(R.string.done),requireActivity())

            }
        })
        return view.root
    }


}

