package com.codes_roots.imakeapp.presentaion.vendordetailsfragment.adapter


import android.annotation.SuppressLint
import android.content.Context
import android.util.Log
import android.view.LayoutInflater
import android.view.ViewGroup
import androidx.databinding.DataBindingUtil
import androidx.recyclerview.widget.*
import androidx.recyclerview.widget.RecyclerView.SCROLL_STATE_DRAGGING
import com.codes_roots.imakeapp.R
import com.codes_roots.imakeapp.databinding.MenuRowItemBinding
import com.codes_roots.imakeapp.presentaion.ClickHandler
import com.codes_roots.imakeapp.presentaion.mainactivity.MainActivity
import com.codes_roots.imakeapp.presentaion.vendordetailsfragment.mvi.MainIntent
import com.codes_roots.imakeapp.presentaion.vendordetailsfragment.viewmodel.RestaurantDetailsViewModel
import com.satafood.core.entities.restaurantdetails.MenuCategory
import kotlinx.coroutines.CoroutineScope
import kotlinx.coroutines.Dispatchers
import java.util.*


class MenuRowAdapter(var viewModel: RestaurantDetailsViewModel, var ResturantId:Int, var context: Context?)
    : ListAdapter<MenuCategory, RowViewHolder>(RowDiffCallback()) {
    var row_index: Int? = null
    val scope = CoroutineScope(Dispatchers.Main)

    lateinit var menuAdapter: VendorMenuAdapter

    override  fun onBindViewHolder(holder: RowViewHolder, @SuppressLint("RecyclerView") position
    : Int) {
        holder.bind(context,ResturantId,viewModel, currentList[position])
        holder.binding.recyclerView.scrollToPosition(viewModel.state.value?.position!!)
        menuAdapter = VendorMenuAdapter(viewModel,ResturantId, context)

        holder.binding.recyclerView.apply {
            var viewState = viewModel.state.value
            adapter = menuAdapter
            layoutManager = GridLayoutManager(context, 1)
            //      isNestedScrollingEnabled = false
            setHasFixedSize(true)

        }
        menuAdapter.submitList(currentList[position].menu_categories_items)


    }
    override fun onCreateViewHolder(p0: ViewGroup, p1: Int): RowViewHolder {
        val binding: MenuRowItemBinding = DataBindingUtil.inflate(
            LayoutInflater.from(p0.context),
            R.layout.menu_row_item, p0, false
        )

        try {


        }catch (e:Exception){}

        return RowViewHolder(binding)
    }


}

private class RowDiffCallback : DiffUtil.ItemCallback<MenuCategory>() {
    override fun areItemsTheSame(oldItem: MenuCategory, newItem: MenuCategory) =
        oldItem.id == newItem.id
    @SuppressLint("DiffUtilEquals")
    override fun areContentsTheSame(oldItem: MenuCategory, newItem: MenuCategory) =
        oldItem == newItem
}

class RowViewHolder(
    val binding: MenuRowItemBinding
) : RecyclerView.ViewHolder(binding.root) {
    fun bind(context: Context?,ResturantId: Int,viewModel: RestaurantDetailsViewModel, data: MenuCategory) {
        binding.listener = ClickHandler()
        binding.data = data
        binding.resturantId = ResturantId
        binding.context = context as MainActivity?
        binding.viewModel = viewModel
    }
}

