package com.codes_roots.imakeapp.presentaion.vendordetailsfragment.adapter

import android.annotation.SuppressLint
import android.content.Context
import android.graphics.Paint
import android.view.LayoutInflater
import android.view.ViewGroup
import androidx.core.view.isVisible
import androidx.databinding.DataBindingUtil
import androidx.recyclerview.widget.DiffUtil
import androidx.recyclerview.widget.ListAdapter
import androidx.recyclerview.widget.RecyclerView
import com.codes_roots.imakeapp.R
import com.codes_roots.imakeapp.databinding.RestaurantMenuItemAdapter2Binding
import com.codes_roots.imakeapp.databinding.RestaurantMenuItemAdapterBinding
import com.codes_roots.imakeapp.presentaion.ClickHandler
import com.codes_roots.imakeapp.presentaion.mainactivity.MainActivity
import com.codes_roots.imakeapp.presentaion.vendordetailsfragment.viewmodel.RestaurantDetailsViewModel
import com.satafood.core.entities.restaurantdetails.MenuCategoriesItem
import kotlinx.coroutines.CoroutineScope
import kotlinx.coroutines.Dispatchers

class VendorMenuAdapter(
    var viewModel: RestaurantDetailsViewModel,
    var ResturantId: Int,
    var context: Context?
) : ListAdapter<MenuCategoriesItem, MenuViewHolder>(MenuDiffCallback()) {
    var row_index: Int? = null
    val scope = CoroutineScope(Dispatchers.Main)


    override fun onBindViewHolder(holder: MenuViewHolder, position: Int) {
        holder.bind(context, ResturantId, viewModel, currentList[position])
        if (currentList[position].discount!=null){
            if (currentList[position].price!=0.0){
            holder.binding.priceBefore.text = calculatePriceAfterDiscount(position)
            holder.binding.priceAfter.apply {
                paintFlags = paintFlags or Paint.STRIKE_THRU_TEXT_FLAG
            }
            }else{
                holder.binding.priceAfter.apply {
                    paintFlags = 0
                }
                holder.binding.priceBefore.apply {
                   isVisible = false
                }
            }
        }else{
            holder.binding.priceAfter.apply {
                paintFlags = 0
            }
        }
    }
  private  fun calculatePriceAfterDiscount(position: Int) :String {
      val priceBeforeDiscount = currentList[position].price!!.toInt()
      val discountPercentage = currentList[position].discount!!.toInt()
      val discountValue = priceBeforeDiscount * discountPercentage / 100
      val priceAfterDiscount = priceBeforeDiscount- discountValue

      return  priceAfterDiscount.toString()+((context as MainActivity).Pref.currency)
  }
    override fun onCreateViewHolder(p0: ViewGroup, p1: Int): MenuViewHolder {
        val binding: RestaurantMenuItemAdapter2Binding = DataBindingUtil.inflate(
            LayoutInflater.from(p0.context),
            R.layout.restaurant_menu_item_adapter2, p0, false
        )

        try {
            if (currentList[p1].discount != null){

            }else{

            }
            //   binding.offerView.isVisible = currentList[p1].offers!!.isNotEmpty()

        } catch (e: Exception) {
        }

        return MenuViewHolder(binding)
    }


}

private class MenuDiffCallback : DiffUtil.ItemCallback<MenuCategoriesItem>() {

    override fun areItemsTheSame(oldItem: MenuCategoriesItem, newItem: MenuCategoriesItem) =
        oldItem.id == newItem.id

    @SuppressLint("DiffUtilEquals")
    override fun areContentsTheSame(oldItem: MenuCategoriesItem, newItem: MenuCategoriesItem) =
        oldItem == newItem
}

class MenuViewHolder(
    val binding: RestaurantMenuItemAdapter2Binding
) : RecyclerView.ViewHolder(binding.root) {


    fun bind(
        context: Context?,
        ResturantId: Int,
        viewModel: RestaurantDetailsViewModel,
        data: MenuCategoriesItem
    ) {

        binding.listener = ClickHandler()
        binding.data = data
        binding.resturantId = ResturantId
        binding.context = context as MainActivity?
        binding.viewModel = viewModel

    }


}
