package com.codes_roots.imakeapp.presentaion.vendordetailsfragment.viewmodel

import android.util.Log
import androidx.lifecycle.MutableLiveData
import androidx.lifecycle.viewModelScope
import com.meem.physio.util.SingleLiveEvent
import com.codes_roots.imakeapp.presentaion.mainactivity.BaseViewModel
import com.codes_roots.imakeapp.presentaion.vendordetailsfragment.mvi.MainIntent
import com.codes_roots.imakeapp.presentaion.vendordetailsfragment.mvi.MainViewState
import com.codes_roots.imakeapp.presentaion.vendordetailsfragment.mvi.mapIntentToViewState
import com.codes_roots.imakeapp.repository.retaurantdetails.DataRepo
import com.codes_roots.imakeapp.repository.retaurantdetails.RemoteDataSource
import com.satafood.core.entities.favourite.FavouriteModelItem
import com.satafood.core.entities.restaurantdetails.MenuOption
import com.satafood.core.mapper.restaurantdetails.RestuarantsDetailsUseCase
import kotlinx.coroutines.*
import kotlinx.coroutines.channels.Channel
import kotlinx.coroutines.flow.*
import java.io.IOException
import javax.inject.Inject

class RestaurantDetailsViewModel @Inject constructor(
    private val DateRepoCompnay: DataRepo,
    private val Datasources: RemoteDataSource,
) : BaseViewModel<MainViewState>() {
    val intents: Channel<MainIntent> = Channel(Channel.UNLIMITED)
    protected val uiState: MutableStateFlow<MainViewState?> = MutableStateFlow(MainViewState())

    val state: MutableStateFlow<MainViewState?> get() = uiState

    var OptionsArrayVariable: MutableLiveData<Double>? = MutableLiveData()

    var quantity: MutableLiveData<Int>? = MutableLiveData()


    private var job: Job? = null

    val OptionsArray = ArrayList<MenuOption>()
    var Required = 0

    var data: RestuarantsDetailsUseCase? = null
    var checkFavorite = MutableLiveData<ArrayList<FavouriteModelItem>>()
    var errorMessage = SingleLiveEvent<String>()
    val loading = MutableLiveData<Boolean>()
    val coroutineExceptionHandler = CoroutineExceptionHandler { _, throwable ->
        throwable.printStackTrace()
    }
    private val viewStateMapper: suspend (MainIntent) -> MainViewState =
        { mapIntentToViewState(it, DateRepoCompnay) }

    init {
        checkFavorite = MutableLiveData()
        getIntent()
// لازم ابعت viewstate كامل واتحكم بكل option حسب المطلوب وارساله مرة اخري واستقباله هنا او في ال view

        uiState.value = MainViewState().copy(progress = true)
        // launchNextViewStateJob(intents.value)
    }

    fun getIntent() {
        job = viewModelScope.launch() {
            intents.receiveAsFlow().collect {
                uiState.value = (viewStateMapper(it))
            }
        }
    }

    /// checkFavorite
    fun checkFavorite(id: Int) {
        job = CoroutineScope(Dispatchers.IO).launch {
            try {
                val response = Datasources.checkFavorite(id)
                withContext(Dispatchers.Main + coroutineExceptionHandler) {
                    if (response.isSuccessful) {
                        checkFavorite.postValue(response.body())

                    } else {

                        onError("Error : ${response.message()} ")
                    }
                }
            } catch (e: IOException) {
                Log.i("CatchingCrash", "getUserAddresses: ${e.message}")
            }

        }
    }

    private fun onError(message: String) {
        errorMessage.value = message
        loading.value = false
    }
}