package com.codes_roots.imakeapp.presentaion.wallet_details

import android.annotation.SuppressLint
import android.content.Context
import android.view.LayoutInflater
import android.view.ViewGroup
import androidx.recyclerview.widget.DiffUtil
import androidx.recyclerview.widget.ListAdapter
import androidx.recyclerview.widget.RecyclerView
import com.codes_roots.imakeapp.R
import com.codes_roots.imakeapp.databinding.RowItemWalletTransactionsBinding
import com.codes_roots.imakeapp.presentaion.mainactivity.MainActivity
import com.satafood.core.entities.walletdetails.WalletDetailsModelItem

class WalletTransactionsAdapter(
    val context: Context,
    private val onItemClick: (WalletDetailsModelItem) -> Unit
) :
    ListAdapter<WalletDetailsModelItem, WalletTransactionsAdapter.WalletViewHolder>(Companion) {

    companion object : DiffUtil.ItemCallback<WalletDetailsModelItem>() {
        override fun areItemsTheSame(
            oldItem: WalletDetailsModelItem,
            newItem: WalletDetailsModelItem
        ): Boolean {
            return oldItem.id == newItem.id
        }

        override fun areContentsTheSame(
            oldItem: WalletDetailsModelItem,
            newItem: WalletDetailsModelItem
        ): Boolean {
            return oldItem.hashCode() == newItem.hashCode()
        }
    }

    override fun onCreateViewHolder(parent: ViewGroup, viewType: Int): WalletViewHolder {
        val binding =
            RowItemWalletTransactionsBinding.inflate(
                LayoutInflater.from(parent.context),
                parent,
                false
            )
        return WalletViewHolder(binding) {
            onItemClick(it)
        }
    }

    @SuppressLint("SetTextI18n")
    override fun onBindViewHolder(holder: WalletViewHolder, position: Int) {
        val item = currentList[position]
        context as MainActivity
        item?.let {
            holder.bind(it)
        }
        holder.itemBinding.messageView.text = context.getString(R.string.discount_has_been) +
                item.value.toString() + context.Pref.currency


    }

    inner class WalletViewHolder(
        val itemBinding: RowItemWalletTransactionsBinding,
        private val onItemClick: (WalletDetailsModelItem) -> Unit
    ) : RecyclerView.ViewHolder(itemBinding.root) {


        init {
            itemBinding.walletLayout.setOnClickListener {
                onItemClick(currentList[adapterPosition])
            }
        }

        fun bind(item: WalletDetailsModelItem) {
            item.apply {
                itemBinding.wallet = this
            }
        }
    }

}