package com.codes_roots.imakeapp.presentaion.wallet_details.mvi

import androidx.lifecycle.MutableLiveData
import androidx.lifecycle.viewModelScope
import com.codes_roots.imakeapp.presentaion.mainactivity.BaseViewModel
import com.codes_roots.imakeapp.repository.wallet_details.WalletTransactionsDataRepo
import com.sata.satafood.presentaion.wallet_details.mvi.MainIntent


import com.codes_roots.imakeapp.repository.wallet_details.WalletDetailsRemoteDataSource

import kotlinx.coroutines.*
import kotlinx.coroutines.channels.Channel
import kotlinx.coroutines.flow.MutableStateFlow
import kotlinx.coroutines.flow.collect
import kotlinx.coroutines.flow.receiveAsFlow
import javax.inject.Inject


class WalletDetailsViewModel @Inject constructor(
    private val DateRepoCompnay: WalletTransactionsDataRepo,
    private val Datasources: WalletDetailsRemoteDataSource,
) : BaseViewModel<MainViewState>() {

    val intents: Channel<MainIntent> = Channel<MainIntent>(Channel.UNLIMITED)

    protected val uiState: MutableStateFlow<MainViewState?> = MutableStateFlow(MainViewState())

    val state: MutableStateFlow<MainViewState?> get() = uiState

    private var job: Job? = null




    val errorMessage = MutableLiveData<String>()
    val loading = MutableLiveData<Boolean>()

    private val viewStateMapper: suspend (MainIntent)

    -> MainViewState = { mapIntentToViewState(it, DateRepoCompnay) }

    val coroutineExceptionHandler = CoroutineExceptionHandler { _, throwable ->
        throwable.printStackTrace()
    }

    init {

        getIntent()

        // لازم ابعت viewstate كامل واتحكم بكل option حسب المطلوب وارساله مرة اخري واستقباله هنا او في ال view

        uiState.value = MainViewState().copy(progress = true)

        // launchNextViewStateJob(intents.value)
    }

    fun getIntent() {

        job = viewModelScope.launch() {

            intents.receiveAsFlow().collect {

                uiState.value = (viewStateMapper(it))

            }
        }
    }


    override fun onCleared() {
        super.onCleared()
        job!!.cancel()
    }

    private fun onError(message: String) {
        errorMessage.value = message
        loading.value = false
    }

}




