package com.codes_roots.imakeapp.repository.RestaurantsList

import com.satafood.core.entities.google.GoogleModel
import com.satafood.core.entities.google.SliderModel
import com.satafood.core.entities.homepage.Cuisines
import com.satafood.core.entities.homepage.sliders.SliderHomePageModelItem
import com.satafood.core.entities.restaurantslist.BranchesModelListItem
import com.satafood.core.entities.seemore_section.VendorOffersDataItem

interface RestaurantListDataSource {
    suspend fun getCuisinesListResponse(catid:Int):  ArrayList<Cuisines>
    suspend fun getBranchesListResponse(AreasId:Int,catid: Int): ArrayList<BranchesModelListItem>
    suspend fun getBranchesListByGoogleID(googleModel: GoogleModel,page:Int?): ArrayList<BranchesModelListItem>
    suspend fun getBranchesByAreasByCat(googleModel: GoogleModel,page:Int?): ArrayList<BranchesModelListItem>
    suspend fun getVendorOffersData(googleModel: GoogleModel?): ArrayList<VendorOffersDataItem>
    suspend fun getNearestBranchesData(googleModel: GoogleModel?): ArrayList<BranchesModelListItem>
    suspend fun getNewOfferData(googleModel: GoogleModel?): ArrayList<BranchesModelListItem>
    suspend fun getFreeDliveryBranches(googleModel: GoogleModel?): ArrayList<BranchesModelListItem>
    suspend fun getMostOrderedBranches(googleModel: GoogleModel?): ArrayList<BranchesModelListItem>
    suspend fun AddFavorite(restaurant_id: Int, UserId: Int): Boolean

    suspend fun getCategoriesSliders(sliderModel: SliderModel?): ArrayList<SliderHomePageModelItem>

}