package com.codes_roots.imakeapp.repository.authenticate


import com.codes_roots.imakeapp.datalayer.APIServices
import com.satafood.core.entities.login.ForgetPasswordModel
import com.satafood.core.entities.login.LoginModel
import com.satafood.core.entities.login.User
import retrofit2.Response
import javax.inject.Inject

/**
Created by Prokash Sarkar on Tue, January 19, 2021
 **/

class RemoteDataSource @Inject constructor(private val ApiService: APIServices)
    : DataSource {

    override suspend fun getLoginResponse(loginModel: User): Response<LoginModel> {
       kotlin.runCatching {  return ApiService.login(loginModel) }.getOrElse { throw  it }
    }

    override suspend fun forgetPasswordResponse(loginModel: ForgetPasswordModel): Response<ForgetPasswordModel> {
        kotlin.runCatching {   return ApiService.forgetPassword(loginModel)}.getOrElse { throw  it }
    }

    override suspend fun getRegisterResponse(registerModel: User): Response<LoginModel> {
        kotlin.runCatching {  return ApiService.register(registerModel) }.getOrElse { throw  it }
    }

    override suspend fun checkAgainVerifyEmail(registerModel: User): Response<LoginModel> {
        kotlin.runCatching {   return ApiService.checkAgainVerifyEmail(registerModel) }.getOrElse { throw  it }
    }
    override suspend fun checkVerifyEmail(registerModel: LoginModel): Response<LoginModel> {
        kotlin.runCatching {  return ApiService.checkVerifyEmail(registerModel) }.getOrElse { throw  it }
    }

    override suspend fun facebookResponse(facebookModel: User): Response<LoginModel> {
        kotlin.runCatching { return  ApiService.faceBookLogin(facebookModel) }.getOrElse { throw  it }
    }

    override suspend fun activeUserAccount(userId: Int, loginModel: LoginModel): Response<LoginModel> {
        kotlin.runCatching { return   ApiService.activeUserAccount( loginModel) }.getOrElse { throw  it }
    }


}