package com.codes_roots.imakeapp.repository.cart

import com.satafood.core.entities.cart.CartConfigurations
import com.satafood.core.entities.google.GoogleModel
import com.satafood.core.entities.login.LoginModel
import com.satafood.core.entities.ordermodel.OrderModel
import com.satafood.core.entities.paymentways.PaymentWaysItem
import com.satafood.core.entities.paymentways.VoucherModel
import com.satafood.core.entities.paymob.MakePaymentOrderIntegration
import com.satafood.core.entities.paymob.PayMobToken
import com.satafood.core.entities.paymob.Payment
import com.satafood.core.entities.paymob.Token

import com.satafood.core.entities.restaurantdetails.StoreDetailsModel
import com.satafood.core.entities.wallet.WalletModel
import retrofit2.Response

interface CartDataSource {
    suspend fun getCartConfig(googleModel: GoogleModel): Response<CartConfigurations>
    suspend fun checkWallet(googleModel: GoogleModel): WalletModel
    suspend fun GetCartItem(restaurant_id: Int, AreaId: Int, CartItems: Array<Int>): StoreDetailsModel
    suspend fun getPaymentWays(): Response<ArrayList<PaymentWaysItem>>
    suspend fun getPaymobToken(auth : PayMobToken): Response<Token>
    suspend fun AddOrder(orderInfo: OrderModel): Response<OrderModel>
    suspend fun checkVoucherRequest(voucherModel: VoucherModel): Response<VoucherModel>
    suspend fun sendNotificationToDevice(loginModel: LoginModel): Response<LoginModel>


    suspend fun GetPaymentkey(auth: Payment): Response<Payment>
    suspend fun MakePaymentOrderIntegration(loginModel: HashMap<String, Any>): Response<MakePaymentOrderIntegration?>
}