package com.codes_roots.imakeapp.repository.home

import android.content.Context
import com.codes_roots.imakeapp.datalayer.APIServices
import com.codes_roots.imakeapp.datalayer.ExceptionsMapper
import com.codes_roots.imakeapp.helper.BaseDataSource
import javax.inject.Inject

class HomeDataSourceImpl @Inject constructor(
    private val ApiService: APIServices, context: Context,
    exceptionsMapper: ExceptionsMapper
) : BaseDataSource(context, exceptionsMapper), IHomeDataSource {

    override suspend fun getItemDetails(itemId: Int) =
        getResult {
            ApiService.getItemById(itemId)
        }
}