package com.codes_roots.imakeapp.repository.homepage

import com.satafood.core.entities.add_driver_request.DriverRequestModel
import com.satafood.core.entities.favourite.FavouriteModelItem
import com.satafood.core.entities.gallery.GalleryModel
import com.satafood.core.entities.google.GoogleModel
import com.satafood.core.entities.homepage.CitiesModelItem
import com.satafood.core.entities.homepage.SectionsModelItem
import com.satafood.core.entities.homepage.sliders.SliderHomePageModelItem
import com.satafood.core.entities.login.LoginModel
import com.satafood.core.entities.mainpage.HomePageModel
import com.satafood.core.entities.myorders.MyOrderModelItem
import com.satafood.core.entities.myorders.OrderStatus
import com.satafood.core.entities.notification.NotificationModelItem
import com.satafood.core.entities.ordermodel.OrderModel
import com.satafood.core.entities.seemore_section.CategoryBannerItem
import com.satafood.core.entities.social_media.SocialMediaModelItem
import com.satafood.core.entities.static_pages.StaticPagesItem
import retrofit2.Response


/**
Created by Prokash Sarkar on Tue, January 19, 2021
 **/


interface DataSource {

    suspend fun getCategoriesData(): SectionsModelItem

    suspend fun getHomePageData(googleModel: GoogleModel?,user_id: Int?): HomePageModel?


    suspend fun getMainResponse(): ArrayList<SectionsModelItem>
    suspend fun getSocialIcons(): ArrayList<SocialMediaModelItem>

    suspend fun getUserLastOrderForRating(): MyOrderModelItem
    suspend fun addDriverRequest(driverRequestModel: DriverRequestModel?): Response<DriverRequestModel>

    suspend fun getBranchesGallery(url:String,query: GalleryModel): GalleryModel

    suspend fun getMainSlidersData(googleModel: GoogleModel?): ArrayList<SliderHomePageModelItem?>

    suspend fun DeleteFavorite(FavId:Int):  Boolean

    suspend fun changeOrderRateStatus(orderId: Int,rated: MyOrderModelItem):  MyOrderModelItem

    suspend fun GetCities(): ArrayList<CitiesModelItem>?

    suspend fun GetTownData(city_id : Int): ArrayList<CitiesModelItem>?

    suspend fun GetAreaData(area_id : Int):  ArrayList<CitiesModelItem>

    suspend fun changeOrderStatus(order_id:Int,data: OrderStatus) : OrderStatus

    suspend fun getUserOrders() : ArrayList<MyOrderModelItem>
    suspend fun getFilteredUserOrders(order_status_id:OrderModel) : ArrayList<MyOrderModelItem>
    suspend fun registerToken(loginModel: LoginModel): Response<Int>


    suspend fun getFavorite(user_id: Int): ArrayList<FavouriteModelItem>

    suspend fun getNotifications(user_id:Int,googleId:String,): ArrayList<NotificationModelItem>

    suspend fun getStaticPages(): ArrayList<StaticPagesItem>
    suspend fun getCategoriesBanner(): ArrayList<CategoryBannerItem>

}