package com.codes_roots.imakeapp.repository.main


import android.content.Context
import com.codes_roots.imakeapp.datalayer.APIServices
import com.codes_roots.imakeapp.datalayer.ExceptionsMapper
import com.codes_roots.imakeapp.helper.BaseDataSource

import com.satafood.core.entities.main.Token

import javax.inject.Inject


class MainDataSource @Inject constructor(
    private val ApiService: APIServices, context: Context,
    exceptionsMapper: ExceptionsMapper
) : BaseDataSource(context, exceptionsMapper), IMainDataSource {


    override suspend fun updateUserToken(userId: Int, token: Token) =
        getResult {
            ApiService.updateUserToken(userId, token)
        }


}