package com.codes_roots.imakeapp.repository.retaurantdetails

import com.satafood.core.entities.addresses.UserAddressesItem
import com.satafood.core.entities.favourite.FavouriteModelItem
import com.satafood.core.entities.login.LoginModel
import com.satafood.core.entities.login.User
import com.satafood.core.entities.myorders.MyOrderModelItem
import com.satafood.core.entities.profile.ProfileModel
import com.satafood.core.entities.rate.RateModel
import com.satafood.core.entities.restaurantdetails.MenuCategoriesItem
import com.satafood.core.entities.restaurantdetails.StoreDetailsModel
import com.satafood.core.entities.reviews.ReviewsModel
import okhttp3.MultipartBody
import retrofit2.Response

interface DataSource {
    suspend fun getRestaurantDetails(restaurant_id: Int, area_id: Int): StoreDetailsModel
    suspend fun AddFavorite(restaurant_id: Int, UserId: Int): Boolean
    suspend fun getRestaurantReviews(restaurant_id: Int): ReviewsModel

    suspend fun preOrder(orderInfo: MyOrderModelItem): Response<Double>

    suspend fun getUserAddresses(): Response<ArrayList<UserAddressesItem>>
    suspend fun checkRestaurantAddress(branchId:Int): Response<ArrayList<UserAddressesItem>>
    suspend fun addUsersAddress(addressInfo: UserAddressesItem): Response<UserAddressesItem>
    suspend fun editUsersAddress(addressId: Int,addressInfo: UserAddressesItem): Response<UserAddressesItem>
    suspend fun deleteUsersAddress(addressId: Int): Response<Int>

    suspend fun getUsersData(addressId: Int): Response<ProfileModel>

    suspend fun editUserData(file: MultipartBody.Part?, user: User):Response<User>
    suspend fun checkFavorite(restaurant_id: Int): Response<ArrayList<FavouriteModelItem>>

    suspend fun rate(rate: RateModel): Response<RateModel>
    suspend fun GetItemById(item_id: Int): ArrayList<MenuCategoriesItem>?

    suspend fun sendNotificationToDevice(loginModel: LoginModel): Response<LoginModel>


    suspend fun editUsersDataWithOutPhoto(user: User): Response<User>
}