package com.codes_roots.imakeapp.repository.searchRepo

import com.codes_roots.imakeapp.di.IoDispatcher
import com.satafood.core.entities.google.GoogleModel
import com.satafood.core.entities.search_model.SearchModel
import kotlinx.coroutines.CoroutineDispatcher
import kotlinx.coroutines.delay
import kotlinx.coroutines.flow.*
import java.io.IOException
import javax.inject.Inject

class SearchDataRepo @Inject constructor(
    private val Datasources: SearchRemoteDataSource,
    @IoDispatcher private val ioDispatcher: CoroutineDispatcher
)
{

    fun getRestaurantDetails(googleModel: GoogleModel): Flow<Result<SearchModel>> =


        flow {
            emit(Datasources.getSearchData(googleModel))
             }
            .map { Result.success(it) }
            .retry(4){ t -> (t is IOException).also { if (it) {
                delay(1000)
            }}}
            .catch { throwable -> emit(Result.failure(throwable)) }
            .flowOn(ioDispatcher)






}