package com.codes_roots.imakeapp.repository.support


import android.content.Context
import com.codes_roots.imakeapp.datalayer.APIServices
import com.codes_roots.imakeapp.datalayer.ExceptionsMapper
import com.codes_roots.imakeapp.helper.BaseDataSource
import com.satafood.core.entities.support.Complaints
import com.satafood.core.entities.support.QuestionCategoryItem
import com.satafood.core.entities.support.questionsItem
import retrofit2.Response
import javax.inject.Inject


class SupportDataSource @Inject constructor(
    private val ApiService: APIServices, context: Context,
    exceptionsMapper: ExceptionsMapper
) : BaseDataSource(context, exceptionsMapper), ISupportDataSource {


    override suspend fun getQueries() =
        getResult {
            ApiService.getQueries()
        }



    override suspend fun addComplaints(complaints: Complaints?): Response<Complaints> {
        return ApiService.addComplaints(complaints)
    }

    override suspend fun getCommonQuestions(typeId : Int): Response<MutableList<questionsItem>> {
   kotlin.runCatching {     return ApiService.getCommonQuestionsById(typeId) }.getOrElse { throw it }

    }

    override suspend fun getQuestionsCategories(): Response<List<QuestionCategoryItem>> {
        return ApiService.getQuestionsCategories()
    }

    override suspend fun getAllCommonQuestions(): Response<MutableList<questionsItem>> {
        return ApiService.getAllCommonQuestions()
    }



}