package com.codes_roots.imakeapp.repository.wallet


import android.content.Context
import com.codes_roots.imakeapp.datalayer.APIServices
import com.codes_roots.imakeapp.datalayer.ExceptionsMapper
import com.codes_roots.imakeapp.helper.BaseDataSource
import com.satafood.core.base.DataState
import com.satafood.core.entities.wallet.WalletCredit
import javax.inject.Inject


class WalletDataSource @Inject constructor(
    private val ApiService: APIServices, context: Context,
    exceptionsMapper: ExceptionsMapper
) : BaseDataSource(context, exceptionsMapper), IWalletDataSource {

    override suspend fun getWalletList() =
        getResult {
            ApiService.getWalletList()
        }

    override suspend fun getUserCredit(): DataState<WalletCredit> = getResult {
        ApiService.getUserCredit()
    }



}