package com.codes_roots.imakeapp.repository.wallet

import com.codes_roots.imakeapp.helper.executeRemoteAPI
import kotlinx.coroutines.CoroutineDispatcher
import javax.inject.Inject

class WalletRepository @Inject constructor(
    private val walletDataSource: WalletDataSource,
    ioDispatcher: CoroutineDispatcher,
)  {

    suspend  fun getWalletList() =
        executeRemoteAPI {
            walletDataSource.getWalletList()
        }

    suspend  fun getUserCredit() =
        executeRemoteAPI {
            walletDataSource.getUserCredit()
        }
//        flow {
//            emit(walletDataSource.getWalletList(authorization))
//        }
//            .map { Result.success(it) }
//            .retry(4){ t -> (t is IOException).also { if (it) {
//                delay(1000)
//            }}}
//            .catch { throwable -> emit(Result.failure(throwable)) }
//            .flowOn(ioDispatcher)
}