package com.codes_roots.imakeapp.di.component

import android.content.Context

import com.codes_roots.dagger.di.module.ActivityBuildersModule

import com.codes_roots.dagger.di.module.TestAppModule
import com.codes_roots.imakeapp.di.APIModule
import com.codes_roots.imakeapp.di.AppComponent
import com.codes_roots.imakeapp.di.DispatcherModule
import com.codes_roots.imakeapp.helper.ViewModelBuilderModule
import com.codes_roots.imakeapp.presentaion.mainactivity.di.MainModule
import dagger.BindsInstance
import dagger.Component
import dagger.android.AndroidInjectionModule
import javax.inject.Singleton

/**
Created by Prokash Sarkar on Tue, January 19, 2021
 **/

@Singleton
@Component(
    modules = [
        DispatcherModule::class,
        AndroidInjectionModule::class,
        APIModule::class,
        TestAppModule::class,
        MainModule::class,
        ActivityBuildersModule::class,
        ViewModelBuilderModule::class

    ]
)

interface TestAppComponent : AppComponent {
    @Component.Factory
    interface Factory {
        fun create(@BindsInstance applicationContext: Context): TestAppComponent
    }

    fun inject(app: TestBaseApplication)

}


