package com.codes_roots.dagger.di.module


import android.content.Context
import com.codes_roots.imakeapp.repository.homepage.DataSource
import com.codes_roots.imakeapp.datalayer.APIServices
import com.codes_roots.imakeapp.helper.PreferenceHelper
import dagger.Module
import dagger.Provides
import javax.inject.Singleton
import org.mockito.Mockito




/**
Created by Prokash Sarkar on Mon, February 08, 2021
Copyright (c) 2021 Augmedix. All rights reserved.
 **/

@Module
class TestAppModule {

    @Singleton
    @Provides
    fun provideTasksRemoteDataSource(
        apiService: APIServices
    ): DataSource {
        return Mockito.mock(DataSource::class.java)
    }
    @Singleton
    @Provides
    fun providePreferenceHelper(
        context: Context
    ): PreferenceHelper {
        return PreferenceHelper(context)
    }


}