package com.codes_roots.imakeapp.repository


import androidx.arch.core.executor.testing.InstantTaskExecutorRule
import androidx.lifecycle.Observer
import com.codes_roots.imakeapp.di.component.TestAppComponent
import com.codes_roots.imakeapp.di.component.TestBaseApplication
import com.codes_roots.imakeapp.presentaion.homefragment.viewmodel.MainViewState
import com.codes_roots.imakeapp.presentaion.homefragment.viewmodel.MainViewModel
import com.codes_roots.imakeapp.repository.homepage.DataRepo
import com.codes_roots.imakeapp.repository.homepage.DataSource
import com.nhaarman.mockitokotlin2.doAnswer
import com.satafood.core.entities.homepage.SectionsModelItem

import kotlinx.coroutines.*

import kotlinx.coroutines.flow.*
import kotlinx.coroutines.test.TestCoroutineDispatcher
import org.junit.After

import org.junit.Assert.*
import org.junit.Before
import org.junit.Rule

import org.junit.Test
import org.junit.rules.TestRule
import org.mockito.Mock
import org.mockito.Mockito.*
import org.mockito.MockitoAnnotations
import org.mockito.kotlin.stub
import javax.inject.Inject
import kotlin.time.ExperimentalTime

@ExperimentalCoroutinesApi
class DataRepoTest {


    @get:Rule
    val testInstantTaskExecutorRule: TestRule = InstantTaskExecutorRule()

    @get: Rule
    val mainCoroutineScopeRule: TestCoroutineRule = TestCoroutineRule()


    @Inject
    lateinit var remoteDataSource: DataSource

    private val testDispatcher = TestCoroutineDispatcher()


    private lateinit var viewModel: MainViewModel
    private lateinit var DateRepoo: DataRepo


    @Mock
    lateinit var StateProvider: Observer<MainViewState>


    @Before
    fun setup() {
        MockitoAnnotations.initMocks(this)
        val component: TestAppComponent = DaggerTestAppComponent.factory()
            .create(TestBaseApplication())
        component.inject(this)
        DateRepoo = DataRepo(remoteDataSource, testDispatcher)
        viewModel = MainViewModel(DateRepoo).apply {

        }

    }

    @After
    fun tearDown() {
    }

    @ExperimentalTime
    @InternalCoroutinesApi
    @ExperimentalCoroutinesApi
    @Test
    fun getMainData() = runBlocking {
        val getFreeDeliveryBranche = ArrayList<SectionsModelItem>()

        var response = getFreeDeliveryBranche
        //  var expexted  = Flow<homepageUseCase>
        remoteDataSource.stub {
            onBlocking { remoteDataSource.getMainResponse() } doAnswer {
                response
            }
        }
        val flow = DateRepoo.TestCoroutine
        flow.collect {

            assertTrue(it.isSuccess)

        }
    }

//    @ExperimentalTime
//    @ExperimentalCoroutinesApi
//    @Test
//    fun TestData() = testDispatcher.runBlockingTest {
//        val category = mutableListOf<Category>()
//        category.add(Category(name = "hossam"))
//        val newoffer = mutableListOf<Lastoffer>()
//        newoffer.add(Lastoffer(description = "hossam"))
//
//        val slider = mutableListOf<SliderX>()
//        slider.add(SliderX(photo = "hossam"))
//        val response = MainViewDataModel(category, newoffer, slider)
//
//        remoteDataSource.stub {
//            onBlocking { remoteDataSource.getMainResponse() } doAnswer {
//                response
//
//            }
//        }
//        var expected = homepageUseCase(response)
//
////       //`when`(DataRepo(remoteDataSource).TestCoroutine)
//        viewModel.GetMainData()
//        var states = viewModel.state.first()
//        assertTrue(states is MainViewState.ShowData)
//        verify(StateProvider).onChanged(states)
//
//
//
//    }
//
//    @ExperimentalTime
//    @ExperimentalCoroutinesApi
//    @Test
//    fun testDelay() = testDispatcher.runBlockingTest {
//        val category = mutableListOf<Category>()
//        category.add(Category(name = "hossam"))
//        val newoffer = mutableListOf<Lastoffer>()
//        newoffer.add(Lastoffer(description = "hossam"))
//
//        val slider = mutableListOf<SliderX>()
//        slider.add(SliderX(photo = "hossam"))
//        var throwError = true
//        var response = MainViewDataModel(category, newoffer, slider)
//        //  var expexted  = Flow<homepageUseCase>
//
//        remoteDataSource.stub {
//            onBlocking { remoteDataSource.getMainResponse() }  doAnswer {
//
//
//                if (throwError) throw IOException() else response
//
//            }
//        }
//        val flow = DateRepoo.TestCoroutine
//
//// تستني لما كل الفنكشن تتنفذ blocktest
//
//        flow.test {
//            advanceTimeBy(1000)
//            throwError = false
//            advanceTimeBy(1000)
//            assertTrue(awaitItem().isSuccess)
//            awaitComplete()
//        }
//    }
//
//    @Test
//    fun testFealuireFlow() = testDispatcher.runBlockingTest {
//        val category = mutableListOf<Category>()
//        category.add(Category(name = "hossam"))
//        val newoffer = mutableListOf<Lastoffer>()
//        newoffer.add(Lastoffer(description = "hossam"))
//
//        val slider = mutableListOf<SliderX>()
//        slider.add(SliderX(photo = "hossam"))
//        var throwError = true
//        var response = MainViewDataModel(category, newoffer, slider)
//        //  var expexted  = Flow<homepageUseCase>
//
//        remoteDataSource.stub {
//            onBlocking { remoteDataSource.getMainResponse() }.doAnswer { throw  Exception() }
//
//        }
//        // استخدمت Result في ال follow عشان بترجع الobject , error في نفس الclass وده مش بيحصل في ال sealed
//// انا كنت ناسي اعمل emit في الcatch عشان كدا كان بيرجع هنا نفس الrespone في الحالتين
//// تستني لما كل الفنكشن تتنفذ blocktest
//     DateRepoo.TestCoroutine.collect {
//
//            assertTrue(it.isFailure)
//
//        }
//
//
//    }
//
//
//
//    @ExperimentalTime
//    @ExperimentalCoroutinesApi
//    @Test
//    fun TestDataFailuier() = testDispatcher.runBlockingTest {
//        val category = mutableListOf<Category>()
//        category.add(Category(name = "hossam"))
//        val newoffer = mutableListOf<Lastoffer>()
//        newoffer.add(Lastoffer(description = "hossam"))
//
//        val slider = mutableListOf<SliderX>()
//        slider.add(SliderX(photo = "hossam"))
//        val response = MainViewDataModel(category, newoffer, slider)
//
//        remoteDataSource.stub {
//            onBlocking { remoteDataSource.getMainResponse() }.doAnswer { throw  IOException() }
//
//        }
//        var expected = homepageUseCase(response)
//
//        viewModel.GetMainData()
//        var states = viewModel.state.collect()
//        assertTrue(states is MainViewState.ShowError)
//    }
}