package com.satafood.core.entities.myorders

import android.os.Build
import androidx.annotation.RequiresApi
import com.satafood.core.entities.branch_orders.BillingAddress
import java.io.Serializable
import java.lang.Long
import java.text.SimpleDateFormat
import java.util.*
import kotlin.Any
import kotlin.Double
import kotlin.Int
import kotlin.String


data class MyOrderModelItem(
    var billing_address_id: Int?=null,
    var branch_id: Int?=null,
    var rated: Int?=null,
    var coupon_id: Int?=null,
    var created: String?=null,
    var discount: Double?=null,
    var id: Int?=null,
    var restaurantsId:Int?=null,
    var vendor_id:Int?=null,
    var modified: String?=null,
    var accept_order_time: String?=null,
    var ResName: String?=null,
    var logo: String?=null,
    var cover: String?=null,
    var notes: String?=null,
    var offer_id: Int?=null,
    var order_details: List<OrderDetail>?=null,
    var paymenttype: Paymenttype?=null,
    var order_status_id: Int?=null,
    var status: String?=null,
    var paymenttype_id: Int?=null,
    var taxes: Double?=null,
    var total: Double?=null,
    var sub_total: Double?=null,
    var google_id: Double?=null,
    var user_id: Int?=null,
    var billing_address: BillingAddress?=null,
    var latitude: Double?=null,
    var longitude: Double?=null,
    var branches: Branches?=null,
    var order_status: OrderStatus?=null,
    var users: Users?=null,
    var canceled_reason: String?=null,
    var code: String?=null,
    var DateDiff: String?=null,
    var commission: Double?=null,
    var delivery_comment: String?=null,
    var delivery_id: Int?=null,
    var delivery_serivce: Int?=null,
    var delivery_time: Int?=null,
    var offer_discount: Double?=null,
    var voucher_discount: Double?=null,
    var takeway: Int?=null,
    var test_orders: Int?=null,
    var voucher_id: String?=null,
    var wallet_discount: Double?=null,
    var wallets_id: Int?=null,
    var BranchUserId: Int?=null,
    var OrderId: Int?=null,
): Serializable
{

    @RequiresApi(Build.VERSION_CODES.O)
    fun getCreationDateFormatted(): String? {
        val date =  SimpleDateFormat("yyyy-MM-dd'T'HH:mm:ss.SSS'Z'").parse(created)
        return SimpleDateFormat("yyyy-MM-dd HH:mm").format(date)
    }

    fun getCreationDate(): String? {

        val sdf = SimpleDateFormat("yyyy-MM-dd HH")

        val myFormat = SimpleDateFormat("yyyy-MM-dd'T'HH:mm:ss.SSS'Z'")

        sdf.setTimeZone(TimeZone.getTimeZone("Africa/Cairo"))

        myFormat.timeZone = TimeZone.getTimeZone("CAT")

        val dateObj = myFormat.parse(created)

        val dateString = sdf.format(dateObj)

        return dateString
    }

    fun getDateDif(): String? {
        val sdf = SimpleDateFormat("yyyy-MM-dd'T'HH:mm:ss.SSS'Z'", Locale("en"))
        val myFormat = SimpleDateFormat("yyyy-MM-dd'T'HH:mm:ss.SSS'Z'", Locale("en"))
        myFormat.timeZone = TimeZone.getTimeZone("CAT")
        val dateObj = myFormat.parse(created)
        val dateString = sdf.format(dateObj)
        return dateString
    }

    fun getCreationMinute(date : String): String? {
        val sdf = SimpleDateFormat("mm")
        val myFormat = SimpleDateFormat("yyyy-MM-dd'T'HH:mm")
        val dateObj = myFormat.parse(date)
        val timestamp = dateObj.time.toString()
        val dateString = sdf.format(Date(Long.parseLong(timestamp)))

        return dateString


    }
}
