package com.satafood.core.mapper.homepage

import com.satafood.core.entities.mainpage.*
import com.satafood.core.entities.restaurantslist.BranchesModelListItem

data class homeUseCase(var homePageData: HomePageModel? = null) {
    var percentageForVendor: List<PercentageForVendorsUseCase>? = null
    var freedeliverydata: List<FreeDeliveryDataUseCase>? = null
    var nearestbranche: List<NearestBrancheUseCase>? = null
    var mostsellitems: List<MostSellItemUseCase>? = null
    var mostOrderedBranch: List<MostOrderedBranchUseCase>? = null
    var DiscountedItem: List<DiscountItemUseCase>? = null
    var lastoffers: List<OffersUseCase>? = null
    var mainData: MainTitlesUseCase? = null
    var notificationCount: List<NotificationCountUseCase>? = null
    var areanotificatons: List<NotificationCountUseCase>? = null



    init {

        mainData = MainTitlesUseCase(homePageData)
        percentageForVendor = homePageData!!.GetPercentageForVendors!!.data!!.map { percentage -> PercentageForVendorsUseCase(percentage) }
        freedeliverydata= homePageData!!.GetFreeDliveryBranches!!.data!!.map { freedelivery->FreeDeliveryDataUseCase(freedelivery)  }
        lastoffers= homePageData!!.lastoffers!!.data!!.map { lastoffer->OffersUseCase(lastoffer)  }
        mostsellitems= homePageData!!.MostSellItems!!.data!!.map { mostsellitem->MostSellItemUseCase(mostsellitem)  }
        DiscountedItem= homePageData!!.GetDiscountedItem!!.data!!.map { discountSellitem-> DiscountItemUseCase(discountSellitem)  }
        nearestbranche = homePageData?.GetNearestBranche?.data!!.map { nearestbranch -> NearestBrancheUseCase(nearestbranch)  }
        mostOrderedBranch = homePageData?.getMostOrderedBranch?.data?.map{ mostOrderedBranch -> MostOrderedBranchUseCase(mostOrderedBranch)  }
        notificationCount = homePageData?.notificationCount?.map {  count -> NotificationCountUseCase(count)}
        areanotificatons = homePageData?.areanotificatons?.map {  count -> NotificationCountUseCase(count)}

    }
}
class MainTitlesUseCase(var data: HomePageModel?) {
    var freeDeliveryTitle = data!!.GetFreeDliveryBranches
    var nearestBrancheTitle = data!!.GetNearestBranche
    var percentageForVendorsTitle = data!!.GetPercentageForVendors
    var mostSellItemsTitle = data!!.MostSellItems
    var mostOrderedBranchTitle = data!!.getMostOrderedBranch
    var lastoffersTitle = data!!.lastoffers
     var discountTitle = data!!.GetDiscountedItem

    init {
//        if (data!!.name == "مطاعم") {
//            nameColor = "#fffff"
//        } else {
//            nameColor = "black"
//        }
    }

}

class PercentageForVendorsUseCase(var data: PercentageForVendorsData?) {
    var restaurant = data!!.restaurants
    var id = restaurant!!.RestauranthId
    var logo = restaurant!!.logo
    var cover = restaurant!!.cover
    var name = restaurant!!.name
    var cuisines = restaurant!!.cuisines
    var restaurantState = restaurant!!.IsOpen

    init {
//        if (data!!.name == "مطاعم") {
//            nameColor = "#fffff"
//        } else {
//            nameColor = "black"
//        }
    }

}

class OffersUseCase(var data: LastoffersData?) {
    var id = data!!.menu_categories_items_id
    var name = data!!.name
    var description = data!!.description
    var cover = data!!.cover
    var logo = data!!.logo
    var price = data!!.price
    var restaurantState = data!!.IsOpen
    var cuisines = data!!.cuisines

}


class MostSellItemUseCase(var data: MostSellItemsData?) {
    var itemAmount = data!!.itemamount
    var itemTotal = data!!.itemtotal
    var menuCategoriesItems = data!!.menu_categories_items
    var descriptions = data!!.description
    var id = menuCategoriesItems!!.id
    var name = menuCategoriesItems!!.name
    var name_en = menuCategoriesItems!!.name_en
    var photo = menuCategoriesItems!!.photo
    var price = data!!.price
    var discount = data!!.discount

}

class DiscountItemUseCase(var data: MostSellItemsData?) {
    var itemAmount = data!!.itemamount
    var itemTotal = data!!.itemtotal
    var descriptions = data!!.description
    var id = data!!.id
    var name = data!!.name
    var name_en = data!!.name_en
    var photo = data!!.photo
    var price = data!!.price
    var discount = data!!.discount}

class FreeDeliveryDataUseCase(var data: FreeDliveryBranchesData) {
    var restaurantId = data.RestauranthId
    var restaurantLogo = data.logo
    var restaurantName = data.name
    var deliveryCost = data.delivery_cost

}

class NearestBrancheUseCase(var data: NearestBrancheData) {
    var id = data.RestauranthId
    var restaurantLogo = data.logo
    var restaurantName = data.name
}

class NotificationCountUseCase(var data: NotificationCount) {
    var count = data.count
}




class MostOrderedBranchUseCase(var data: MostOrderedBranch?) {
    var branches = data?.branches
    var restaurant = branches?.restaurant
    var id = branches?.restaurant?.RestauranthId
    var logo = branches?.restaurant?.logo
    var cuisines = branches?.restaurant?.cuisines
    var cover = branches?.restaurant?.cover
    var area_id = data?.area_id
    var name = branches?.restaurant?.name
    var restaurantState = data?.branches?.restaurant?.IsOpen
    var rate = branches?.restaurant?.rate

}
