package com.satafood.core.mapper.restaurantdetails

import com.satafood.core.entities.restaurantdetails.MenuCategoriesItem
import com.satafood.core.entities.restaurantdetails.MenuCategory
import com.satafood.core.entities.restaurantdetails.StoreDetailsModel
import com.satafood.core.entities.restaurantdetails.RestuarantsDetails

data class StoreDetailsMapper(var maindata: StoreDetailsModel? = null) {
    var details: RestuarantsDetailsUseCase? = null
    var menuCategoryMapper: MenuCategoryMapper? = null


    init {
        details =
            maindata!!.restaurantDetails?.map { details -> RestuarantsDetailsUseCase(details) }
                ?.first()

        menuCategoryMapper =
            maindata!!.restaurantDetails?.map {it.menu_categories}?.map { details -> MenuCategoryMapper(details) }
                ?.first()


    }
}

class RestuarantsDetailsUseCase(var data: RestuarantsDetails?) {

    var deliveryTime = data?.delivery_time
    var timeDelivery = data?.time_delivery
    var logo = data?.logo
    var BranchId = data?.branch_id.toString()
    var minimum = data?.minimum
    var isTakway = data?.istakway

    var cuisines = data?.cuisines
    var rate:Float = if (data?.rate == null) 0.0F else data!!.rate!!
    var reviews = data?.rateCount

    var id = data?.RestauranthId

    var deliveryCost = if(data?.delivery_cost==null) 0.0 else data?.delivery_cost

    //    var deliveryCost = if (data?.delivery_cost==0) "توصيل مجاني" else data!!.delivery_cost.toString()
    var cuisineText = data?.cuisines?.map { it.name }.toString()

    var restaurantState = data?.IsOpen
    var restaurantName = data?.name
    var offerDescription = data?.offerDescription


}

class MenuCategoryMapper(var data: List<MenuCategory>?) {
    var menuCategoryItems  = data?.map { it.menu_categories_items } ?:  ArrayList<MenuCategoriesItem>()
}



fun FilterItemsListByCategory(CategoryId: Int, brancharray: List<MenuCategory>) =
    brancharray.filter { data -> data.id == CategoryId }.first()

fun SearchBranchesByname(restaurantName: String, brancharray: List<MenuCategory>) =
    runCatching {

    brancharray.map { data ->
        data.menu_categories_items!!.filter {
            it.name_en!!.contains(restaurantName) || it.name!!.contains(restaurantName)
        }
    }.first() }.getOrElse { throw it }


fun PlusCartItem(Item: MenuCategoriesItem, brancharray: List<MenuCategoriesItem>) =
    brancharray!!.find { data -> data.id == Item.id }!!.copy(quintity = Item.quintity!! + 1,
        total = Item.price!! * (Item.quintity + 1).toFloat())

fun MinusCartItem(Item: MenuCategoriesItem, brancharray: List<MenuCategoriesItem>) =
    brancharray!!.find { data -> data.id == Item.id }!!.copy(quintity = Item.quintity!! - 1,
        total = Item.price!! * (Item.quintity!! - 1).toFloat())