package com.satafood.core.mapper.restaurantslist

import android.content.Context
import com.satafood.core.entities.restaurantslist.BranchesModelListItem

class brancheslistusecase(
    var BranchesUseCaseData: List<BranchesModelListItem>? = null,
    var FiltredData: List<BranchesDataUseCase>? = null
) {

    var branchesList:List<BranchesDataUseCase>? = FiltredData 


    init {
        if (BranchesUseCaseData != null)
            branchesList =
                BranchesUseCaseData?.map { branchesList -> BranchesDataUseCase(branchesList) } as ArrayList<BranchesDataUseCase>?

    }
}


//اول حرف لازم يبقي capital
class BranchesDataUseCase(var data: BranchesModelListItem) {
    val context: Context? = null
    var id = data.RestauranthId
    var CuisinesList = data.cuisines
    var name = data.name
    var photo = data.Rescover ?: data.cover
    var logo = data.logo
    var area_id = data.area_id

    var RestaurantsName = data.name
    var deliveryTime = data.delivery_time
    var deliveryCost = if(data.delivery_cost==0) null else data.delivery_cost
    var rate = data.rate

    var description = data.offerDescription

    var isOpen = ""
    var restaurantState = data.IsOpen

    init {
        if (data.IsOpen == "true") {
                isOpen = "(مفتوح)"
        }
        else {
            isOpen = "(مغلق)"

        }



    }

}

fun FilterBranchesListByCuisines(cuisinesId: Int, brancharray: brancheslistusecase) =
    brancharray.BranchesUseCaseData!!.filter { data ->
        data.cuisines?.filter { it.id == cuisinesId }?.isNotEmpty() ?: false
    }

fun sortBranchesByName(branch: ArrayList<BranchesDataUseCase>?) =
    branch!!.sortedBy { it.name }

fun sortBranchesByDeliveryTime(branch: ArrayList<BranchesDataUseCase>?) =
    branch!!.sortedBy { it.deliveryTime }

fun sortBranchesByRate(branch: ArrayList<BranchesDataUseCase>?) =
    branch!!.sortedByDescending { it.rate }

fun sortBranchesByDeliveryCost(branch: ArrayList<BranchesDataUseCase>?) =
    branch!!.sortedBy { it.deliveryCost }

fun SearchBranchesByname(restaurantName: String, brancharray: ArrayList<BranchesDataUseCase>) =
    brancharray.filter { data ->
        data.name!!.contains(restaurantName)
    }

fun filterTopRatedVendors(brancharray: ArrayList<BranchesDataUseCase>?): List<BranchesDataUseCase> {
    val filter = brancharray!!.filter { data ->
        (data.rate ?: 0.0) == 4.0
    }
    return filter
}

fun filterFreeDeliveryVendors(brancharray: ArrayList<BranchesDataUseCase>?) =
    brancharray!!.filter { data ->
        data.deliveryCost == null
    }

fun filterOpenedVendors(brancharray: ArrayList<BranchesDataUseCase>?) =
    brancharray!!.filter { data ->
        data.isOpen.contains("(مفتوح)")
    }






