package com.satafood.core.mapper.search_model_mapper

import android.content.Context
import android.content.SharedPreferences
import com.satafood.core.entities.homepage.*
import com.satafood.core.entities.search_model.ItemResult
import com.satafood.core.entities.search_model.SearchModel
import com.satafood.core.entities.search_model.VendorsResult
import com.satafood.core.mapper.homepage.MostSellItemUseCase

data class SearchModelMapper(var data: SearchModel? = null) {

    var itemsModel:List<ItemResultMapper>? = null
    var storesModel:List<StoresResultMapper>? = null

    init {
        itemsModel = data!!.ItemResult.map { items -> ItemResultMapper(items) }
        storesModel = data!!.VendorsResult.map { items -> StoresResultMapper(items) }
    }

}

class ItemResultMapper(var data: ItemResult?) {

   var id = data!!.id
   var name = data!!.name
   var price = data!!.price
   var photo = data!!.photo
   var descriptions = data!!.descriptions


}

class StoresResultMapper(var data: VendorsResult?) {
   var id = data!!.RestauranthId
   var CuisinesList = data!!.cuisines
   var state = data!!.IsOpen
   var name = data!!.name
   var deliveryCost = data!!.delivery_cost
   var deliveryTime = data!!.delivery_time
   var logo = data!!.logo
   var cover = data!!.cover
   var rate = data!!.rate
   var descriptions = data!!.description


}
